"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeCommand = exports.REGISTER_INJECTION = exports.INJECTION_POINT_ASYNC = exports.EnableInjection = exports.arrayHasDuplicates = exports.AssertEnumHasFieldValue = exports.assertWithContext = exports.assert = exports.replaceElementOnWindow = exports.removeElementFromWindow = exports.RemoveProtectedCharactersFromString = exports.isStringFreeOfProtectedCharacters = exports.ProtectedCharacters = exports.SortObjectsByField = exports.DragItemTypes = exports.GenerateUniqueName = exports.timedMonitorPromise = exports.timedLoggerPromise = exports.getRangeWithIterative = exports.getRange = exports.CreateErrorWithCode = exports.GetDateObjectSafe = exports.IDP_URL = exports.AWS_REGION = exports.IDENTITY_POOL_ID = exports.APP_CLIENT_ID = exports.USER_POOL_ID = exports.getHashParam = exports.getQueryParam = exports.isProd = exports.isSsoEnvironment = exports.isDemoEnvironment = exports.measurePromise = exports.measureSeconds = exports.isEquivalent = exports.RuntypeFromEnum = exports.getEnumSafe = exports.CreateUniqueID = exports.CreateDeepClone = exports.getValueSafe = exports.setValue = exports.getValue = exports.checkKeys = exports.max = exports.START_RUN_URL = exports.DeleteFirebaseInstance = exports.IsCloudScheduler = exports.isDevelopment = exports.isCommandLine = exports.ThrowErrorAsPromise = void 0;
exports.CleanupUndefinedValuesFromObject = exports.GlobalModalResourceLockThunk = exports.CheckWebLockResourceInUse = exports.RunFunctionWithWebLockFrontEnd = exports.CompareAndCreateSetsFromArrays = exports.objectKeyIntersection = exports.IButtonState = exports.BatchUpdateFirestoreDoc = exports.BatchSetMergeFirestoreDoc = exports.BatchSetFirestoreDoc = exports.BatchDeleteFirestoreDoc = exports.FirestoreBatchBarrel = exports.Barrel = exports.GenerateRandomString = void 0;
const _ = __importStar(require("lodash"));
const Logging = __importStar(require("./Logging"));
const Firebase = __importStar(require("./Firebase"));
const R = __importStar(require("runtypes"));
const randomstring = __importStar(require("randomstring"));
const { exec } = require("child_process");
const ThrowErrorAsPromise = (error) => {
    return new Promise((resolve, reject) => {
        reject(error);
    });
};
exports.ThrowErrorAsPromise = ThrowErrorAsPromise;
const isCommandLine = () => {
    return typeof window == "undefined";
};
exports.isCommandLine = isCommandLine;
/*
 * isDevelopment is only used for front-end calls to determine the URL
 * in command line use - just set it to the prod URL but it shouldn't be used anyways
 */
const isDevelopment = () => {
    const myWindow = window;
    return (myWindow.location.hostname == 'localhost');
};
exports.isDevelopment = isDevelopment;
const IsCloudScheduler = () => {
    const creds = process.env.GOOGLE_APPLICATION_CREDENTIALS;
    if (creds !== undefined) {
        return true;
    }
    return false;
};
exports.IsCloudScheduler = IsCloudScheduler;
const RunnerBackendLogger = Logging.GetLogger(Logging.LoggingArea.RunnerBackend);
const CommonLogger = Logging.GetLogger(Logging.LoggingArea.Common);
const DeleteFirebaseInstance = (firebase) => {
    if ((0, exports.IsCloudScheduler)()) {
        return Promise.resolve();
    }
    return firebase.delete().catch(error => {
        RunnerBackendLogger.error(`Error deleting firebase instance: ${error}`);
    });
};
exports.DeleteFirebaseInstance = DeleteFirebaseInstance;
exports.START_RUN_URL = ((0, exports.isCommandLine)()) || (0, exports.isDevelopment)() ? process.env.SCHEDULER_ADDRESS || "http://localhost:8080" : window.REACT_APP_GIT_PROXY_URL;
// export const START_RUN_URL = (isCommandLine() || isDevelopment()) ? "http://localhost:8080": (window as any).REACT_APP_GIT_PROXY_URL
const max = (a, initialValue) => {
    return a.reduce((m, x) => parseInt(m) > parseInt(x) ? parseInt(m) : parseInt(x), initialValue);
};
exports.max = max;
function checkKeys(obj, keyPath) {
    return _.has(obj, keyPath);
}
exports.checkKeys = checkKeys;
function getValue(obj, keyPath) {
    return _.get(obj, keyPath);
}
exports.getValue = getValue;
function setValue(obj, keyPath, value) {
    return _.set(obj, keyPath, value);
}
exports.setValue = setValue;
function getValueSafe(obj, keyPath, ifFalseReturn) {
    let result = checkKeys(obj, keyPath);
    if (!result) {
        return ifFalseReturn;
    }
    else {
        return getValue(obj, keyPath);
    }
}
exports.getValueSafe = getValueSafe;
/**
 * a wrapper for lodash's cloneDeep functionality.
 *
 * @param value any type of value
 * @returns a deep clone of that value
 */
const CreateDeepClone = (value) => {
    return _.cloneDeep(value);
};
exports.CreateDeepClone = CreateDeepClone;
const CreateUniqueID = (prefix) => {
    return _.uniqueId(prefix);
};
exports.CreateUniqueID = CreateUniqueID;
function getEnumSafe(enumObj, enumValue, defaultValue) {
    if (!enumObj || !enumValue) {
        return defaultValue;
    }
    const found = Object.values(enumObj).find(v => enumValue == v);
    if (!found) {
        return defaultValue;
    }
    else {
        return found;
    }
}
exports.getEnumSafe = getEnumSafe;
/**
 * Snippet taken from user marlonjan at https://github.com/pelotom/runtypes/issues/66. Turns an enum into a Runtype object
 * @param theEnum just the name of the enum
 * @returns a runtype matching given enum
 */
const RuntypeFromEnum = (theEnum) => {
    const values = Object.values(theEnum);
    const isEnumValue = (input) => values.includes(input);
    const errorMessage = (input) => `Failed constraint check. Expected one of ${JSON.stringify(values)}, but received ${JSON.stringify(input)}`;
    return R.Unknown.withConstraint((object) => isEnumValue(object) || errorMessage(object));
};
exports.RuntypeFromEnum = RuntypeFromEnum;
const isEquivalent = (a, b) => {
    // Create arrays of property names
    var aProps = Object.getOwnPropertyNames(a);
    var bProps = Object.getOwnPropertyNames(b);
    /*
     * If number of properties is different,
     * objects are not equivalent
     */
    if (aProps.length != bProps.length) {
        return false;
    }
    for (var i = 0; i < aProps.length; i++) {
        var propName = aProps[i];
        /*
         * If values of same property are not equal,
         * objects are not equivalent
         */
        if (a[propName] !== b[propName]) {
            return false;
        }
    }
    /*
     * If we made it this far, objects
     * are considered equivalent
     */
    return true;
};
exports.isEquivalent = isEquivalent;
const measureSeconds = (startISOString, endISOString) => {
    const seconds = new Date(endISOString).getTime() - new Date(startISOString).getTime();
    return seconds;
};
exports.measureSeconds = measureSeconds;
const measurePromise = (fn) => {
    const start = new Date().toISOString();
    let onPromiseDone = (passThroughData) => {
        const end = new Date().toISOString();
        const performanceTime = (0, exports.measureSeconds)(start, end);
        const result = {
            performanceTime: performanceTime,
            passThroughData: passThroughData
        };
        return result;
    };
    return fn().then(onPromiseDone, onPromiseDone);
};
exports.measurePromise = measurePromise;
const isDemoEnvironment = () => {
    return (0, exports.getQueryParam)("env") == 'demo';
};
exports.isDemoEnvironment = isDemoEnvironment;
const isSsoEnvironment = () => {
    return (!!(0, exports.getHashParam)("id_token"));
};
exports.isSsoEnvironment = isSsoEnvironment;
const isProd = () => {
    return window.location.href.includes("editor.structure.rest");
};
exports.isProd = isProd;
const getQueryParam = (key) => {
    const url_string = window.location.href;
    const url = new URL(url_string);
    const env = url.searchParams.get(key);
    return env;
};
exports.getQueryParam = getQueryParam;
const getHashParam = (key) => {
    const hash_string = window.location.hash.substr(1);
    ;
    const hash_arr = hash_string.split('&');
    let hash_dictionary = {};
    hash_arr.forEach((str) => {
        const [found_key, found_value] = str.split("=");
        hash_dictionary[found_key] = found_value;
    });
    return hash_dictionary[key];
};
exports.getHashParam = getHashParam;
exports.USER_POOL_ID = 'us-west-2_c4Lg8pNfQ';
exports.APP_CLIENT_ID = 'mjn020f01m2uvvg38ujrt8gts';
exports.IDENTITY_POOL_ID = 'us-west-2:da18afd3-bfb8-4b1a-876a-6bbe7ec60669';
exports.AWS_REGION = 'us-west-2';
exports.IDP_URL = "cognito-idp." + exports.AWS_REGION + ".amazonaws.com/";
/**
 *
 * @param date possibly a firestore formatted date or a regular date object
 * @returns Javascript Date Object
 */
const GetDateObjectSafe = (date) => {
    //firestore dates have a toDate function, if it exists, return it
    if (typeof (date.toDate) === 'function') {
        return date.toDate();
    }
    else {
        return date;
    }
};
exports.GetDateObjectSafe = GetDateObjectSafe;
const CreateErrorWithCode = (statusCode, errorString, errorDetail) => {
    const error = {
        statusCode,
        error: {
            errorString,
            errorDetail
        },
        toString: () => {
            return `${errorString} DETAIL:${errorDetail}`;
        }
    };
    return error;
};
exports.CreateErrorWithCode = CreateErrorWithCode;
const getRange = (maxVal, rangeWidth) => {
    return {
        upper: maxVal,
        lower: maxVal - rangeWidth
    };
};
exports.getRange = getRange;
const getRangeWithIterative = (maxVal, rangeWidth, iterative) => {
    const regularRange = (0, exports.getRange)(maxVal, rangeWidth);
    const iterativeAmount = rangeWidth * iterative;
    return {
        upper: regularRange.upper - iterativeAmount,
        lower: regularRange.lower - iterativeAmount
    };
};
exports.getRangeWithIterative = getRangeWithIterative;
const timedLoggerPromise = (detailString, logContext, loggingArea, p) => {
    // default to Date.now() since performance object is only accessible in the browser
    let startTime = Date.now();
    if (!(0, exports.isCommandLine)()) {
        startTime = performance.now();
    }
    return p.finally(() => {
        let endTime = Date.now();
        if (!(0, exports.isCommandLine)()) {
            endTime = performance.now();
        }
        const elapsedMS = endTime - startTime;
        const logger = Logging.GetLogger(loggingArea);
        logger.infoContext(logContext, `completed, elapsedMS:${elapsedMS} detail:${detailString}`);
    });
};
exports.timedLoggerPromise = timedLoggerPromise;
// Can throw an EMERG statement when promise exceeds the designated timeLimitMS
const timedMonitorPromise = (timeLimitMS, promiseLocation, logContext, loggingArea, promise) => {
    // default to Date.now() since performance object is only accessible in the browser
    let startTime = Date.now();
    if (!(0, exports.isCommandLine)()) {
        startTime = performance.now();
    }
    return promise.finally(() => {
        let endTime = Date.now();
        if (!(0, exports.isCommandLine)()) {
            endTime = performance.now();
        }
        const elapsedMS = endTime - startTime;
        const logger = Logging.GetLogger(loggingArea);
        if (elapsedMS > timeLimitMS) {
            logger.emergContext(logContext, `Promise in ${promiseLocation} exceeded ${timeLimitMS} milliseconds.
				Elapsed Milliseconds: ${elapsedMS}`);
        }
    });
};
exports.timedMonitorPromise = timedMonitorPromise;
const GenerateUniqueName = (baseName, names) => {
    let counter = 1;
    const nameSet = new Set([...names]);
    //baseCase, first time the name is being used
    if (!nameSet.has(baseName))
        return baseName;
    //otherwise, iterate until you find a unique value
    while (nameSet.has(baseName + counter)) {
        counter++;
    }
    return baseName + counter;
};
exports.GenerateUniqueName = GenerateUniqueName;
var DragItemTypes;
(function (DragItemTypes) {
    DragItemTypes["AG_Tree_Node"] = "ag-tree-node";
    DragItemTypes["AG_Tree_Subgraph"] = "ag-tree-subgraph";
    DragItemTypes["AG_SQL_Step_Menu_Column"] = "ag-SQL-step-menu-column";
    DragItemTypes["AG_Column_Viewer_Column"] = "ag-column-viewer-column";
    DragItemTypes["Step_Menu_Tab"] = "step-menu-tab";
    DragItemTypes["Node_Test"] = "node-test";
    DragItemTypes["Tabular_Config"] = "tabular-config";
})(DragItemTypes = exports.DragItemTypes || (exports.DragItemTypes = {}));
const SortObjectsByField = (stepRowArray, field) => {
    return stepRowArray.filter((obj) => {
        return obj[field] !== undefined || obj[field] !== null;
    }).sort((obj1, obj2) => {
        return obj1[field] < obj2[field] ? -1 : obj1[field] > obj2[field] ? 1 : 0;
    });
};
exports.SortObjectsByField = SortObjectsByField;
//Characters that shouldn't be included in a filename, they cause issues. 
//Therefore, protect nodes et. all from having these characters typed in their names
// export const ProtectedCharacters: Set<string> = new Set(['#', '/', "\\", '<', '>', '%', '&', '{', '}', '*', '?', ' ', '$', '!', "'", `"`, ':', '@', '+', '`', '|', '='])
exports.ProtectedCharacters = new Set([" ", "(", ")", "#", "%", "`", "'", '"', ",", ".", "|", "+", "+", "!", "?", "{", "}", "/", "\\"]);
/**
 * A helper function that checks if a string contains any protected characters which make it invalid to use as an entity name
 * @param name
 * returns a boolean indicating if the string is a valid entity name or not
 */
const isStringFreeOfProtectedCharacters = (name) => {
    const nameArray = name.split('');
    //if any of the characters is protected, it is invalid
    return nameArray.every(character => !exports.ProtectedCharacters.has(character));
};
exports.isStringFreeOfProtectedCharacters = isStringFreeOfProtectedCharacters;
const RemoveProtectedCharactersFromString = (string) => {
    const stringArray = string.split('');
    const filteredStringArray = stringArray.filter(char => !exports.ProtectedCharacters.has(char));
    return filteredStringArray.join('');
};
exports.RemoveProtectedCharactersFromString = RemoveProtectedCharactersFromString;
/**
 * Function for removing an element from the window and replaces it with a dummy function
 * @param keyPath
 * @returns function to call when you want to restore the original value on the window object
 */
const removeElementFromWindow = (keyPath) => {
    return (0, exports.replaceElementOnWindow)(keyPath, () => { });
};
exports.removeElementFromWindow = removeElementFromWindow;
/**
 *
 * @param keyPath array of strings
 * @param value
 * @returns callback function that replaces the original value back on the window object
 */
const replaceElementOnWindow = (keyPath, value) => {
    let consoleElement;
    if (!(0, exports.isCommandLine)()) {
        consoleElement = getValueSafe(window, keyPath, value);
        setValue(window, keyPath, value);
    }
    return () => {
        if (!(0, exports.isCommandLine)()) {
            setValue(window, keyPath, consoleElement);
        }
    };
};
exports.replaceElementOnWindow = replaceElementOnWindow;
/**
 * takes an assertion - if the assertion is falsy, logs an emergency in data dog with an orgID and
 * stops the application by throwing an error
 *
 * @param loggingArea - specifies what area the emerg log will be seen in
 * @param assertion - boolean/expression that evaluates to a boolean. if false, emerg is logged and error is thrown
 * @param message - optional message to include with the error if it's thrown
 */
const assert = (loggingArea, assertion, message) => {
    return (0, exports.assertWithContext)(loggingArea, assertion, {}, message);
};
exports.assert = assert;
const assertWithContext = (loggingArea, assertion, loggingContext, message) => {
    const logger = Logging.GetLogger(loggingArea);
    if (!assertion) {
        const errMessage = message ?
            `orgID: ${exports.orgIDToLog}, ${message}` :
            `orgID: ${exports.orgIDToLog}, assertion failed`;
        try {
            throw new Error(errMessage);
        }
        catch (ex) {
            logger.emergContext(loggingContext, errMessage);
        }
    }
};
exports.assertWithContext = assertWithContext;
/**
 * @param inputEnum
 * @param fieldValue note that this is not the field, but the value of the field
 * @param enumName a string to let the logger know what enum is being checked
 * @returns void
 */
const AssertEnumHasFieldValue = (inputEnum, fieldValue, enumName) => {
    return (0, exports.assert)(Logging.LoggingArea.Common, Object.values(inputEnum).includes(fieldValue), `expected field missing from enum ${enumName}! (AssertEnumHasField)`);
};
exports.AssertEnumHasFieldValue = AssertEnumHasFieldValue;
const arrayHasDuplicates = (array) => {
    return array.length !== new Set(array).size;
};
exports.arrayHasDuplicates = arrayHasDuplicates;
const EnableInjection = (injectionPoint, shouldInject = null) => {
    let resolveReturn;
    let rejectReturn;
    CommonLogger.info("enable injection point:", injectionPoint.injectionName);
    injectionPoint.shouldInject = shouldInject;
    injectionPoint.injectionPromise = new Promise((resolve, reject) => {
        resolveReturn = resolve;
        rejectReturn = reject;
    });
    return {
        release: () => {
            CommonLogger.info("releasing injection", injectionPoint.injectionName);
            resolveReturn();
            injectionPoint.shouldInject = null;
        },
        releaseWithError: (err) => {
            CommonLogger.info("releasing injection WITH error", injectionPoint.injectionName, err);
            rejectReturn(err);
            injectionPoint.shouldInject = null;
        }
    };
};
exports.EnableInjection = EnableInjection;
const INJECTION_POINT_ASYNC = (injectionPoint, context, ...args) => {
    if (!injectionPoint.injectionPromise) {
        return Promise.resolve(args);
    }
    else {
        if (injectionPoint.shouldInject && !injectionPoint.shouldInject(context)) {
            return Promise.resolve(args);
        }
        CommonLogger.info("going into waiting :", injectionPoint.injectionName);
        return injectionPoint.injectionPromise.then(() => {
            CommonLogger.info("completed injection:", injectionPoint.injectionName);
            return args;
        });
    }
};
exports.INJECTION_POINT_ASYNC = INJECTION_POINT_ASYNC;
const REGISTER_INJECTION = (injectionName) => {
    return {
        injectionName,
        injectionPromise: null,
        shouldInject: null
    };
};
exports.REGISTER_INJECTION = REGISTER_INJECTION;
const executeCommand = (command) => {
    return new Promise((resolve, reject) => {
        exec(command, {
            env: {
                GOOGLE_APPLICATION_CREDENTIALS: process.env.GOOGLE_APPLICATION_CREDENTIALS,
                PATH: process.env.PATH,
                RUNTIME_ENVIRONMENT: process.env.RUNTIME_ENVIRONMENT
            }
        }, (error, stdout, stderr) => {
            if (error) {
                CommonLogger.error("error on execute command", error);
                reject([stdout, stderr]);
            }
            else {
                resolve([stdout, stderr]);
            }
        });
    });
};
exports.executeCommand = executeCommand;
/**
 * uses the randomstring npm library
 * @returns a random string of length 15 made from alphanumeric characters
 */
const GenerateRandomString = () => {
    return randomstring.generate({
        length: 15,
        charset: "alphanumeric"
    });
};
exports.GenerateRandomString = GenerateRandomString;
var ExecutionStatus;
(function (ExecutionStatus) {
    ExecutionStatus["waiting"] = "waiting";
    ExecutionStatus["executing"] = "executing";
    ExecutionStatus["done"] = "done";
})(ExecutionStatus || (ExecutionStatus = {}));
/**
 * Barrel runs N promises at a time in an array of requests
 * this basically gets an array of functions that generate a promise - and
 * manage sthe execution of them such only "concurrent" number of requests
 * are happening at a time.
 * it does this by keeping track of which requests are waiting, executing or done - kicking off a new request whenever one completes, until all of the requests are done
 * @param promiseGeneratorArray the promiseGeneratorArray is an array of functions that returns promises
 * @param concurrent  - number of parallel requests
 * @returns
 */
function Barrel(promiseGeneratorArray, concurrent) {
    CommonLogger.debug("Starting barrel", concurrent, promiseGeneratorArray.length);
    let executionTracker = Array(promiseGeneratorArray.length).fill(undefined).map(() => {
        return { status: ExecutionStatus.waiting };
    });
    let promiseResults = [];
    const getNOfStatus = (executionStatus, n) => {
        let result = [];
        let count = 0;
        executionTracker.forEach((e, index) => {
            if (e.status == executionStatus && count < n) {
                result.push(index);
                count = count + 1;
            }
        });
        return result;
    };
    return new Promise((resolve, reject) => {
        const exec = () => {
            CommonLogger.debug("in exec of barrel");
            const completedIndexesLength = getNOfStatus(ExecutionStatus.done, promiseGeneratorArray.length).length;
            if (completedIndexesLength == promiseGeneratorArray.length) {
                CommonLogger.debug("finished barrel", concurrent, promiseGeneratorArray.length);
                resolve(promiseResults);
            }
            else {
                const indexesRunning = getNOfStatus(ExecutionStatus.executing, concurrent);
                const numToLaunch = concurrent - indexesRunning.length;
                const indexesToLaunch = getNOfStatus(ExecutionStatus.waiting, numToLaunch);
                CommonLogger.debug("launching more of barrel", indexesRunning, numToLaunch, indexesToLaunch);
                (0, exports.assert)(Logging.LoggingArea.Common, numToLaunch > 0, "num to launch is always more than zero");
                (0, exports.assert)(Logging.LoggingArea.Common, indexesRunning.length || indexesToLaunch.length, "there should always be something to run");
                indexesToLaunch.forEach((indexToLaunch) => {
                    CommonLogger.debug("launch index of barrel", indexToLaunch);
                    executionTracker[indexToLaunch].status = ExecutionStatus.executing;
                    promiseResults[indexToLaunch] = promiseGeneratorArray[indexToLaunch]().then((result) => {
                        promiseResults[indexToLaunch] = result;
                        executionTracker[indexToLaunch].status = ExecutionStatus.done;
                        CommonLogger.debug("finished index of barrel", indexToLaunch, executionTracker);
                        exec();
                    }).catch((err) => {
                        CommonLogger.error("failed to complete barrel", err);
                        reject(err);
                    });
                });
            }
        };
        exec();
    });
}
exports.Barrel = Barrel;
/**
 * Creates batches from any source or combination of sources given an array of functions to add docs to a batch, then continue committing batches until all funcs in array are complete
 * @param arrayOfFuncs each function puts one doc object and one batch operation (set, update, delete) into the current batch
 * @param batchSize number of docs/actions to put in a batch before committing to FB, FB caps this at 500
 */
const FirestoreBatchBarrel = (arrayOfFuncs, batchSize) => {
    const totalBatchesToWrite = Math.ceil(arrayOfFuncs.length / batchSize);
    CommonLogger.debug("firestore batch barrel starting, expected batches:", totalBatchesToWrite, "; batch max size:", batchSize);
    const firestore = Firebase.getFirestore();
    const batchQueue = [];
    let batch;
    let completeBatches = 0; //batches finished committing
    let batchIsRunning = false;
    return new Promise((resolveBarrel, rejectBarrel) => {
        if (batchSize > 500) {
            CommonLogger.emerg("FirestoreBatchBarrel batchSize can not exceed 500");
            rejectBarrel("FirestoreBatchBarrel attempting to use batch size that exceeds maximum");
        }
        arrayOfFuncs.forEach((func, funcIndex, funcArr) => {
            const startBatchCommit = () => {
                if (batchIsRunning || !batchQueue[0]) {
                    return;
                }
                batchIsRunning = true;
                batchQueue[0].commit().then(() => {
                    batchIsRunning = false;
                    completeBatches++;
                    CommonLogger.debug("firestore barrel batch #", completeBatches, "complete");
                    if (completeBatches === totalBatchesToWrite) {
                        CommonLogger.info("FB batch barrel finished successfully.", arrayOfFuncs.length, "docs written in", completeBatches, "batches.");
                        resolveBarrel();
                    }
                    batchQueue.shift();
                    startBatchCommit();
                }).catch((err) => {
                    CommonLogger.error("firestore barrel batch #", completeBatches + 1, "failed with error:", err);
                    rejectBarrel(`Failure writing to Firebase at batch #${completeBatches + 1} out of ${totalBatchesToWrite} total batches expected; Error: ${err.toString()}`);
                });
            };
            // this starts a new empty batch at the very beginning of the array and at the next index AFTER sending the last full batch to the queue, BEFORE calling the func at this index
            if ((funcIndex === 0) || (funcIndex % batchSize === 0)) {
                batch = firestore.batch();
            }
            func(batch);
            /*
             * this sends a full batch to the queue AFTER calling func at this indexand kicks off commit if no commit is occurring. If batches are filled faster than committed,
             * the first call should be the only one that doesn't return immediately, but we call it each time in case a commit finishes before the next batch is added to queue.
             * Note: we have to do (funcIndex + 1) because indeces start at 0, i.e. indeces 0-49 covers 50 iterations
             */
            if (((funcIndex + 1) % batchSize === 0) || (funcIndex === funcArr.length - 1)) {
                batchQueue.push(batch);
                startBatchCommit();
            }
        });
    });
};
exports.FirestoreBatchBarrel = FirestoreBatchBarrel;
const BatchDeleteFirestoreDoc = (docRef) => {
    return (batch) => {
        batch.delete(docRef);
    };
};
exports.BatchDeleteFirestoreDoc = BatchDeleteFirestoreDoc;
const BatchSetFirestoreDoc = (docRef, value) => {
    return (batch) => {
        batch.set(docRef, value);
    };
};
exports.BatchSetFirestoreDoc = BatchSetFirestoreDoc;
const BatchSetMergeFirestoreDoc = (docRef, value) => {
    return (batch) => {
        batch.set(docRef, value, { merge: true });
    };
};
exports.BatchSetMergeFirestoreDoc = BatchSetMergeFirestoreDoc;
/**
 *
 * @param docRef
 * @param value Value should be a dictionary { keyToUpdate: value }
 * @returns
 */
const BatchUpdateFirestoreDoc = (docRef, value) => {
    return (batch) => {
        batch.update(docRef, value);
    };
};
exports.BatchUpdateFirestoreDoc = BatchUpdateFirestoreDoc;
var IButtonState;
(function (IButtonState) {
    IButtonState["initial"] = "initial";
    IButtonState["loading"] = "loading";
    IButtonState["success"] = "success";
    IButtonState["fail"] = "fail";
})(IButtonState = exports.IButtonState || (exports.IButtonState = {}));
//return the keys that intersect
//https://stackoverflow.com/questions/34392741/best-way-to-get-intersection-of-keys-of-two-objects
const objectKeyIntersection = (o1, o2) => {
    return Object.keys(o1).concat(Object.keys(o2)).sort().reduce(function (r, a, i, aa) {
        if (i && aa[i - 1] === a) {
            r.push(a);
        }
        return r;
    }, []);
};
exports.objectKeyIntersection = objectKeyIntersection;
/**
 * Used to compare two arrays and divide them into 3 arrays
 * based on what values are distinct or in-common between the input arrays
 * @param originalArray
 * @param newArray
 * @returns
 */
const CompareAndCreateSetsFromArrays = (originalArray, newArray) => {
    const firstOnly = originalArray.filter(originalArrayID => !newArray.some(newArrayID => originalArrayID === newArrayID));
    const secondOnly = newArray.filter(originalArrayID => !originalArray.some(newArrayID => originalArrayID === newArrayID));
    const inCommon = originalArray.filter(originalArrayID => newArray.some(newArrayID => originalArrayID === newArrayID));
    return { inCommon, firstOnly, secondOnly };
};
exports.CompareAndCreateSetsFromArrays = CompareAndCreateSetsFromArrays;
/**
 * Wrapper function for extracting usage of navigator weblocks api
 * @param resourceName
 * @param callbackFunction
 */
const RunFunctionWithWebLockFrontEnd = (resourceName, callbackFunction) => {
    return navigator.locks.request(resourceName, { ifAvailable: true }, lock => {
        return callbackFunction();
    });
};
exports.RunFunctionWithWebLockFrontEnd = RunFunctionWithWebLockFrontEnd;
const CheckWebLockResourceInUse = (resourceName) => {
    return (navigator.locks.query())
        .then((resourcesInformation) => {
        const resourceInUse = resourcesInformation.held.some(resource => resource.name === resourceName);
        return resourceInUse;
    });
};
exports.CheckWebLockResourceInUse = CheckWebLockResourceInUse;
const GlobalModalResourceLockThunk = (setupCallback) => {
    return ((dispatch, getState) => {
        setupCallback();
        return new Promise((resolve, reject) => {
            //set up polling that checks the state of the gloabl modal visibility
            const RecursiveStateChecker = () => {
                var _a, _b;
                const state = getState();
                const globalModalVisibility = !!((_b = (_a = state === null || state === void 0 ? void 0 : state.modal) === null || _a === void 0 ? void 0 : _a.globalModalState) === null || _b === void 0 ? void 0 : _b.visible);
                if (!globalModalVisibility) {
                    resolve();
                }
                else {
                    setTimeout(RecursiveStateChecker, 1000);
                }
            };
            setTimeout(RecursiveStateChecker, 1000);
        });
    });
};
exports.GlobalModalResourceLockThunk = GlobalModalResourceLockThunk;
const CleanupUndefinedValuesFromObject = (obj) => {
    Object.keys(obj).forEach(key => {
        if (obj[key] === undefined) {
            delete obj[key];
        }
        if (!!obj[key] && typeof obj[key] === "object") { //handles case where obj[key] === null
            (0, exports.CleanupUndefinedValuesFromObject)(obj[key]);
        }
    });
};
exports.CleanupUndefinedValuesFromObject = CleanupUndefinedValuesFromObject;
//# sourceMappingURL=Common.js.map