"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateServerStateCounter = exports.getServerState = exports.batchWriteServerJob = exports.putServerJob = exports.putServerState = exports.scanServerJob = exports.scanServerState = exports.listUnauthenticatedJob = exports.getUnauthenticatedClientState = exports.getClientState = exports.updateUserState = exports.queryJobResult = exports.getUserState = exports.addClientState = exports.listClientJob = exports.addClientJob = exports.RequestType = exports.doServerDynamo = exports.getServerCredentials = exports.doSsoDynamo = exports.doUnauthenticatedDynamo = exports.getUserIdParam = exports.getDocClient = exports.getCognitoUser = exports.ClientType = exports.DYNAMO_ENDPOINT = exports.IDP_URL = exports.AWS_REGION = exports.IDENTITY_POOL_ID = exports.APP_CLIENT_ID = exports.USER_POOL_ID = void 0;
const AWSCognito = __importStar(require("amazon-cognito-identity-js"));
const AWSSdk = __importStar(require("aws-sdk"));
const Common = __importStar(require("./Common"));
exports.USER_POOL_ID = 'us-west-2_c4Lg8pNfQ';
exports.APP_CLIENT_ID = 'mjn020f01m2uvvg38ujrt8gts';
exports.IDENTITY_POOL_ID = 'us-west-2:da18afd3-bfb8-4b1a-876a-6bbe7ec60669';
exports.AWS_REGION = 'us-west-2';
exports.IDP_URL = "cognito-idp." + exports.AWS_REGION + ".amazonaws.com/";
exports.DYNAMO_ENDPOINT = 'dynamodb.us-west-2.amazonaws.com';
AWSSdk.config.update({
    dynamoDbCrc32: false
});
var ClientType;
(function (ClientType) {
    ClientType["server"] = "server";
    ClientType["client"] = "client";
    ClientType["commandLine"] = "commandLine";
    ClientType["demo"] = "demo";
    ClientType["sso"] = "sso";
})(ClientType = exports.ClientType || (exports.ClientType = {}));
const getCognitoUser = () => {
    const data = {
        UserPoolId: exports.USER_POOL_ID,
        ClientId: exports.APP_CLIENT_ID
    };
    let userPool = new AWSCognito.CognitoUserPool(data);
    return userPool.getCurrentUser();
};
exports.getCognitoUser = getCognitoUser;
const getDocClient = (clientType, cognitoUser, cb) => {
    const responseCB = (err, docClient) => {
        if (err) {
            console.error(err);
            cb(err, null);
        }
        else {
            cb(null, docClient);
        }
    };
    switch (clientType) {
        case ClientType.demo:
            if (cognitoUser) {
                doClientDynamo(cognitoUser, responseCB);
                return;
            }
            else {
                (0, exports.doUnauthenticatedDynamo)(responseCB);
                return;
            }
            break;
        case ClientType.sso:
            (0, exports.doSsoDynamo)(responseCB);
            return;
            break;
        case ClientType.server:
            (0, exports.getServerCredentials)().then((serverConfig) => {
                (0, exports.doServerDynamo)(serverConfig, responseCB);
            });
            return;
            break;
        case ClientType.client:
            doClientDynamo(cognitoUser, responseCB);
            return;
            break;
        default:
            console.assert(false);
    }
};
exports.getDocClient = getDocClient;
const getUserIdParam = (clientType, requestType, cb) => {
    if (clientType == ClientType.demo) {
        switch (requestType) {
            case RequestType.get:
                cb(null, "us-west-2:3b464cae-5553-4490-bf04-ac46a4d2512f");
                break;
            case RequestType.query:
                cb(null, "us-west-2:3b464cae-5553-4490-bf04-ac46a4d2512f");
                break;
            default:
                console.assert(false);
        }
    }
    else if (clientType == ClientType.client || clientType == ClientType.sso) {
        AWSSdk.config.credentials.get((err) => {
            if (err) {
                cb(err, null);
            }
            else {
                cb(null, AWSSdk.config.credentials.identityId);
            }
        });
    }
    else {
        console.assert(false);
    }
    return;
};
exports.getUserIdParam = getUserIdParam;
const doUnauthenticatedDynamo = (cb) => {
    AWSSdk.config.region = exports.AWS_REGION;
    AWSSdk.config.credentials = new AWSSdk.CognitoIdentityCredentials({
        IdentityPoolId: exports.IDENTITY_POOL_ID,
    });
    const cognitoidentity = new AWSSdk.CognitoIdentity();
    const params = {
        IdentityPoolId: exports.IDENTITY_POOL_ID
    };
    cognitoidentity.getId(params, function (err, data) {
        if (err) {
            cb(err, null);
            return;
        }
        else {
            var params2 = {
                IdentityId: data.IdentityId
            };
            cognitoidentity.getCredentialsForIdentity(params2, function (err2, data2) {
                if (err2) {
                    cb(err2, null);
                }
                else {
                    const DummyConfig = {
                        accessKeyId: data2.Credentials.AccessKeyId,
                        accessSecretKey: data2.Credentials.SecretKey,
                        sessionToken: data2.Credentials.SessionToken,
                        region: "us-west-2"
                    };
                    AWSSdk.config.update(DummyConfig);
                    const docClient = new AWSSdk.DynamoDB.DocumentClient({ region: AWSSdk.config.region });
                    cb(null, docClient);
                }
            });
        }
    });
};
exports.doUnauthenticatedDynamo = doUnauthenticatedDynamo;
const doSsoDynamo = (cb) => {
    const id_token = Common.getHashParam("id_token");
    const access_token = Common.getHashParam("access_token");
    AWSSdk.config.region = exports.AWS_REGION;
    AWSSdk.config.credentials = new AWSSdk.CognitoIdentityCredentials({
        IdentityPoolId: exports.IDENTITY_POOL_ID,
        Logins: {
            [exports.IDP_URL + exports.USER_POOL_ID]: id_token
        }
    });
    AWSSdk.config.credentials.get((err) => {
        if (err) {
            return cb(err, null);
        }
        const docClient = new AWSSdk.DynamoDB.DocumentClient({ region: AWSSdk.config.region }); //3
        return cb(null, docClient);
    });
    //  }
    //})
};
exports.doSsoDynamo = doSsoDynamo;
const getServerCredentials = () => {
    //console.log("process.env.NODE_ENV: ", process.env.NODE_ENV);
    return new Promise((resolve, reject) => {
        if (process.env.STRUCTURE_MODE == 'scheduler') {
            resolve(require('../config/aws-admin.js'));
        }
        else {
            reject('not running on protected server');
        }
    });
};
exports.getServerCredentials = getServerCredentials;
const doServerDynamo = (serverConfig, cb) => {
    AWSSdk.config.update({
        region: exports.AWS_REGION,
        //endpoint: DYNAMO_ENDPOINT,
        accessKeyId: serverConfig.accessKeyId,
        secretAccessKey: serverConfig.secretAccessKey
    });
    const docClient = new AWSSdk.DynamoDB.DocumentClient({ region: AWSSdk.config.region });
    return cb(null, docClient);
};
exports.doServerDynamo = doServerDynamo;
////END NEW SERVER ACCESS CODE
//ALL DB FUNCTIONS ARE BROKEN INTO THREE PARTS
//1) The CLIENT/SERVER CREDENTIAL STUFF : (e.g., doClientDynamo or doServerDynamo
//2) The actual parameters: (e.g., addJob, listJob, getUserState, etc... )
//3) The execution and error handling: (e.g. doDBRequest)
const doClientDynamo = (cognitoUser, cb) => {
    console.assert(cognitoUser);
    cognitoUser.getSession((err, session) => {
        if (err) {
            return cb(err, null);
        }
        AWSSdk.config.region = exports.AWS_REGION;
        AWSSdk.config.credentials = new AWSSdk.CognitoIdentityCredentials({
            IdentityPoolId: exports.IDENTITY_POOL_ID,
            Logins: {
                [exports.IDP_URL + exports.USER_POOL_ID]: session.getIdToken().getJwtToken()
            }
        });
        AWSSdk.config.credentials.get((err) => {
            if (err) {
                return cb(err, null);
            }
            const docClient = new AWSSdk.DynamoDB.DocumentClient({ region: AWSSdk.config.region }); //3
            return cb(null, docClient);
        });
    });
};
var RequestType;
(function (RequestType) {
    RequestType["get"] = "get";
    RequestType["put"] = "put";
    RequestType["query"] = "query";
    RequestType["scan"] = "scan";
    RequestType["batch"] = "batch";
    RequestType["update"] = "update";
})(RequestType = exports.RequestType || (exports.RequestType = {}));
const dbRequest = (requestType, dbClient, params, cb) => {
    const responseCB = (err, data) => {
        try {
            if (err) {
                console.error("error on dbRequest", err, "requestType", requestType);
                cb(err, null);
            }
            else {
                cb(null, data);
            }
        }
        catch (err) {
            console.error("uncaught error in callback: ", err);
            console.assert(false);
        }
    };
    switch (requestType) {
        case RequestType.get:
            dbClient.get(params, responseCB);
            break;
        case RequestType.put:
            dbClient.put(params, responseCB);
            break;
        case RequestType.query:
            dbClient.query(params, responseCB);
            break;
        case RequestType.scan:
            dbClient.scan(params, responseCB);
            break;
        case RequestType.update:
            dbClient.update(params, responseCB);
            break;
        case RequestType.batch:
            dbClient.batchWrite(params, responseCB);
            break;
        default:
            console.assert(false, "unknown requesttype", requestType);
    }
};
const addClientJob = (cognitoUser, inputData, cb) => {
    console.assert(cognitoUser);
    doClientDynamo(cognitoUser, (err, { docClient, id }) => {
        if (err) {
            return cb(err, null);
        }
        let params = {
            TableName: 'StructureRestJob',
            Item: { UserId: id, CreationDate: new Date().toISOString() }
        };
        dbRequest(RequestType.put, docClient, params, cb);
    });
};
exports.addClientJob = addClientJob;
const listClientJob = (cognitoUser, cb) => {
    console.assert(cognitoUser);
    doClientDynamo(cognitoUser, (err, { docClient, id }) => {
        if (err)
            return cb(err, null);
        let DateKey = new Date().toISOString();
        let params = {
            TableName: 'StructureRestJob',
            KeyConditionExpression: "UserId = :UserId  ",
            ExpressionAttributeValues: {
                ":UserId": id,
            },
            ScanIndexForward: false,
            ExclusiveStartKey: {
                UserId: id,
                CreationDate: DateKey
            },
            Limit: 5 //DataPerReq
        };
        dbRequest(RequestType.query, docClient, params, cb);
    });
};
exports.listClientJob = listClientJob;
const addClientState = (cognitoUser, inputData, cb) => {
    doClientDynamo(cognitoUser, (err, { docClient, id }) => {
        if (err)
            return cb(err, null);
        var DateKey = new Date().toISOString();
        var params = {
            TableName: 'StructureRestState',
            Item: {
                UserId: id,
                CreationDate: DateKey,
                UserState: inputData
            }
        };
        dbRequest(RequestType.put, docClient, params, cb);
    });
};
exports.addClientState = addClientState;
const getUserState = (docClient, targetUserId, cb) => {
    const params = {
        TableName: "StructureRestState",
        Key: {
            "UserId": targetUserId
        }
    };
    dbRequest(RequestType.get, docClient, params, cb);
};
exports.getUserState = getUserState;
const queryJobResult = (docClient, id, cb) => {
    let DateKey = new Date().toISOString();
    let params = {
        TableName: 'StructureRestJob',
        KeyConditionExpression: "UserId = :UserId  ",
        ExpressionAttributeValues: {
            ":UserId": id,
        },
        ScanIndexForward: false,
        ExclusiveStartKey: {
            UserId: id,
            CreationDate: DateKey
        },
        Limit: 5 //DataPerReq
    };
    dbRequest(RequestType.query, docClient, params, cb);
};
exports.queryJobResult = queryJobResult;
const updateUserState = (docClient, targetUserId, inputData, cb) => {
    const DateKey = new Date().toISOString();
    const params = {
        TableName: 'StructureRestState',
        Key: {
            UserId: targetUserId
        },
        UpdateExpression: "set UserState = :u, LastUpdate = :l",
        ExpressionAttributeValues: {
            ":u": inputData,
            ":l": DateKey
        },
        ReturnValues: "UPDATED_NEW"
    };
    dbRequest(RequestType.update, docClient, params, cb);
};
exports.updateUserState = updateUserState;
const getClientState = (cognitoUser, cb) => {
    console.assert(cognitoUser);
    doClientDynamo(cognitoUser, (err, { docClient, id }) => {
        if (err)
            return cb(err, null);
        var params = {
            TableName: "StructureRestState",
            Key: {
                "UserId": id
            }
        };
        dbRequest(RequestType.get, docClient, params, cb);
    });
};
exports.getClientState = getClientState;
const getUnauthenticatedClientState = (cb) => {
    // Set the region where your identity pool exists (us-east-1, eu-west-1)
    AWSSdk.config.region = 'us-west-2';
    // Configure the credentials provider to use your identity pool
    AWSSdk.config.credentials = new AWSSdk.CognitoIdentityCredentials({
        IdentityPoolId: 'us-west-2:da18afd3-bfb8-4b1a-876a-6bbe7ec60669',
    });
    var cognitoidentity = new AWSSdk.CognitoIdentity();
    var params = {
        IdentityPoolId: 'us-west-2:da18afd3-bfb8-4b1a-876a-6bbe7ec60669', /* required */
    };
    cognitoidentity.getId(params, function (err, data) {
        if (err)
            console.log(err, err.stack); // an error occurred
        else {
            //console.log(data);           // successful response
            if (data) {
                //console.log(data.IdentityId);
                var params2 = {
                    IdentityId: data.IdentityId // required
                    //CustomRoleArn: 'arn:aws:iam::109765664052:role/Cognito_StructureRestIPUnauth_Role',
                };
                cognitoidentity.getCredentialsForIdentity(params2, function (err2, data2) {
                    if (err2)
                        console.log(err2, err2.stack); // an error occurred
                    else { //console.log(data2);           // successful response
                        if (data2) {
                            const DummyConfig = {
                                accessKeyId: data2.Credentials.AccessKeyId,
                                accessSecretKey: data2.Credentials.SecretKey,
                                sessionToken: data2.Credentials.SessionToken,
                                region: "us-west-2"
                            };
                            AWSSdk.config.update(DummyConfig);
                            var params = {
                                TableName: "StructureRestState",
                                Key: {
                                    "UserId": "us-west-2:3b464cae-5553-4490-bf04-ac46a4d2512f"
                                }
                            };
                            var docClient = new AWSSdk.DynamoDB.DocumentClient({ region: AWSSdk.config.region });
                            docClient.get(params, function (err, data) {
                                //console.log("err"+err+"\ndata"+data);
                                if (err)
                                    return cb(err, null);
                                return cb(null, data);
                            });
                        }
                    }
                });
            }
        }
    });
};
exports.getUnauthenticatedClientState = getUnauthenticatedClientState;
const listUnauthenticatedJob = (cb) => {
    // Set the region where your identity pool exists (us-east-1, eu-west-1)
    AWSSdk.config.region = 'us-west-2';
    // Configure the credentials provider to use your identity pool
    AWSSdk.config.credentials = new AWSSdk.CognitoIdentityCredentials({
        IdentityPoolId: 'us-west-2:da18afd3-bfb8-4b1a-876a-6bbe7ec60669',
    });
    var cognitoidentity = new AWSSdk.CognitoIdentity();
    var params = {
        IdentityPoolId: 'us-west-2:da18afd3-bfb8-4b1a-876a-6bbe7ec60669', /* required */
    };
    cognitoidentity.getId(params, function (err, data) {
        if (err)
            console.log(err, err.stack); // an error occurred
        else {
            //console.log(data);           // successful response
            if (data) {
                //console.log(data.IdentityId);
                var params2 = {
                    IdentityId: data.IdentityId // required
                    //CustomRoleArn: 'arn:aws:iam::109765664052:role/Cognito_StructureRestIPUnauth_Role',
                };
                cognitoidentity.getCredentialsForIdentity(params2, function (err2, data2) {
                    if (err2)
                        console.log(err2, err2.stack); // an error occurred
                    else { //console.log(data2);           // successful response
                        if (data2) {
                            const DummyConfig = {
                                accessKeyId: data2.Credentials.AccessKeyId,
                                accessSecretKey: data2.Credentials.SecretKey,
                                sessionToken: data2.Credentials.SessionToken,
                                region: "us-west-2"
                            };
                            AWSSdk.config.update(DummyConfig);
                            let DateKey = new Date().toISOString();
                            let params = {
                                TableName: 'StructureRestJob',
                                KeyConditionExpression: "UserId = :UserId  ",
                                ExpressionAttributeValues: {
                                    ":UserId": "us-west-2:3b464cae-5553-4490-bf04-ac46a4d2512f"
                                },
                                ScanIndexForward: false,
                                ExclusiveStartKey: {
                                    UserId: "us-west-2:3b464cae-5553-4490-bf04-ac46a4d2512f",
                                    CreationDate: DateKey
                                },
                                Limit: 5 //DataPerReq
                            };
                            var docClient = new AWSSdk.DynamoDB.DocumentClient({ region: AWSSdk.config.region });
                            docClient.query(params, function (err, data) {
                                if (err)
                                    return cb(err, null);
                                return cb(null, data);
                            });
                        }
                    }
                });
            }
        }
    });
};
exports.listUnauthenticatedJob = listUnauthenticatedJob;
const scanServerState = (cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err) {
            return cb(err, null);
        }
        const params = {
            TableName: "StructureRestState",
            Limit: 30,
            ReturnConsumedCapacity: "TOTAL"
        };
        dbRequest(RequestType.scan, docClient, params, cb);
    });
});
exports.scanServerState = scanServerState;
const scanServerJob = (params, cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err) {
            return cb(err, null);
        }
        if (params === null) {
            params = {
                TableName: "StructureRestJob",
                Limit: 30,
                ReturnConsumedCapacity: "TOTAL"
            };
        }
        dbRequest(RequestType.scan, docClient, params, cb);
    });
});
exports.scanServerJob = scanServerJob;
const putServerState = (inputData, cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err)
            return cb(err, null);
        const params = {
            TableName: 'StructureRestState',
            Item: inputData.Item
        };
        dbRequest(RequestType.put, docClient, params, cb);
    });
});
exports.putServerState = putServerState;
const putServerJob = (inputData, cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err)
            return cb(err, null);
        const params = {
            TableName: 'StructureRestJob',
            Item: inputData.Item
        };
        dbRequest(RequestType.put, docClient, params, cb);
    });
});
exports.putServerJob = putServerJob;
const batchWriteServerJob = (params, cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err)
            return cb(err, null);
        dbRequest(RequestType.batch, docClient, params, cb);
    });
});
exports.batchWriteServerJob = batchWriteServerJob;
const getServerState = (inputData, cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err)
            return cb(err, null);
        var params = {
            TableName: "StructureRestState",
            Key: {
                "UserId": inputData.Item.UserId
            }
        };
        dbRequest(RequestType.get, docClient, params, cb);
    });
});
exports.getServerState = getServerState;
const updateServerStateCounter = (params, cb) => __awaiter(void 0, void 0, void 0, function* () {
    const serverCredentials = yield (0, exports.getServerCredentials)();
    (0, exports.doServerDynamo)(serverCredentials, (err, docClient) => {
        if (err)
            return cb(err, null);
        const params2 = {
            TableName: "StructureRestState",
            Key: {
                "UserId": params.Item.UserId
            },
            UpdateExpression: 'SET #val = if_not_exists(#val, :zero) + :incr',
            ExpressionAttributeNames: { '#val': 'JobCounter' },
            ExpressionAttributeValues: { ':incr': 1, ':zero': 0 },
            ReturnValues: 'UPDATED_NEW',
        };
        dbRequest(RequestType.update, docClient, params2, cb);
    });
});
exports.updateServerStateCounter = updateServerStateCounter;
//# sourceMappingURL=Dynamo.js.map