"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitAllStepStatus = exports.GitListFiles = exports.GitReadCommitFromCommitOID = exports.Log = exports.GitLog = exports.GitAddMany = exports.GitStatuses = exports.GitRemove = exports.DeleteFile = exports.CompareAndDeleteFiles = exports.GitAdd = exports.ReadFile = exports.DeleteDirectory = exports.FindFilesByStatus = exports.ReadFileFromCommit = exports.ReadFileForDiff = exports.WriteFile = exports.Merge = exports.GitMerge = exports.CheckoutWithFlush = exports.WriteToFirestoreWithFilesystemData = exports.ForceCheckout = exports.Checkout = exports.GitCheckout = exports.Branch = exports.GitCreateBranch = exports.Pull = exports.GitPull = exports.DeleteRemoteBranch = exports.DeleteLocalBranch = exports.DeleteBranch = exports.ListBranch = exports.GitCurrentBranch = exports.ListBranches = exports.GitBranches = exports.Fetch = exports.GitFetch = exports.Push = exports.GitPush = exports.GitClone = exports.GitCurrentCommitOID = exports.GitColors = exports.CreateFreshGitState = exports.EGitSetup = exports.EGitActions = exports.ERequiredGitUserConfig = exports.REMOTE = exports.getNodesDir = exports.NODES_DIR = exports.API_URL = void 0;
exports.WriteFilesForGitModal = exports.SerializeAndWriteOtherEntities = exports.SerializeAndWriteNodeFiles = exports.PrepareBrowserForFileWrite = exports.ResetFile = exports.Clone = exports.CleanupDirectoryOnStart = exports.loadStateFromFiles = exports.readFiles = exports.GetStepCounterFromYaml = exports.GetNameFromYaml = exports.EFirestoreUpdateObject = exports.GitInit = exports.Commit = exports.GitCommit = exports.GitStatus = exports.GetStatusFromMatrix = void 0;
const git = __importStar(require("isomorphic-git"));
const node_1 = __importDefault(require("isomorphic-git/http/node"));
const web_1 = __importDefault(require("isomorphic-git/http/web"));
const Version = __importStar(require("./VersionControlActions"));
const Common = __importStar(require("./Common"));
const State = __importStar(require("./State"));
const Path = __importStar(require("path"));
const Logging = __importStar(require("./Logging"));
const VersionControlActions = __importStar(require("./VersionControlActions"));
const Firebase = __importStar(require("./Firebase"));
const Workspaces = __importStar(require("./Workspaces"));
exports.API_URL = Common.isCommandLine() ? undefined : window.REACT_APP_GIT_PROXY_URL;
exports.NODES_DIR = "nodes/";
const getNodesDir = (dirRoot) => {
    return Path.join(dirRoot, exports.NODES_DIR);
};
exports.getNodesDir = getNodesDir;
const DEFAULT_INIT_BRANCH = "main";
exports.REMOTE = "remotes/origin";
const gitLogger = Logging.GetLogger(Logging.LoggingArea.Git);
const GitLogWithContext = (gitFunctionState, logContext, message, loggerFunction) => {
    const cleanGitFunctionState = Object.assign({}, gitFunctionState.commiter);
    loggerFunction(Object.assign(Object.assign({}, logContext), { GitInfo: cleanGitFunctionState }), message);
};
var ERequiredGitUserConfig;
(function (ERequiredGitUserConfig) {
    ERequiredGitUserConfig["configType"] = "Git Settings";
    ERequiredGitUserConfig["gitAuthorEmail"] = "Author Email";
    ERequiredGitUserConfig["gitAuthorName"] = "Author Email";
    ERequiredGitUserConfig["gitRepoName"] = "Repository Name";
    ERequiredGitUserConfig["gitToken"] = "Token";
    ERequiredGitUserConfig["gitUsername"] = "Username";
})(ERequiredGitUserConfig = exports.ERequiredGitUserConfig || (exports.ERequiredGitUserConfig = {}));
var EGitActions;
(function (EGitActions) {
    EGitActions["idle"] = "idle";
    EGitActions["commiting"] = "commiting";
    EGitActions["pushing"] = "pushing";
    EGitActions["fetching"] = "fetching";
    EGitActions["merging"] = "merging";
    EGitActions["checkingOut"] = "checkingOut";
    EGitActions["cloning"] = "cloning";
    EGitActions["adding"] = "adding";
    EGitActions["listingCommits"] = "listingCommits";
    EGitActions["listingBranches"] = "listingBranches";
    EGitActions["listingCurrentBranch"] = "listingCurrentBranch";
    EGitActions["branching"] = "branching";
})(EGitActions = exports.EGitActions || (exports.EGitActions = {}));
var EGitSetup;
(function (EGitSetup) {
    EGitSetup["setup"] = "Setup";
    EGitSetup["notSetup"] = "NotSetup";
})(EGitSetup = exports.EGitSetup || (exports.EGitSetup = {}));
const CreateFreshGitState = () => {
    return {
        gitSetup: EGitSetup.notSetup,
        currentGitAction: EGitActions.idle,
        gitError: ""
    };
};
exports.CreateFreshGitState = CreateFreshGitState;
var GitColors;
(function (GitColors) {
    GitColors["*added"] = "green";
    GitColors["*modified"] = "orange";
    GitColors["*deleted"] = "red";
})(GitColors = exports.GitColors || (exports.GitColors = {}));
const GitCurrentCommitOID = (fsRequirements) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref: "HEAD" });
    return git.resolveRef(options)
        .catch(error => {
        //add datadog logging
        throw new Error("Error reading the files/commits in directory: " + fsRequirements.dir + "error" + error.toString());
    });
};
exports.GitCurrentCommitOID = GitCurrentCommitOID;
/**
 * Helper for Clone function to pass back readable error message
 * @param error
 * @returns
 */
const ConvertCloneErrorMessage = (error) => {
    let message = "Issue cloning repository: ";
    switch (error.data.statusCode) {
        case 404:
            message += "Check your git url.";
            break;
        case 401:
            message += "Check your username and password.";
            break;
        default:
            message += error.message;
    }
    return new Error(message);
};
const GitClone = (fsRequirements, url, userCredentials) => {
    const onAuth = () => userCredentials;
    const options = Object.assign(Object.assign({}, fsRequirements), { http: Common.isCommandLine() ? node_1.default : web_1.default, onAuth, corsProxy: exports.API_URL, url: url });
    Common.assert(Logging.LoggingArea.Git, !!url, "(GitClone) expected to have target url");
    Common.assert(Logging.LoggingArea.Git, !!userCredentials, "(GitClone) expected to auth creds");
    return git.clone(options)
        .catch(error => {
        throw ConvertCloneErrorMessage(error);
    });
};
exports.GitClone = GitClone;
const GitPush = (fsRequirements, ref, userCredentials) => {
    const onAuth = () => userCredentials;
    const options = Object.assign(Object.assign({}, fsRequirements), { http: Common.isCommandLine() ? node_1.default : web_1.default, remote: "origin", ref, remoteRef: ref, onAuth });
    Common.assert(Logging.LoggingArea.Git, !!ref, "(GitPush) expected to have target branch");
    Common.assert(Logging.LoggingArea.Git, !!userCredentials, "(GitPush) expected to have source branch");
    return git.push(options)
        .catch(err => {
        let message = `Error pushing to remote: ${err.message}`;
        if (err.message.includes("Internal Server Error")) {
            message += ": Please ensure your remote hosting service isn't experiencing issues before trying again.";
        }
        throw new Error(message);
    });
};
exports.GitPush = GitPush;
const Push = (gitState) => {
    const { fsSettings, credentials } = gitState;
    return (branchToPushTo) => {
        return (0, exports.GitPush)(fsSettings, branchToPushTo, credentials)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Push", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Push = Push;
const GitFetch = (fsRequirements, userCredentials) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { onAuth: () => userCredentials, remote: "origin", http: Common.isCommandLine() ? node_1.default : web_1.default });
    Common.assert(Logging.LoggingArea.Git, !!userCredentials, "(GitFetch) expected to have auth credentials");
    return git.fetch(options)
        .catch(err => {
        throw new Error(`Error fetching from remote origin: ${err.toString()}`);
    });
};
exports.GitFetch = GitFetch;
const Fetch = (gitState) => {
    const { fsSettings, credentials } = gitState;
    return () => {
        return (0, exports.GitFetch)(fsSettings, credentials)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Fetch", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Fetch = Fetch;
const GitBranches = (fsRequirements, useRemote) => {
    const options = Object.assign({}, fsRequirements);
    if (useRemote) {
        options["remote"] = "origin";
    }
    return git.listBranches(options)
        .catch(err => {
        throw new Error(`Branch fetching error: ${err.toString()}`);
    });
};
exports.GitBranches = GitBranches;
const ListBranches = (gitState, useRemote) => {
    const { fsSettings } = gitState;
    return () => {
        return (0, exports.GitBranches)(fsSettings, useRemote)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during ListBranches", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.ListBranches = ListBranches;
const GitCurrentBranch = (fsRequirements) => {
    const options = Object.assign({}, fsRequirements);
    return git.currentBranch(options)
        .catch(err => {
        throw new Error(`Error retrieving branch information: ${err}`);
    });
};
exports.GitCurrentBranch = GitCurrentBranch;
const ListBranch = (gitState) => {
    const { fsSettings } = gitState;
    return () => {
        return (0, exports.GitCurrentBranch)(fsSettings)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error while listing current branch", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.ListBranch = ListBranch;
const DeleteBranch = (fsRequirements, refName) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref: refName });
    return git.deleteBranch(options)
        .catch(err => {
        throw new Error("Error deleting branch: " + err.toString());
    });
};
exports.DeleteBranch = DeleteBranch;
const DeleteLocalBranch = (gitState) => {
    const { fsSettings } = gitState;
    return (branchName) => {
        return (0, exports.DeleteBranch)(fsSettings, branchName);
    };
};
exports.DeleteLocalBranch = DeleteLocalBranch;
const DeleteRemoteBranch = (fsRequirements, userCredentials, refName) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { onAuth: () => userCredentials, ref: refName, remote: "origin", http: Common.isCommandLine() ? node_1.default : web_1.default, delete: true });
    return git.push(options)
        .catch(err => {
        throw new Error("Error deleting remote branch: " + err.toString());
    });
};
exports.DeleteRemoteBranch = DeleteRemoteBranch;
const GitPull = (fsRequirements, userCredentials, author, singleBranch, ref) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { onAuth: () => userCredentials, remote: "origin", http: Common.isCommandLine() ? node_1.default : web_1.default, author,
        singleBranch,
        ref });
    return git.pull(options)
        .catch(err => {
        throw new Error("Error pulling from remote: " + err.toString());
    });
};
exports.GitPull = GitPull;
const Pull = (gitState) => {
    const { fsSettings, commiter, credentials } = gitState;
    return (singleBranch, refName) => {
        return (0, exports.GitPull)(fsSettings, credentials, commiter, singleBranch, refName)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Pull", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Pull = Pull;
/**
 * Creates and Checks out a new branch
 * @param fsRequirements
 * @param branchName
 * @returns
 */
const GitCreateBranch = (fsRequirements, branchName) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref: branchName, checkout: true });
    Common.assert(Logging.LoggingArea.Git, !!branchName, "(GitCreateBranch) expected to have target branch");
    return git.branch(options)
        .catch(err => {
        throw new Error(`Unable to create branch ${branchName}: ${err.toString()}`);
    });
};
exports.GitCreateBranch = GitCreateBranch;
const Branch = (gitState) => {
    const { fsSettings } = gitState;
    return (newBranchName) => {
        return (0, exports.GitCreateBranch)(fsSettings, newBranchName)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Create Branch", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Branch = Branch;
const GitCheckout = (fsRequirements, ref, forceCheckout) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref: ref, force: forceCheckout });
    Common.assert(Logging.LoggingArea.Git, !!ref, "(GitCheckout) expected to have target branch");
    return git.checkout(Object.assign(Object.assign({}, options), { dryRun: true }))
        .then(() => git.checkout(options))
        .catch(err => {
        throw new Error(`Unable to checkout ${ref}: ${err.toString()}`);
    });
};
exports.GitCheckout = GitCheckout;
const Checkout = (gitState) => {
    const { fsSettings } = gitState;
    return (branchToCheckout) => {
        return (0, exports.GitCheckout)(fsSettings, branchToCheckout, false)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Checkout", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Checkout = Checkout;
const ForceCheckout = (gitState) => {
    const { fsSettings } = gitState;
    return (branchToCheckout) => {
        return (0, exports.GitCheckout)(fsSettings, branchToCheckout, true)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Forced Checkout", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.ForceCheckout = ForceCheckout;
const WriteToFirestoreWithFilesystemData = (gitState) => {
    const { fsSettings } = gitState;
    return (teamID, workspaceID) => {
        return Workspaces.GetAllWorkspaceDataFromGitCommit(fsSettings, null, workspaceID)
            .then(newWorkspaceData => {
            const firestore = Firebase.getFirestore();
            return Workspaces.getAllWorkspaceDataFromFirebase(firestore, teamID, workspaceID)
                .then(workspaceStateToReplace => {
                return Workspaces.FlushFirestoreWorkspaceWithAllWorkspaceData(firestore, teamID, workspaceID, newWorkspaceData, workspaceStateToReplace);
            });
        })
            .catch(error => {
            GitLogWithContext(gitState, { orgID: teamID, envID: workspaceID }, "Error during Filesystem Flush", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.WriteToFirestoreWithFilesystemData = WriteToFirestoreWithFilesystemData;
const CheckoutWithFlush = (gitState) => {
    const { fsSettings } = gitState;
    return (branchToCheckout, teamID, workspaceID) => {
        const loggingContext = { orgID: teamID, envID: workspaceID };
        return Common.timedLoggerPromise(`Checking out ${branchToCheckout}`, loggingContext, Logging.LoggingArea.Git, (0, exports.GitCheckout)(fsSettings, branchToCheckout, false))
            .then(() => {
            //run git log and scoop top commit
            gitLogger.infoContext(loggingContext, "(Preparing to Flush), running GitLog to get head commit");
            return Common.timedLoggerPromise(`Running Git Log on ${branchToCheckout}`, loggingContext, Logging.LoggingArea.Git, (0, exports.GitLog)(fsSettings, branchToCheckout));
        })
            .then((commits) => {
            const latestCommit = commits[0];
            const latestCommitOID = latestCommit.oid;
            gitLogger.infoContext(loggingContext, `(Preparing to Flush), running GetAllWorkspaceDataFromGitCommit for branch: ${branchToCheckout}, commit: ${latestCommitOID}`);
            return Common.timedLoggerPromise(`GetAllWorkspaceDataFromGitCommit for ${branchToCheckout}, ${latestCommitOID}`, loggingContext, Logging.LoggingArea.Git, Workspaces.GetAllWorkspaceDataFromGitCommit(fsSettings, latestCommitOID, workspaceID));
        })
            .then(newWorkspaceData => {
            const firestore = Firebase.getFirestore();
            gitLogger.infoContext(loggingContext, `(Preparing to Flush), running getAllWorkspaceDataFromFirebase`);
            return Common.timedLoggerPromise(`GetAllWorkspaceDataFromFirestore`, loggingContext, Logging.LoggingArea.Git, Workspaces.getAllWorkspaceDataFromFirebase(firestore, teamID, workspaceID))
                .then(workspaceStateToReplace => {
                gitLogger.infoContext(loggingContext, `(Preparing to Flush), running FlushFirestoreWorkspaceWithAllWorkspaceData`);
                return Common.timedLoggerPromise(`FlushFirestoreWorkspaceWithAllWorkspaceData`, loggingContext, Logging.LoggingArea.Git, Workspaces.FlushFirestoreWorkspaceWithAllWorkspaceData(firestore, teamID, workspaceID, newWorkspaceData, workspaceStateToReplace));
            });
        })
            .catch(error => {
            GitLogWithContext(gitState, loggingContext, "Error during Checkout with Flush", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.CheckoutWithFlush = CheckoutWithFlush;
/**
 * Walker function that sequentially handles merges on files so we can handle issues 1 at a time, default
 * when not used it to have them occur concurrently, which doesn't work well with the user interventions (merge conflict resolution)
 * need to make sure this isn't super slow, also that we don't force this when a merge conflict doesn't occur
 * @param walk caller function from isomorphic-git used to read/walk through the specified child files/path/tree
 * @param children files/directorys to read/work on
 * @returns
 */
const MergeWalkerIteratorOverride = (walk, children) => {
    return new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const childrenArray = [...children];
            for (let i = 0; i < childrenArray.length; i++) {
                childrenArray[i] = yield walk(childrenArray[i]);
            }
            resolve(childrenArray);
        }
        catch (error) {
            reject(error);
        }
    }));
};
const GitMerge = (fsRequirements, branchWithChangesWeWant, branchWhereWeWantTheChanges, author, asyncMergeConflictCallback) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { theirs: branchWithChangesWeWant, ours: branchWhereWeWantTheChanges, author });
    Common.assert(Logging.LoggingArea.Git, !!branchWhereWeWantTheChanges, "(GitMerge) expected to have target branch");
    Common.assert(Logging.LoggingArea.Git, !!branchWithChangesWeWant, "(GitMerge) expected to have source branch");
    Common.assert(Logging.LoggingArea.Git, !!author, "(GitMerge) expected to have git author");
    //try to merge normally, if it doesn't succeed, catch and try again with our helper functions
    return git.merge(Object.assign({}, options))
        .catch(() => {
        return git.merge(Object.assign(Object.assign({}, options), { asyncMergeConflictCallback: asyncMergeConflictCallback, iterateOverride: MergeWalkerIteratorOverride }));
    }).catch(error => {
        //if we fail again, either the user aborted the merge, or isomorphic git couldn't support it, log and tell them to fix it outside Coalesce
        GitLogWithContext({ commiter: author, fsSettings: fsRequirements, credentials: { username: "", password: "" } }, {}, `Error during Merge: ${error}`, gitLogger.errorContext);
        throw new Error(`Unable to merge ${branchWithChangesWeWant} with ${branchWhereWeWantTheChanges}. Merge conflicts of this type are currently unsupported.  Please handle the conflict off platform and fetch/merge the changes.`);
    });
};
exports.GitMerge = GitMerge;
const Merge = (gitState, asyncMergeConflictCallback) => {
    const { fsSettings, commiter } = gitState;
    return (branchWithChangesWeWant, branchWhereWeWantTheChanges) => {
        return (0, exports.GitMerge)(fsSettings, branchWithChangesWeWant, branchWhereWeWantTheChanges, commiter, asyncMergeConflictCallback)
            .catch(error => {
            GitLogWithContext(gitState, {}, `Error during Merge: ${error}`, gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Merge = Merge;
const WriteFile = (fsRequirements, fileData, filepath, filename) => {
    return fsRequirements.fs.promises.writeFile(`${fsRequirements.dir}${filepath}${filename}`, fileData)
        .then(() => {
        return;
    }).catch(err => {
        throw new Error("Error writing file changes to: " + filename + " " + err.toString());
    });
};
exports.WriteFile = WriteFile;
const ReadFileForDiff = (fsRequirements, ref, filepath) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref });
    return git.resolveRef(options).then(commit => {
        return (0, exports.ReadFileFromCommit)(fsRequirements, commit, filepath);
    })
        .then(fileContent => {
        return { exists: true, yaml: fileContent };
    })
        .catch(err => {
        //file didn't exist
        return { exists: false, yaml: "" };
    });
};
exports.ReadFileForDiff = ReadFileForDiff;
const ReadFileFromCommit = (fsRequirements, commitOID, filepath) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { oid: commitOID, filepath });
    return git.readBlob(options).then(result => {
        let { blob } = result;
        return Buffer.from(blob).toString("utf-8");
    }).catch(err => {
        throw new Error(`Error reading file ${filepath} from commit ${commitOID}: ${err.toString()}`);
    });
};
exports.ReadFileFromCommit = ReadFileFromCommit;
const FindFilesByStatus = (statusFiles, status) => {
    return statusFiles.filter(file => file.status === status);
};
exports.FindFilesByStatus = FindFilesByStatus;
const DeleteDirectory = (fsRequirements, directory) => {
    const { fs, dir } = fsRequirements;
    const { promises } = fs;
    return promises.readdir(dir + directory).then(result => {
        return result.filter(file => file.includes(".yml"));
    }).catch(err => {
        return [];
    }).then(files => {
        return Promise.all(files.map(file => (0, exports.DeleteFile)(fsRequirements, directory + "/" + file)));
    }).then(() => {
        return;
    }).catch(err => {
        throw new Error("Error while deleting: " + directory + " " + err.message);
    });
};
exports.DeleteDirectory = DeleteDirectory;
const ReadFile = (fsRequirements, dir, filename) => {
    const { fs } = fsRequirements;
    const { promises } = fs;
    return promises.readFile(dir + filename).then(res => {
        return new TextDecoder("utf-8").decode(res);
    })
        .then(fileContent => {
        return { yaml: fileContent, exists: true };
    })
        .catch(err => {
        return { yaml: "", exists: false };
    });
};
exports.ReadFile = ReadFile;
const GitAdd = (fsRequirements, filename) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { filepath: filename });
    Common.assert(Logging.LoggingArea.Git, !!filename, "(GitAdd) expected to have a filename");
    return git.add(options)
        .catch(err => {
        throw new Error("Error adding file: " + err.toString());
    });
};
exports.GitAdd = GitAdd;
const CompareAndDeleteFiles = (fsRequirements, currentSteps) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref: "HEAD" });
    let headFiles;
    const stageFiles = Object.keys(currentSteps).map(stepCounter => "nodes/" + currentSteps[stepCounter].operation.name + ".yml");
    return git.listFiles(options).then(files => {
        headFiles = files;
        const stageSet = new Set(stageFiles);
        return headFiles.filter(file => !stageSet.has(file)).filter(file => file.includes("nodes/"));
    }).then((filesToDelete) => {
        return Promise.all(filesToDelete.map(file => {
            return (0, exports.DeleteFile)(fsRequirements, file);
        }));
    }).then(() => {
        return;
    }).catch(err => {
        throw new Error("Delete error during CompareAndDelete: " + err.toString());
    });
};
exports.CompareAndDeleteFiles = CompareAndDeleteFiles;
const DeleteFile = (fsRequirements, filepath) => {
    const { fs } = fsRequirements;
    const { promises } = fs;
    return new Promise((resolve, reject) => {
        try {
            return promises.unlink(fsRequirements.dir + "/" + filepath).then(() => {
                resolve();
            }).catch(err => {
                reject(new Error(`Error unlinking file ${filepath}: ${err.toString()}`));
            });
        }
        catch (error) {
            //log
            reject(error);
        }
    });
};
exports.DeleteFile = DeleteFile;
const GitRemove = (fsRequirements, filepath) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { filepath });
    return git.remove(options)
        .catch(err => {
        throw new Error("Error while removing: " + filepath + " " + err.toString());
    });
};
exports.GitRemove = GitRemove;
var GitStatuses;
(function (GitStatuses) {
    GitStatuses["added"] = "*added";
    GitStatuses["deleted"] = "*deleted";
    GitStatuses["modified"] = "*modified";
})(GitStatuses = exports.GitStatuses || (exports.GitStatuses = {}));
const GitAddMany = (fsRequirements, filenames) => {
    const promises = filenames.map(file => {
        const { name, status } = file;
        if (status === GitStatuses.deleted) { //deleted here
            return (0, exports.GitRemove)(fsRequirements, name);
        }
        else { //modified or add is here
            return (0, exports.GitAdd)(fsRequirements, name);
        }
    });
    return Promise.all(promises)
        .then(() => {
        return;
    })
        .catch(err => {
        throw new Error("Error during git add: " + err.toString());
    });
};
exports.GitAddMany = GitAddMany;
/**
 * Git Log fails when there isn't a locally checked out version of the branch, so if we fail, run it on the remote/origin/branchName
 * @param fsRequirements
 * @param branchName
 * @returns
 */
const GitLog = (fsRequirements, branchName) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { ref: branchName });
    Common.assert(Logging.LoggingArea.Git, !!branchName, "(GitLog) expected to have target branch");
    return git.log(options)
        .catch(err => {
        if (err.message === `Could not find ${branchName}.`) {
            return git.log(Object.assign(Object.assign({}, fsRequirements), { ref: `${exports.REMOTE}/${branchName}` }));
        }
        else {
            throw new Error("Error during log: " + err.message);
        }
    });
};
exports.GitLog = GitLog;
const Log = (gitState) => {
    const { fsSettings } = gitState;
    return (logBranch) => {
        return (0, exports.GitLog)(fsSettings, logBranch)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error Logging commits", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Log = Log;
const GitReadCommitFromCommitOID = (fsRequirements, commitOID) => {
    const options = Object.assign({}, fsRequirements);
    Common.assert(Logging.LoggingArea.Git, !!commitOID, "(GitReadCommitFromCommitOID) expected to have target branch");
    return git.log(options)
        .then(result => {
        const targetCommit = result.find(commit => {
            return commit.oid == commitOID;
        });
        if (!targetCommit) {
            throw new Error("No commit found with the given commitOID");
        }
        return targetCommit;
    })
        .catch(error => {
        throw new Error("Error during git log: " + error.message);
    });
};
exports.GitReadCommitFromCommitOID = GitReadCommitFromCommitOID;
const GitListFiles = (fsRequirements, ref) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { dir: fsRequirements.dir });
    if (ref) {
        options["ref"] = ref;
    }
    return git.listFiles(options)
        .catch(err => {
        throw new Error("Error listing files: " + err.toString());
    });
};
exports.GitListFiles = GitListFiles;
const GitAllStepStatus = (fsRequirements) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { filter: f => f.endsWith(".yml") });
    return git.statusMatrix(options).then(result => {
        const results = result.map(matrixRow => {
            const obj = {
                name: "",
                status: "",
                shouldCommit: false
            };
            const [name, HEAD, WORK, STAGE] = matrixRow;
            obj["name"] = name;
            //take head, work, stage and do a comparison func to spit back the correct status
            obj["status"] = (0, exports.GetStatusFromMatrix)(HEAD, WORK, STAGE);
            return obj;
            //filter out all the unmodified status objects
        }).filter(file => file["status"] !== "unmodified").map(statusObj => (Object.assign(Object.assign({}, statusObj), { shouldCommit: false }))); //tack on the shouldCommit field for use in the GitMenu modal
        return results;
    }).catch(err => {
        throw new Error("Error during status: " + err.toString());
    });
};
exports.GitAllStepStatus = GitAllStepStatus;
const GetStatusFromMatrix = (HEAD, WORK, STAGE) => {
    switch (HEAD) {
        case 0:
            return "*added";
        case 1:
            switch (WORK) {
                case 0:
                    return "*deleted";
                case 2:
                    return "*modified";
                case 1:
                default:
                    return "unmodified";
            }
        default:
            return "unmodified";
    }
};
exports.GetStatusFromMatrix = GetStatusFromMatrix;
const GitStatus = (fsRequirements, dir, filename) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { dir: fsRequirements.dir + dir, filepath: filename });
    Common.assert(Logging.LoggingArea.Git, !!filename, "(GitStatus) expected to have filename");
    return git.status(options)
        .catch(err => {
        throw err;
    });
};
exports.GitStatus = GitStatus;
const GitCommit = (fsRequirements, author, message, branch) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { author,
        message, ref: branch });
    Common.assert(Logging.LoggingArea.Git, !!branch, "(GitCommit) expected to have target branch");
    Common.assert(Logging.LoggingArea.Git, !!message, "(GitCommit) expected to have commit message");
    Common.assert(Logging.LoggingArea.Git, !!author, "(GitCommit) expected to have git author");
    return git.commit(options)
        .catch(err => {
        throw new Error("Error during commit" + err.toString());
    });
};
exports.GitCommit = GitCommit;
const Commit = (gitState) => {
    const { fsSettings, commiter } = gitState;
    return (message, branch) => {
        return (0, exports.GitCommit)(fsSettings, commiter, message, branch)
            .catch(error => {
            GitLogWithContext(gitState, {}, "Error during Commit", gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Commit = Commit;
//only support cloning an existing repo?  not all services allow you to create locally and then use the CL to push to create
const GitInit = (fsRequirements) => {
    const options = Object.assign(Object.assign({}, fsRequirements), { defaultBranch: DEFAULT_INIT_BRANCH });
    return git.init(options)
        .catch(err => {
        throw err;
    });
};
exports.GitInit = GitInit;
var EFirestoreUpdateObject;
(function (EFirestoreUpdateObject) {
    EFirestoreUpdateObject["node"] = "Node";
    EFirestoreUpdateObject["dataYml"] = "DataYML";
})(EFirestoreUpdateObject = exports.EFirestoreUpdateObject || (exports.EFirestoreUpdateObject = {}));
const GetNameFromYaml = (yaml) => {
    const { steps } = Version.getReduxStateFromYaml([yaml], "");
    const step = Object.keys(steps)[0];
    return steps[step].operation.locationName + "-" + steps[step].operation.name;
};
exports.GetNameFromYaml = GetNameFromYaml;
const GetStepCounterFromYaml = (yaml) => {
    const splitYaml = yaml.split("stepCounter:");
    Common.assert(Logging.LoggingArea.Git, !!(splitYaml.length > 1), "(GetStepCounterFromYaml) expected to split and find the nodeID");
    return parseInt(splitYaml[1]);
};
exports.GetStepCounterFromYaml = GetStepCounterFromYaml;
const readFiles = (fsRequirements, cb) => {
    return new Promise((resolve, reject) => {
        const nodesDir = (0, exports.getNodesDir)(fsRequirements.dir);
        fsRequirements.fs.readdir(nodesDir, (err, files) => {
            if (err) {
                console.error("unable to open dir", nodesDir, err);
                reject(err);
                return;
            }
            else {
                //process each entru 
                let currentIndex = 0;
                const onFileFinish = () => {
                    if (currentIndex == files.length) {
                        resolve({});
                    }
                    else {
                        const filePath = Path.join(nodesDir, files[currentIndex]);
                        fsRequirements.fs.readFile(filePath, { encoding: "utf-8" }, (error, readResult) => {
                            if (error) {
                                console.error("got error on reading file", files[currentIndex], error);
                                reject(err);
                                return;
                            }
                            else {
                                cb(readResult);
                                //bump to next file
                                currentIndex = currentIndex + 1;
                                onFileFinish();
                            }
                        });
                    }
                };
                onFileFinish();
            }
        });
    });
};
exports.readFiles = readFiles;
const loadStateFromFiles = (fsRequirements) => {
    let stepsYaml = [];
    const onFileRead = (nodeYaml) => {
        stepsYaml.push(nodeYaml);
    };
    return (0, exports.readFiles)(fsRequirements, onFileRead).then(() => {
        const reduxState = Version.getReduxStateFromYaml(stepsYaml, "");
        return reduxState;
    });
};
exports.loadStateFromFiles = loadStateFromFiles;
const CleanupDirectoryOnStart = (FileStore, dispatch) => {
    return new Promise((resolve, reject) => {
        dispatch(State.setFilesystemSettings(FileStore, "/workspace"));
        return (0, exports.DeleteDirectory)({ fs: FileStore, dir: "/workspace" }, "/nodes").then(() => {
            resolve();
        }).catch(error => {
            gitLogger.error("Error during CleanUpDirectoryOnStart: ", error);
            reject(error);
        });
    });
};
exports.CleanupDirectoryOnStart = CleanupDirectoryOnStart;
/**
 *
 * @param gitFunctionState
 * @param userID
 * @returns The name of the default branch to initialize with after Cloning
 */
const Clone = (gitFunctionState, userID) => {
    const { fsSettings, credentials, commiter } = gitFunctionState;
    return (gitRepoUrl) => {
        //always reinit connection to fs and wipe files on clone
        fsSettings.fs.init(`coalesce:${userID}`, { wipe: true });
        return (0, exports.GitClone)(fsSettings, gitRepoUrl, credentials)
            .then(() => {
            return (0, exports.GitCurrentBranch)(fsSettings)
                .then((branchName) => {
                return (0, exports.GitLog)(fsSettings, branchName).then(() => {
                    return branchName;
                });
            })
                .catch((error) => {
                //only execute if we receive the failure message from GitLog
                if (error.code === "NotFoundError") {
                    GitLogWithContext(gitFunctionState, { userID }, `Error during clone validation, error: ${error}`, gitLogger.errorContext);
                    GitLogWithContext(gitFunctionState, { userID }, `Setting up new default branch in fresh repo: ${DEFAULT_INIT_BRANCH}`, gitLogger.infoContext);
                    return (0, exports.WriteFile)(fsSettings, VersionControlActions.readme, "/", "README.md")
                        .then(() => (0, exports.GitAdd)(fsSettings, "README.md"))
                        .then(() => (0, exports.GitCommit)(fsSettings, commiter, "Init commit", DEFAULT_INIT_BRANCH))
                        .then(() => (0, exports.GitPush)(fsSettings, DEFAULT_INIT_BRANCH, credentials))
                        .then(() => (0, exports.GitCheckout)(fsSettings, DEFAULT_INIT_BRANCH, false))
                        .then(() => DEFAULT_INIT_BRANCH);
                }
                else {
                    throw error;
                }
            });
        })
            .then((branchToReturn) => {
            GitLogWithContext(gitFunctionState, { userID }, "Clone successful", gitLogger.infoContext);
            return branchToReturn;
        })
            .catch((error) => {
            GitLogWithContext(gitFunctionState, { userID }, `GitSettings threw an error when trying to Clone: ${error}`, gitLogger.errorContext);
            throw error;
        });
    };
};
exports.Clone = Clone;
const ResetFile = (gitFunctionState) => {
    const { fsSettings } = gitFunctionState;
    return (filepath) => {
        return GitResetFile(fsSettings, filepath)
            .catch(error => {
            GitLogWithContext(gitFunctionState, {}, `(GitResetFile) error: ${error}`, gitLogger.errorContext);
            throw error;
        });
    };
};
exports.ResetFile = ResetFile;
const GitResetFile = (fsSettings, filepath) => {
    const options = Object.assign(Object.assign({}, fsSettings), { filepath });
    return git.resetIndex(options);
};
const PrepareBrowserForFileWrite = (fsSettings, logger, orgID) => {
    return Common.timedLoggerPromise("Prepared Browser for File Write", { orgID }, Logging.LoggingArea.Git, new Promise((resolve, reject) => {
        fsSettings.fs.promises.mkdir("/workspace").catch((err) => null)
            .then(() => fsSettings.fs.promises.mkdir("/workspace/nodes")).catch((err) => null)
            .then(() => {
            return (0, exports.DeleteDirectory)(fsSettings, "/nodes");
        }).catch((error) => {
            logger.errorContext(`GitMenu threw an error when trying DeleteDirectory w/directory "/nodes"`, error);
            reject(error);
        })
            .then(resolve);
    }));
};
exports.PrepareBrowserForFileWrite = PrepareBrowserForFileWrite;
const SerializeAndWriteNodeFiles = (allSteps, fsSettings, orgID) => {
    return Common.timedLoggerPromise("Writing all nodes", { orgID }, Logging.LoggingArea.Git, new Promise((resolve, reject) => {
        const nodeFileWritePromises = Object.keys(allSteps)
            .map((nodeCounter) => {
            const nodeData = allSteps[nodeCounter];
            const fileData = VersionControlActions.getYamlContentForStep(nodeData, nodeCounter);
            const cleanFileName = Common.RemoveProtectedCharactersFromString(nodeData.operation.name);
            return (0, exports.WriteFile)(fsSettings, fileData, "/nodes/", `${nodeData.operation.locationName}-${cleanFileName}.yml`);
        });
        return Promise.all(nodeFileWritePromises)
            .then(() => {
            resolve();
        })
            .catch(reject);
    }));
};
exports.SerializeAndWriteNodeFiles = SerializeAndWriteNodeFiles;
/**
 * Currently repsonsible for writing all entities to their respective file(s)
 * @param fsSettings
 * @param locations
 * @param environments
 * @param subgraphs
 * @param jobs
 * @param macros
 * @param stepTypes
 * @returns a Promise when the WriteFile promise completes
 */
const SerializeAndWriteOtherEntities = (fsSettings, locations, environments, subgraphs, jobs, macros, stepTypes, orgID) => {
    return Common.timedLoggerPromise("Writing data.yml", { orgID }, Logging.LoggingArea.Git, new Promise((resolve, reject) => {
        const dataYaml = VersionControlActions.getDataYaml(locations, environments, subgraphs, jobs, macros, stepTypes);
        (0, exports.WriteFile)(fsSettings, dataYaml, "/", "data.yml")
            .then(resolve)
            .catch(reject);
    }));
};
exports.SerializeAndWriteOtherEntities = SerializeAndWriteOtherEntities;
const WriteFilesForGitModal = (gitFunctionState, gitLogger, orgID) => {
    const { fsSettings } = gitFunctionState;
    return (stateForWrite) => {
        const { locations, workspaces, folders, jobs, macros, stepTypes, steps } = stateForWrite;
        return (0, exports.PrepareBrowserForFileWrite)(fsSettings, gitLogger, orgID)
            .then(() => {
            return (0, exports.SerializeAndWriteOtherEntities)(fsSettings, locations, workspaces, folders, jobs, macros, stepTypes, orgID);
        }).catch(err => {
            gitLogger.errorContext(`GitMenu threw an error when trying WriteFile w/file "data.yml"`, err);
            throw new Error("Error during write to data.yml:" + err.message);
        })
            .then(() => {
            return (0, exports.SerializeAndWriteNodeFiles)(steps, fsSettings, orgID);
        })
            .catch(err => {
            gitLogger.errorContext(`GitMenu threw an error when trying WriteFile to "/nodes/"`, err);
            throw new Error("Error writing to filestore: " + err.message);
        })
            .then(() => {
            return Common.timedLoggerPromise("Getting file statuses", { orgID }, Logging.LoggingArea.Git, (0, exports.GitAllStepStatus)(fsSettings));
        });
    };
};
exports.WriteFilesForGitModal = WriteFilesForGitModal;
//# sourceMappingURL=GitOperation.js.map