"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRunState = exports.RunState = void 0;
class RunState {
    constructor() {
        this.currentStep = null;
        this.currentTask = null;
    }
}
exports.RunState = RunState;
const getRunState = (currentState) => {
    let currentStep = currentState['currentStep'];
    let currentTask = currentState['currentTask'];
    let connections = currentState['connections'];
    let steps = currentState['steps'];
    let edges = currentState.edges;
    let tasks = currentState['tasks'];
    let apis = currentState['apis'];
    let currentStepData = currentStep ? steps[currentStep] : false;
    let currentTaskData = currentTask ? tasks[currentTask] : false;
    let runResults = currentState.runResults;
    let outputs = currentState['outputs'];
    return {
        connections, currentStep, currentTask, steps, edges, tasks, currentStepData, currentTaskData, apis, runResults, outputs
    };
};
exports.getRunState = getRunState;
//# sourceMappingURL=RunState.js.map