"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUserDefinedSystemColumn = exports.isFirstClassSystemColumn = exports.EFirstClassSystemColumnFlags = exports.populateSysColumnData = exports.convertSystemColumnSpecToColumnMetadata = exports.getDefaultColumn = exports.GhostRecordDefaultValues = exports.cleanColumnMetadata = exports.parseYAMLString = exports.stringifyMetadata = exports.initializeNodeParams = exports.CreateColumnFromSystemColumnSpec = exports.InitializeSystemColumnsNames = exports.AddSystemColumns = exports.createNewOperation = exports.defaultOperationType = exports.defaultTemplateType = exports.RunTemplateTypes = exports.CheckIfSQLTypeIsConvertable = exports.GetEmptyFinishedQueryResult = exports.getValueFromRow = exports.EFieldType = exports.PersistentStageSQLOperation = exports.DimensionSQLOperation = exports.EDimTypes = exports.SQLOperationRunType = exports.SQLOperation = exports.HydratedMetadata = exports.Metadata = exports.keyColumnTypeDetails = exports.EFirstClassAttributesNode = exports.V0KeyColumnTypeFlagConversion = exports.FirstClassAttributeFlags = exports.EKeyColumnTypes = exports.EFirstClassAttributesColumn = exports.FormattedSystemColumnTypes = exports.V0SystemColumnTypeFlagConversion = exports.systemColumnTypeFlags = exports.ESystemColumnTypes = exports.EHashAlgorithms = exports.IsDataVaultNode = exports.getColumnsForHashKey = exports.EHashType = exports.SourceOperation = exports.WorkspaceHealthDetails = exports.EWorkspaceHealth = exports.ESQLTypeShort = exports.ESQLType = exports.EStepTypes = exports.EStepRunState = void 0;
exports.RunTypeDetails = exports.ERunType = exports.ERunStatus = exports.RunPost = exports.ConvertFromUserContextToSnowflakeUserCrendentials = exports.getUserContextFromRunInfo = exports.checkForType1Dim = exports.hydrateTransform = exports.GetTransformTemplateStrings = exports.TransformTokenDescriptions = exports.ETransformTemplates = exports.getUpdatedSourceMapping = exports.getUpdatedSourceMapJoin = exports.getUpdatedSourceMapName = exports.getSourceMapFromOperationSafe = exports.GenerateSelectStatementForCustomOverride = exports.generateJoinString = exports.GenerateCustomSQL = exports.GetLocationFromStep = exports.GenerateMacroLookup = exports.isTableNameUnique = exports.getFullSource = exports.HandleError = exports.getRunResultFailureAction = exports.RUN_RESULT_FAILURE = exports.getRunResultAction = exports.RUN_RESULT = exports.PlayTaskThunk = exports.HandlePlayTaskThunkError = exports.ERunResultUpdateType = exports.getMostRecentRunResult = exports.createSourceInputColumns = exports.GetTotalColumnCounterIncrement = exports.RunRenderWorkspaceEditSQL = exports.RunRenderSQL = exports.RunTemplate = exports.RunDescTable = exports.RunGetRows = exports.RunRefresh = exports.RunStepIndex = exports.RunUpdateStep = exports.RunRenderAndValidate = exports.RunProvisionTable = exports.RunStepPreview = exports.RunDeriveMappingFromCustomSQLResult = exports.GetColumnMetadataFromDescTableResult = exports.RunStep = exports.getQueryResultFromException = exports.createType2SysColumns = exports.getAllAttributeNames = void 0;
exports.RunResyncSource = exports.initializeEditorForSQL = exports.CustomMonacoSQLActions = void 0;
const Immer = __importStar(require("immer"));
const Common = __importStar(require("./Common"));
const Templates = __importStar(require("./Templates"));
const RunnerOperations = __importStar(require("./RunnerOperations"));
const Axios = __importStar(require("axios"));
const YAML = __importStar(require("yaml"));
const MetadataOperations = __importStar(require("./MetadataOperations"));
const CommonOperations = __importStar(require("./CommonOperations"));
const StepOperations = __importStar(require("./StepOperations"));
const MacroOperations = __importStar(require("./MacroOperations"));
const TestingOperations = __importStar(require("./TestingOperations"));
const Snowflake = __importStar(require("./Snowflake"));
const Logging = __importStar(require("./Logging"));
const R = __importStar(require("runtypes"));
var EStepRunState;
(function (EStepRunState) {
    EStepRunState["none"] = "None";
    EStepRunState["error"] = "Error";
    EStepRunState["validated"] = "Validated";
    EStepRunState["created"] = "Created";
    EStepRunState["loaded"] = "DataLoaded";
    EStepRunState["deployed"] = "Deployed";
})(EStepRunState = exports.EStepRunState || (exports.EStepRunState = {}));
var EStepTypes;
(function (EStepTypes) {
    EStepTypes["sql"] = "sql";
    EStepTypes["sourceInput"] = "sourceInput";
})(EStepTypes = exports.EStepTypes || (exports.EStepTypes = {}));
//set axios default base url
const getBaseURL = () => {
    if (Common.isCommandLine()) {
        if (process.env.AXIOS_POST_ADDRESS) {
            //set for the scheduler
            return process.env.AXIOS_POST_ADDRESS;
        }
        if (process.env.RUNTIME_ENVIRONMENT ||
            process.env.NODE_ENVIRONMENT) {
            //for local cli testing 
            Logging.GetLogger(Logging.LoggingArea.APP).info("setting to localhost for local cli testing");
            return `http://localhost:8000/`;
        }
        if (!process.env.NODE_ENVIRONMENT) {
            //production cli, use the prod python endpoint
            return 'https://app.coalescesoftware.io/';
        }
    }
    const myWindow = window;
    if (myWindow.AXIOS_POST_ADDRESS !== undefined) {
        return myWindow.AXIOS_POST_ADDRESS;
    }
    ;
    //this code is killing me, We need to be able to specify things differently :|
    if (myWindow.location.hostname == "localhost") {
        const url = myWindow.location.protocol + "//" + myWindow.location.hostname + ":8000";
        Logging.GetLogger(Logging.LoggingArea.APP).info("setting base url localhost to " + url);
        return url;
    }
    else {
        const url = myWindow.location.protocol + "//" + myWindow.location.hostname;
        Logging.GetLogger(Logging.LoggingArea.APP).info("setting base url to not localhost", url);
        return url;
    }
};
Axios.default.defaults.baseURL = getBaseURL();
var ESQLType;
(function (ESQLType) {
    ESQLType["stage"] = "Stage";
    ESQLType["persistentStage"] = "persistentStage";
    ESQLType["view"] = "View";
    ESQLType["dimension"] = "Dimension";
    ESQLType["fact"] = "Fact";
    ESQLType["hub"] = "Hub";
    ESQLType["link"] = "Link";
    ESQLType["satellite"] = "Satellite";
    ESQLType["source"] = "Source";
})(ESQLType = exports.ESQLType || (exports.ESQLType = {}));
var ESQLTypeShort;
(function (ESQLTypeShort) {
    ESQLTypeShort["STG"] = "Stage";
    ESQLTypeShort["PSTG"] = "persistentStage";
    ESQLTypeShort["V"] = "View";
    ESQLTypeShort["DIM"] = "Dimension";
    ESQLTypeShort["FCT"] = "Fact";
    ESQLTypeShort["HUB"] = "Hub";
    ESQLTypeShort["LNK"] = "Link";
    ESQLTypeShort["SAT"] = "Satellite";
    ESQLTypeShort["SRC"] = "Source";
})(ESQLTypeShort = exports.ESQLTypeShort || (exports.ESQLTypeShort = {}));
var EWorkspaceHealth;
(function (EWorkspaceHealth) {
    EWorkspaceHealth["refreshing"] = "Refreshing";
    EWorkspaceHealth["failedDeploy"] = "Failed Deploy";
    EWorkspaceHealth["failedRefresh"] = "Failed Refresh";
    EWorkspaceHealth["deploying"] = "Deploying";
    EWorkspaceHealth["waiting"] = "Waiting"; // if the current status is waiting, you can run a new deploy or a refresh. This is the 'healthy' state.  Should I rename to healthy?
})(EWorkspaceHealth = exports.EWorkspaceHealth || (exports.EWorkspaceHealth = {}));
exports.WorkspaceHealthDetails = {
    [EWorkspaceHealth.failedDeploy]: {
        status: EWorkspaceHealth.failedDeploy,
        color: "red"
    },
    [EWorkspaceHealth.failedRefresh]: {
        status: EWorkspaceHealth.failedRefresh,
        color: "red"
    },
    [EWorkspaceHealth.waiting]: {
        status: "OK",
        color: "green"
    },
    [EWorkspaceHealth.deploying]: {
        status: EWorkspaceHealth.deploying,
        color: "yellow"
    },
    [EWorkspaceHealth.refreshing]: {
        status: EWorkspaceHealth.refreshing,
        color: "blue"
    }
};
//update to include metadata.columns
class SourceOperation {
    constructor() {
        this[_a] = true;
        this.locationName = "";
        this.locationID = 0;
        this.database = "";
        this.schema = "";
        this.dataset = "";
        this.table = "";
        this.name = "";
        this.type = EStepTypes.sourceInput;
        this.sqlType = ESQLType.source;
        this.metadata = { columns: [] };
    }
}
exports.SourceOperation = SourceOperation;
_a = Immer.immerable;
///////////// Shared Column Metadata
//////////// Data Vault
//convert into Dictionary
var EHashType;
(function (EHashType) {
    EHashType["hub"] = "HubHash";
    EHashType["link"] = "LinkHash";
    EHashType["change"] = "ChangeHash";
    EHashType["generic"] = "Hash";
    EHashType["none"] = "None";
})(EHashType = exports.EHashType || (exports.EHashType = {}));
//helper function for getting columns for hash
const getColumnsForHashKey = (allColumns, hashColumn) => {
    var _c, _d, _e;
    if (((_c = hashColumn.hashDetails) === null || _c === void 0 ? void 0 : _c.hashType) !== EHashType.link) {
        const hashColumns = allColumns.filter(column => {
            var _c;
            return (_c = column.hashColumns) === null || _c === void 0 ? void 0 : _c.some((ref) => {
                return ref.columnCounter === hashColumn.columnReference.columnCounter;
            });
        });
        return hashColumns;
    }
    else {
        //for links, get underlying columns, then get their columns 
        const hubKeyColumnRefs = [];
        if ((_d = hashColumn.hashDetails) === null || _d === void 0 ? void 0 : _d.hubHashes) {
            (_e = hashColumn.hashDetails) === null || _e === void 0 ? void 0 : _e.hubHashes.forEach(ref => {
                const hashRef = allColumns.find(column => {
                    return column.columnReference.columnCounter === ref.columnCounter;
                });
                if (hashRef) {
                    hubKeyColumnRefs.push(hashRef);
                }
            });
        }
        const columnSet = new Set();
        const hashColumns = [];
        hubKeyColumnRefs.forEach(column => {
            const columns = (0, exports.getColumnsForHashKey)(allColumns, column);
            columns.forEach(newColumn => columnSet.add(newColumn.columnReference.columnCounter));
            hashColumns.push(...columns);
        });
        hashColumns.filter(column => {
            if (columnSet.has(column.columnReference.columnCounter)) {
                columnSet.delete(column.columnReference.columnCounter);
                return true;
            }
            return false;
        });
        return hashColumns;
    }
};
exports.getColumnsForHashKey = getColumnsForHashKey;
/**
 * Helper function to aid in seeing if the passed in SQL type is one of the 1st class Data Vault nodes
 * @param sqlType SQLType to compare
 * @returns a boolean, whether the sqlType param is one of the 3 data vault types
 */
const IsDataVaultNode = (sqlType) => {
    const dataVaultTypes = new Set([ESQLType.hub, ESQLType.link, ESQLType.satellite]);
    return dataVaultTypes.has(sqlType);
};
exports.IsDataVaultNode = IsDataVaultNode;
var EHashAlgorithms;
(function (EHashAlgorithms) {
    EHashAlgorithms["sha1"] = "SHA1";
    EHashAlgorithms["sha256"] = "SHA256";
    EHashAlgorithms["md5"] = "MD5";
    //... more
})(EHashAlgorithms = exports.EHashAlgorithms || (exports.EHashAlgorithms = {}));
/**
 * This enum is deprecated, and its associated dictionary 'systemColumnTypeFlags' is used for
 * 		backward compatibility
 */
var ESystemColumnTypes;
(function (ESystemColumnTypes) {
    ESystemColumnTypes["none"] = "None";
    ESystemColumnTypes["sysCreateDate"] = "sysCreateDate";
    ESystemColumnTypes["sysUpdateDate"] = "sysUpdateDate";
    ESystemColumnTypes["sysStartDate"] = "sysStartDate";
    ESystemColumnTypes["sysEndDate"] = "sysEndDate";
    ESystemColumnTypes["sysVersion"] = "sysVersion";
    ESystemColumnTypes["sysCurrentFlag"] = "sysCurrentFlag";
})(ESystemColumnTypes = exports.ESystemColumnTypes || (exports.ESystemColumnTypes = {}));
//used for adding attributes to columns during column hydration
exports.systemColumnTypeFlags = {
    [ESystemColumnTypes.none]: null,
    [ESystemColumnTypes.sysCreateDate]: "isSystemCreateDate",
    [ESystemColumnTypes.sysUpdateDate]: "isSystemUpdateDate",
    [ESystemColumnTypes.sysStartDate]: "isSystemStartDate",
    [ESystemColumnTypes.sysEndDate]: "isSystemEndDate",
    [ESystemColumnTypes.sysVersion]: "isSystemVersion",
    [ESystemColumnTypes.sysCurrentFlag]: "isSystemCurrentFlag",
};
exports.V0SystemColumnTypeFlagConversion = {
    [exports.systemColumnTypeFlags.sysCreateDate]: ESystemColumnTypes.sysCreateDate,
    [exports.systemColumnTypeFlags.sysUpdateDate]: ESystemColumnTypes.sysUpdateDate,
    [exports.systemColumnTypeFlags.sysStartDate]: ESystemColumnTypes.sysStartDate,
    [exports.systemColumnTypeFlags.sysEndDate]: ESystemColumnTypes.sysEndDate,
    [exports.systemColumnTypeFlags.sysVersion]: ESystemColumnTypes.sysVersion,
    [exports.systemColumnTypeFlags.sysCurrentFlag]: ESystemColumnTypes.sysCurrentFlag
};
exports.FormattedSystemColumnTypes = {
    [ESystemColumnTypes.none]: "",
    [ESystemColumnTypes.sysCreateDate]: "SYSTEM_CREATE_DATE",
    [ESystemColumnTypes.sysUpdateDate]: "SYSTEM_UPDATE_DATE",
    [ESystemColumnTypes.sysStartDate]: "SYSTEM_START_DATE",
    [ESystemColumnTypes.sysEndDate]: "SYSTEM_END_DATE",
    [ESystemColumnTypes.sysVersion]: "SYSTEM_VERSION",
    [ESystemColumnTypes.sysCurrentFlag]: "SYSTEM_CURRENT_FLAG"
};
var EFirstClassAttributesColumn;
(function (EFirstClassAttributesColumn) {
    EFirstClassAttributesColumn["businessKey"] = "isBusinessKey";
    EFirstClassAttributesColumn["changeTracking"] = "isChangeTracking";
    EFirstClassAttributesColumn["surrogateKey"] = "isSurrogateKey";
})(EFirstClassAttributesColumn = exports.EFirstClassAttributesColumn || (exports.EFirstClassAttributesColumn = {}));
var EKeyColumnTypes;
(function (EKeyColumnTypes) {
    EKeyColumnTypes["none"] = "None";
    EKeyColumnTypes["surrogateKey"] = "surrogateKey";
    EKeyColumnTypes["primaryBusinessKey"] = "primaryBusinessKey";
})(EKeyColumnTypes = exports.EKeyColumnTypes || (exports.EKeyColumnTypes = {}));
//used for adding attributes to columns during column hydration
exports.FirstClassAttributeFlags = {
    isChangeTracking: EFirstClassAttributesColumn.changeTracking,
    isSurrogateKey: EFirstClassAttributesColumn.surrogateKey,
    isBusinessKey: EFirstClassAttributesColumn.businessKey,
    none: EKeyColumnTypes.none
};
exports.V0KeyColumnTypeFlagConversion = {
    [EFirstClassAttributesColumn.businessKey]: EKeyColumnTypes.primaryBusinessKey,
    [EFirstClassAttributesColumn.surrogateKey]: EKeyColumnTypes.surrogateKey
};
var EFirstClassAttributesNode;
(function (EFirstClassAttributesNode) {
    EFirstClassAttributesNode["materializationType"] = "materializationType";
    EFirstClassAttributesNode["isMultisource"] = "isMultisource";
    EFirstClassAttributesNode["overrideSQL"] = "overrideSQL";
    EFirstClassAttributesNode["isDataVault"] = "isDataVault";
})(EFirstClassAttributesNode = exports.EFirstClassAttributesNode || (exports.EFirstClassAttributesNode = {}));
exports.keyColumnTypeDetails = {
    [EKeyColumnTypes.none]: {
        formatted: "",
        abbreviated: ""
    },
    [EKeyColumnTypes.surrogateKey]: {
        formatted: "surrogate_key",
        abbreviated: "SK"
    },
    [EKeyColumnTypes.primaryBusinessKey]: {
        formatted: "primary_business_key",
        abbreviated: "BK"
    },
};
class Metadata {
    constructor() {
        this.columns = [];
        this.sourceMapping = [];
        this.destinationName = "";
        this.appliedNodeTests = []; // Node level tests applied to this node
        this.enabledColumnTestIDs = []; // For sustaining which enabled column tests made available to individual columns
    }
}
exports.Metadata = Metadata;
class HydratedMetadata extends MetadataOperations.HydratedMetadata {
}
exports.HydratedMetadata = HydratedMetadata;
//update to add database, schema as optional? values to class definition
class SQLOperation {
    constructor() {
        this[_b] = true;
        this.isDataVault = false;
        this.isMultisource = false;
        this.overrideSQL = false;
        this.name = "";
        this.metadata = {
            columns: [],
            cteString: "",
            sourceMapping: [{
                    name: "",
                    join: { joinCondition: "" },
                    dependencies: [],
                    customSQL: { customSQL: "" },
                    noLinkRefs: []
                }],
            appliedNodeTests: [],
            enabledColumnTestIDs: []
        };
        this.dependencies = [];
        this.sqlType = ESQLType.view;
        this.type = EStepTypes.sql;
        this.locationID = 0;
        this.locationName = "";
        this.database = "";
        this.schema = "";
        this.description = "";
        this.config = {};
        this.materializationType = Templates.materializationTypes.table;
    }
}
exports.SQLOperation = SQLOperation;
_b = Immer.immerable;
//todo: move these elsewhere?
const RColumnReference = R.Record({
    stepCounter: R.Union(R.String, R.Number),
    columnCounter: R.Union(R.String, R.Number),
});
//todo: update to replace unknowns with dictionary where possible
const RColumnMetadata = R.Record({
    defaultValue: R.Optional(R.String),
    nullable: R.Union(R.Boolean, R.String),
    name: R.String,
    dataType: R.String,
    transform: R.Optional(R.String),
    columnReference: RColumnReference,
    sourceColumnReferences: R.Array(R.Record({
        columnReferences: R.Array(RColumnReference),
        transform: R.String
    })),
    systemColumnType: R.Optional(R.String),
    keyColumnType: R.Optional(R.String),
    ghostRecordValue: R.Optional(R.Unknown),
    isChangeTracking: R.Optional(R.Boolean),
    primaryKey: R.Optional(R.Boolean),
    uniqueKey: R.Optional(R.Boolean),
    hashDetails: R.Union(R.Record({
        hashAlgorithm: R.String,
        hashType: R.Optional(R.String),
        hubHashes: R.Optional(R.Array(RColumnReference))
    }), R.Null),
    hashedColumns: R.Optional(RColumnReference),
    isSurrogateKey: R.Optional(R.Boolean),
    description: R.String,
    isBusinessKey: R.Optional(R.Boolean),
    sourceNames: R.Optional(R.Unknown),
    config: R.Optional(R.Unknown),
    appliedColumnTest: R.Optional(R.Unknown),
    acceptedValues: TestingOperations.RAcceptedValues,
    descendedFrom: R.Optional(R.String),
    hashColumns: R.Optional(RColumnReference),
    columnsForHash: R.Optional(R.Array(R.String))
});
const RRefLink = R.Record({
    locationName: R.String,
    nodeName: R.String
});
//todo: Fix to use Dictionary where possible to replace unknowns
exports.SQLOperationRunType = R.Record({
    materializationType: R.String,
    config: R.Optional(R.Dictionary(R.Unknown)),
    description: R.String,
    schema: R.String,
    database: R.String,
    locationName: R.String,
    locationID: R.Number,
    type: R.Union(R.Literal("sql"), R.Literal("sourceInput")),
    sqlType: R.String,
    dependencies: R.Array(RRefLink),
    name: R.String,
    isDataVault: R.Optional(R.Boolean),
    isMultisource: R.Optional(R.Boolean),
    overrideSQL: R.Optional(R.Boolean),
    metadata: R.Record({
        columns: R.Array(RColumnMetadata),
        sourceMapping: R.Array(R.Record({
            name: R.String,
            join: R.Record({
                joinCondition: R.String
            }),
            dependencies: R.Array(RRefLink),
            customSQL: R.Optional(R.Record({
                customSQL: R.String
            })),
            noLinkRefs: R.Optional(R.Array(RRefLink))
        })),
        destinationName: R.Optional(R.String),
        description: R.Optional(R.String),
        mapping: R.Optional(R.Unknown),
        sourceNames: R.Optional(R.Unknown),
        materializationOption: R.Optional(R.String),
        appliedNodeTests: R.Array(TestingOperations.RNodeTest),
        enabledColumnTestIDs: R.Array(R.String)
    })
});
var EDimTypes;
(function (EDimTypes) {
    EDimTypes["type1"] = "Type 1";
    EDimTypes["type2"] = "Type 2";
})(EDimTypes = exports.EDimTypes || (exports.EDimTypes = {}));
class DimensionSQLOperation extends SQLOperation {
    constructor() {
        super(...arguments);
        this.metadata = { columns: [], sourceMapping: [{ name: "", join: { joinCondition: "" }, dependencies: [], noLinkRefs: [] }], appliedNodeTests: [], enabledColumnTestIDs: [] };
        this.sqlType = ESQLType.dimension;
    }
}
exports.DimensionSQLOperation = DimensionSQLOperation;
class PersistentStageSQLOperation extends SQLOperation {
    constructor() {
        super(...arguments);
        this.metadata = { columns: [], sourceMapping: [{ name: "", join: { joinCondition: "" }, dependencies: [], noLinkRefs: [] }], appliedNodeTests: [], enabledColumnTestIDs: [] };
        this.sqlType = ESQLType.persistentStage;
    }
}
exports.PersistentStageSQLOperation = PersistentStageSQLOperation;
//Query Result 
var EFieldType;
(function (EFieldType) {
    EFieldType[EFieldType["numberWhole"] = 0] = "numberWhole";
    EFieldType[EFieldType["numberDecimal"] = 1] = "numberDecimal";
    EFieldType[EFieldType["date"] = 2] = "date";
    EFieldType[EFieldType["string"] = 3] = "string";
})(EFieldType = exports.EFieldType || (exports.EFieldType = {}));
const getValueFromRow = (fields, r, fieldName) => {
    const i = fields.findIndex((f) => {
        return f.name == fieldName;
    });
    const v = r.values[i];
    if (typeof v === "boolean") {
        return v.toString();
    }
    return r.values[i];
};
exports.getValueFromRow = getValueFromRow;
/**
 * @param success must be inputted as this could be used for a 'succesful' or 'failed' result
 * @return an empty query result for when one isn't already generated for whatever reason
 */
const GetEmptyFinishedQueryResult = (success) => {
    return {
        error: null,
        fields: [],
        rows: [],
        success,
        sql: "",
        exportedRefs: [],
        invalidExportedRefs: [],
        startTime: new Date(),
        endTime: new Date(),
        isRunning: false,
        name: "",
        status: Snowflake.ESnowflakeDataReturnStatus.success,
        type: Templates.EQueryResultType.sql
    };
};
exports.GetEmptyFinishedQueryResult = GetEmptyFinishedQueryResult;
const CheckIfSQLTypeIsConvertable = (type) => {
    switch (type) {
        case ESQLType.source:
        case ESQLType.hub:
        case ESQLType.satellite:
        case ESQLType.link:
            return false;
        default:
            return true;
    }
};
exports.CheckIfSQLTypeIsConvertable = CheckIfSQLTypeIsConvertable;
// todo: create enum for provisionTable, preview, runUpdate
var RunTemplateTypes;
(function (RunTemplateTypes) {
    RunTemplateTypes["preview"] = "preview";
    RunTemplateTypes["provisionTable"] = "provisionTable";
    RunTemplateTypes["runUpdate"] = "runUpdate";
    RunTemplateTypes["getData"] = "getData";
    RunTemplateTypes["describe"] = "describe";
    RunTemplateTypes["default"] = "default";
    RunTemplateTypes["truncate"] = "truncate";
    RunTemplateTypes["deploy"] = "deploy";
    RunTemplateTypes["describeView"] = "describeView";
})(RunTemplateTypes = exports.RunTemplateTypes || (exports.RunTemplateTypes = {}));
//default is used on run all
exports.defaultTemplateType = {
    [EStepTypes.sourceInput]: RunTemplateTypes.getData,
    [ESQLType.source]: RunTemplateTypes.getData,
    [ESQLType.view]: RunTemplateTypes.runUpdate,
    [ESQLType.stage]: RunTemplateTypes.runUpdate,
    [ESQLType.dimension]: RunTemplateTypes.runUpdate,
    [ESQLType.persistentStage]: RunTemplateTypes.runUpdate,
    [ESQLType.fact]: RunTemplateTypes.runUpdate
};
/**
 * eventually meant to replace defaultTemplateType
 */
exports.defaultOperationType = {
    [EStepTypes.sourceInput]: RunnerOperations.OperationTypes.select,
    [ESQLType.source]: RunnerOperations.OperationTypes.select,
    [ESQLType.view]: RunnerOperations.OperationTypes.run,
    [ESQLType.stage]: RunnerOperations.OperationTypes.run,
    [ESQLType.dimension]: RunnerOperations.OperationTypes.run,
    [ESQLType.persistentStage]: RunnerOperations.OperationTypes.run,
    [ESQLType.fact]: RunnerOperations.OperationTypes.run
};
// jsx-related details can be found in src/Common.tsx under 'FrontEndStepTypeDetails'
const createNewOperation = (sqlType) => {
    switch (sqlType) {
        case ESQLType.source:
            return new SourceOperation();
        default:
            return new SQLOperation();
    }
};
exports.createNewOperation = createNewOperation;
//add unititalized system columns and insert them in the correct order 
const AddSystemColumns = (columns, nodeSpec) => {
    //or add check here to see if nodeSpec is valid
    const middleColumns = columns !== null ? [...columns] : [];
    const beginningColumnsToAdd = [];
    const endColumnsToAdd = [];
    if (nodeSpec.systemColumns) {
        nodeSpec.systemColumns.forEach((col) => {
            //display names are not initialized since node data doesn't exist yet
            const formattedColumnMetadata = (0, exports.CreateColumnFromSystemColumnSpec)(col);
            if (col.placement === Templates.SystemColumnPlacement.beginning) {
                beginningColumnsToAdd.push(formattedColumnMetadata);
            }
            else {
                endColumnsToAdd.push(formattedColumnMetadata);
            }
        });
    }
    return [...beginningColumnsToAdd, ...middleColumns, ...endColumnsToAdd];
};
exports.AddSystemColumns = AddSystemColumns;
//takes columns and replaces any NODE_NAME tokens to initialize them to their new node
const InitializeSystemColumnsNames = (columns, nodeName) => {
    return columns.map(column => {
        try {
            if (column.name.includes("{{NODE_NAME}}")) {
                column.name = column.name.replace("{{NODE_NAME}}", nodeName);
            }
        }
        catch (error) {
            throw new Error(`Error: initializing system columns for ${nodeName}, column name is Undefined.`);
        }
        return column;
    });
};
exports.InitializeSystemColumnsNames = InitializeSystemColumnsNames;
//Given a single system column spec of a node type, generate a new column based on the definition
const CreateColumnFromSystemColumnSpec = (systemColumnSpec) => {
    //add check here? to make sure systemColumnSpec is valid?
    return (0, exports.populateSysColumnData)(systemColumnSpec.displayName, systemColumnSpec.transform, systemColumnSpec.dataType, systemColumnSpec.attributeName);
};
exports.CreateColumnFromSystemColumnSpec = CreateColumnFromSystemColumnSpec;
const initializeNodeParams = (newStepData, teamID, nodeSpec) => {
    var _c;
    let beginningColumnsToAdd = [];
    let endColumnsToAdd = [];
    // translate from system column spec to our metadata format
    (_c = nodeSpec.systemColumns) === null || _c === void 0 ? void 0 : _c.forEach((col) => {
        const formattedColumnMetadata = (0, exports.convertSystemColumnSpecToColumnMetadata)(col, newStepData);
        if (col.placement === Templates.SystemColumnPlacement.beginning) {
            beginningColumnsToAdd.push(formattedColumnMetadata);
        }
        else {
            endColumnsToAdd.push(formattedColumnMetadata);
        }
    });
    const allColumnsToAdd = [...beginningColumnsToAdd, ...endColumnsToAdd];
    return StepOperations.getNextColumnCounter(allColumnsToAdd.length, teamID).then(newColumnCounter => {
        allColumnsToAdd.forEach((col, index) => {
            col.columnReference.columnCounter = newColumnCounter + index;
        });
        return [...beginningColumnsToAdd, ...newStepData.metadata.columns, ...endColumnsToAdd];
    });
};
exports.initializeNodeParams = initializeNodeParams;
const stringifyMetadata = (hydratedMetadata) => {
    return YAML.stringify(hydratedMetadata);
};
exports.stringifyMetadata = stringifyMetadata;
const parseYAMLString = (yaml) => {
    return YAML.parse(yaml);
};
exports.parseYAMLString = parseYAMLString;
// called on new step creation, cleans up unnecessary metadata
const cleanColumnMetadata = (columns) => {
    const cleanedColumnMetadata = columns.map(column => {
        return {
            columnReference: column.columnReference,
            nullable: column.nullable,
            name: column.name,
            sourceColumnReferences: column.sourceColumnReferences,
            description: column.description,
            hashColumns: [],
            hashDetails: null,
            dataType: column.dataType
        };
    });
    return cleanedColumnMetadata;
};
exports.cleanColumnMetadata = cleanColumnMetadata;
// todo: update datatypes, enum is no longer valid
exports.GhostRecordDefaultValues = {
    [CommonOperations.EDataType.FIXED]: null,
    [CommonOperations.EDataType.REAL]: null,
    [CommonOperations.EDataType.TEXT]: null,
    [CommonOperations.EDataType.DATE]: null,
    [CommonOperations.EDataType.TIMESTAMP]: "1900-01-01",
    [CommonOperations.EDataType.VARIANT]: null,
    [CommonOperations.EDataType.TIMESTAMP_LTZ]: "1900-01-01",
    [CommonOperations.EDataType.TIMESTAMP_TZ]: "1900-01-01",
    [CommonOperations.EDataType.TIMESTAMP_NTZ]: "1900-01-01",
    [CommonOperations.EDataType.OBJECT]: null,
    [CommonOperations.EDataType.ARRAY]: null,
    [CommonOperations.EDataType.BINARY]: null,
    [CommonOperations.EDataType.TIME]: null,
    [CommonOperations.EDataType.BOOLEAN]: null,
    [EKeyColumnTypes.surrogateKey]: 0
};
const getDefaultColumn = () => {
    return {
        name: "",
        nullable: false,
        defaultValue: "",
        dataType: CommonOperations.EDataType.TEXT,
        description: "",
        columnReference: {
            stepCounter: "0",
            columnCounter: 0
        },
        hashColumns: [],
        config: {},
        appliedColumnTests: {},
        acceptedValues: { strictMatch: true, values: [] }
    };
};
exports.getDefaultColumn = getDefaultColumn;
const convertSystemColumnSpecToColumnMetadata = (systemColumnSpec, newStepData) => {
    /*
     * format columnName and set it to col.name
     * if parsed YAML name includes {{NODE_NAME}} - treat like a token
     */
    const colName = systemColumnSpec.displayName.includes("{{NODE_NAME}}") ?
        systemColumnSpec.displayName.replace("{{NODE_NAME}}", newStepData.name) :
        systemColumnSpec.displayName;
    return (0, exports.populateSysColumnData)(colName, systemColumnSpec.transform, systemColumnSpec.dataType, systemColumnSpec.attributeName);
};
exports.convertSystemColumnSpecToColumnMetadata = convertSystemColumnSpecToColumnMetadata;
const populateSysColumnData = (columnName, transform, dataType, attributeName) => {
    const sysColumn = (0, exports.getDefaultColumn)();
    sysColumn.name = columnName;
    sysColumn.dataType = dataType;
    sysColumn[attributeName] = true;
    sysColumn.sourceColumnReferences = [{
            columnReferences: [],
            transform: transform
        }];
    return sysColumn;
};
exports.populateSysColumnData = populateSysColumnData;
var EFirstClassSystemColumnFlags;
(function (EFirstClassSystemColumnFlags) {
    EFirstClassSystemColumnFlags["isSystemStartDate"] = "isSystemStartDate";
    EFirstClassSystemColumnFlags["isSystemEndDate"] = "isSystemEndDate";
    EFirstClassSystemColumnFlags["isSystemCreateDate"] = "isSystemCreateDate";
    EFirstClassSystemColumnFlags["isSystemUpdateDate"] = "isSystemUpdateDate";
    EFirstClassSystemColumnFlags["isSystemVersion"] = "isSystemVersion";
    EFirstClassSystemColumnFlags["isSystemCurrentFlag"] = "isSystemCurrentFlag";
    EFirstClassSystemColumnFlags["isSystemRecordSource"] = "isSystemRecordSource";
})(EFirstClassSystemColumnFlags = exports.EFirstClassSystemColumnFlags || (exports.EFirstClassSystemColumnFlags = {}));
//returns true if a column is a system column of any type
const isFirstClassSystemColumn = (column) => {
    const systemColumnFlags = Object.values(exports.systemColumnTypeFlags).filter(flag => !!flag); //filters out 'none' type which has a value of null
    return systemColumnFlags.some(flag => !!column[flag]); //checks if column has the flag AND if it's true
};
exports.isFirstClassSystemColumn = isFirstClassSystemColumn;
const isUserDefinedSystemColumn = (column, nodeMetadataSpec) => {
    if (!(nodeMetadataSpec === null || nodeMetadataSpec === void 0 ? void 0 : nodeMetadataSpec.systemColumns)) {
        return false;
    }
    const userDefinedSystemColumnTypes = nodeMetadataSpec.systemColumns.map(col => col.attributeName);
    return userDefinedSystemColumnTypes.some(type => column[type] === true);
};
exports.isUserDefinedSystemColumn = isUserDefinedSystemColumn;
const getAllAttributeNames = (nodeSpec) => {
    var _c;
    if (!nodeSpec.config) {
        return [];
    }
    else {
        let attributeNames = [];
        (_c = nodeSpec.config) === null || _c === void 0 ? void 0 : _c.forEach(configGroup => {
            configGroup.items.forEach(item => {
                if (!Templates.IsFirstClassConfigElement(item)) {
                    attributeNames.push(item.attributeName);
                    if (item.type === Templates.SpecUIType.tabular && !!item.columns) {
                        item.columns.forEach(column => {
                            // array allows for columns to have a length, but no definition, that's caught later in validation
                            if (!!column) {
                                attributeNames.push(column.attributeName);
                            }
                        });
                    }
                }
                else {
                    attributeNames.push(item.type);
                }
            });
        });
        return attributeNames;
    }
};
exports.getAllAttributeNames = getAllAttributeNames;
const createType2SysColumns = () => {
    const sysStartColumn = (0, exports.populateSysColumnData)("SYSTEM_START_DATE", "CAST(CURRENT_TIMESTAMP AS TIMESTAMP)", CommonOperations.EDataType.TIMESTAMP, "isSystemStartDate");
    const sysEndColumn = (0, exports.populateSysColumnData)("SYSTEM_END_DATE", "CAST('2999-12-31 00:00:00' AS TIMESTAMP)", CommonOperations.EDataType.TIMESTAMP, "isSystemEndDate");
    const sysVersionColumn = (0, exports.populateSysColumnData)("SYSTEM_VERSION", "", CommonOperations.EDataType.FIXED, "isSystemVersion");
    const sysCurrentFlagColumn = (0, exports.populateSysColumnData)("SYSTEM_CURRENT_FLAG", "", CommonOperations.EDataType.TEXT, "isSystemCurrentFlag");
    return [sysStartColumn, sysEndColumn, sysVersionColumn, sysCurrentFlagColumn];
};
exports.createType2SysColumns = createType2SysColumns;
const getQueryResultFromException = (e) => {
    return {
        success: false,
        rows: [],
        fields: [],
        error: { errorString: e.toString() }
    };
};
exports.getQueryResultFromException = getQueryResultFromException;
const RunStep = (stepCounter, executor) => {
    return RunnerOperations.RunStep(stepCounter, executor);
};
exports.RunStep = RunStep;
const GetColumnMetadataFromDescTableResult = (queryResult, teamID, stepCounter) => {
    return MetadataOperations.GetColumnMetadataFromDescTableResult(queryResult, teamID, stepCounter);
};
exports.GetColumnMetadataFromDescTableResult = GetColumnMetadataFromDescTableResult;
const RunDeriveMappingFromCustomSQLResult = (stepCounter, teamID, macros, errorAlert) => {
    return RunnerOperations.RunDeriveMappingFromCustomSQLResult(stepCounter, teamID, macros, errorAlert);
};
exports.RunDeriveMappingFromCustomSQLResult = RunDeriveMappingFromCustomSQLResult;
/**
 * needed just for generating the generic preview template -
 * all create and load previews will use the below funcs
 */
const RunStepPreview = (stepCounter, specifiedIndex) => {
    return RunnerOperations.RunStepPreview(stepCounter, specifiedIndex);
};
exports.RunStepPreview = RunStepPreview;
const RunProvisionTable = (stepCounter, isPreview) => {
    return RunnerOperations.RunProvisionTable(stepCounter, isPreview);
};
exports.RunProvisionTable = RunProvisionTable;
const RunRenderAndValidate = (stepCounter, operationType, templateEditorOverride) => {
    return RunnerOperations.RunRenderAndValidate(stepCounter, operationType, templateEditorOverride);
};
exports.RunRenderAndValidate = RunRenderAndValidate;
const RunUpdateStep = (stepCounter, isPreview) => {
    return RunnerOperations.RunUpdateStep(stepCounter, isPreview);
};
exports.RunUpdateStep = RunUpdateStep;
const RunStepIndex = (stepCounter, index) => {
    return RunnerOperations.RunStepIndex(stepCounter, index);
};
exports.RunStepIndex = RunStepIndex;
const RunRefresh = (stepCounter) => {
    return RunnerOperations.RunRefresh(stepCounter);
};
exports.RunRefresh = RunRefresh;
const RunGetRows = (stepCounter, token) => {
    return RunnerOperations.RunGetRows(stepCounter, token);
};
exports.RunGetRows = RunGetRows;
const RunDescTable = (locations, stepData, UserContext, macros) => {
    return RunnerOperations.RunDescTable(locations, stepData, UserContext, macros);
};
exports.RunDescTable = RunDescTable;
const RunTemplate = (templateParams, token) => {
    return new Promise((resolve, reject) => {
        RunnerOperations.RunTemplate(templateParams, token)
            .then((result) => {
            resolve(result);
        })
            .catch((err) => {
            reject(err);
        });
    });
};
exports.RunTemplate = RunTemplate;
const RunRenderSQL = (templateString, userContext, nodeMetadata, macrosString) => {
    return RunnerOperations.RunRenderSQL(templateString, userContext, nodeMetadata, macrosString);
};
exports.RunRenderSQL = RunRenderSQL;
const RunRenderWorkspaceEditSQL = (editsCollection, userContext, macros) => {
    return RunnerOperations.RunRenderWorkspaceEditSQL(editsCollection, userContext, macros);
};
exports.RunRenderWorkspaceEditSQL = RunRenderWorkspaceEditSQL;
const GetTotalColumnCounterIncrement = (results) => {
    const totalColumnCount = results.reduce((cumulativeCount, result) => {
        return cumulativeCount + result.data.rows.length;
    }, 0);
    return totalColumnCount;
};
exports.GetTotalColumnCounterIncrement = GetTotalColumnCounterIncrement;
const createSourceInputColumns = (results) => {
    const columns = [];
    results.data.rows.forEach((row) => {
        const metadata = {
            name: row.name,
            dataType: row.type,
            nullable: row["null?"] === "Y",
            defaultValue: "",
            columnReference: {
                columnCounter: 0,
                stepCounter: "0"
            },
            primaryKey: row["primary key"] === "Y",
            uniqueKey: row["unique key"] === "Y",
            description: "",
            appliedColumnTests: {},
            acceptedValues: { strictMatch: true, values: [] },
            config: {}
        };
        columns.push(metadata);
    });
    return columns;
};
exports.createSourceInputColumns = createSourceInputColumns;
const getMostRecentRunResult = (runResults) => {
    return runResults.history.slice(-1)[0];
};
exports.getMostRecentRunResult = getMostRecentRunResult;
var ERunResultUpdateType;
(function (ERunResultUpdateType) {
    ERunResultUpdateType["start"] = "start";
    ERunResultUpdateType["update"] = "update";
})(ERunResultUpdateType = exports.ERunResultUpdateType || (exports.ERunResultUpdateType = {}));
const HandlePlayTaskThunkError = (err) => {
    console.error(err);
};
exports.HandlePlayTaskThunkError = HandlePlayTaskThunkError;
function PlayTaskThunk(dataSelect, stepsSubset, specifiedExecutorFactory, operationType, RunSQL, isPreview) {
    return RunnerOperations.PlayTaskThunk(dataSelect, stepsSubset, specifiedExecutorFactory, operationType, RunSQL, isPreview);
}
exports.PlayTaskThunk = PlayTaskThunk;
exports.RUN_RESULT = "RUN_RESULT";
function getRunResultAction(taskID, stepCounter, resultInfo, display, status) {
    var runResultAction = {
        type: exports.RUN_RESULT,
        stepCounter: stepCounter,
        resultInfo: resultInfo,
        display: display,
        status: status,
        taskID
    };
    return runResultAction;
}
exports.getRunResultAction = getRunResultAction;
exports.RUN_RESULT_FAILURE = "RUN_RESULT_FAILURE";
function getRunResultFailureAction(taskID, stepCounter, error, display, status) {
    return {
        type: exports.RUN_RESULT_FAILURE,
        stepCounter,
        taskID,
        error,
        display,
        status
    };
}
exports.getRunResultFailureAction = getRunResultFailureAction;
/**
 * optional third argument is to take in any invalid sql that
 * we tried to run against snowflake - we don't get one back in
 * an error from the api
 */
const HandleError = (ret, startTime, sql) => {
    return {
        success: false,
        error: ret.error ? ret.error : { message: ret.stack },
        rows: [],
        fields: [],
        sql: sql !== null && sql !== void 0 ? sql : Common.getValueSafe(ret, ["runDetails", "compiledSQL"], ""),
        startTime: startTime,
        endTime: new Date(),
        isRunning: false,
    };
};
exports.HandleError = HandleError;
const getFullSource = (database, schema, stepData) => {
    let fullSource = "";
    if (!stepData) {
        throw new Error("Step didn't exist");
    }
    if (stepData.operation.sqlType === ESQLType.source) {
        fullSource = `${stepData.operation.database}.${stepData.operation.dataset}.${stepData.operation.name}`;
    }
    else {
        fullSource = `${database}.${schema}.${StepOperations.GetStepName(stepData)}`;
    }
    return fullSource;
};
exports.getFullSource = getFullSource;
//check all steps with full name 
const isTableNameUnique = (steps, tableName) => {
    var _c;
    for (let stepCounter in steps) {
        const step = steps[stepCounter];
        switch (step.operation.type) {
            case EStepTypes.sourceInput:
                {
                    const operation = step.operation;
                    if (tableName.toLowerCase() == operation.table.toLowerCase()) {
                        return false;
                    }
                }
                break;
            case EStepTypes.sql:
                {
                    const operation = step.operation;
                    //check schema uniqueness
                    if (tableName.toLowerCase() == ((_c = StepOperations.GetStepName(step)) === null || _c === void 0 ? void 0 : _c.toLowerCase())) {
                        return false;
                    }
                }
                break;
            default:
                console.assert(false);
        }
    }
    return true;
};
exports.isTableNameUnique = isTableNameUnique;
const generateInnerJoinString = (lookupString, firstSourceName, stepName) => {
    return `\nINNER JOIN ${lookupString} "${stepName}"\nON "${firstSourceName}"./*COLUMN*/ = "${stepName}"./*COLUMN*/`;
};
const generateLeftJoinString = (lookupString, firstSourceName, stepName, businessKeyName) => {
    if (businessKeyName !== "/*COLUMN*/") {
        return `\nLEFT JOIN ${lookupString} "${stepName}"\nON "${firstSourceName}"./*COLUMN*/ = "${stepName}"."${businessKeyName}"`;
    }
    return `\nLEFT JOIN ${lookupString} "${stepName}"\nON "${firstSourceName}"./*COLUMN*/ = "${stepName}"./*COLUMN*/`;
};
const GenerateMacroLookup = (macro, location, name) => {
    return `{{ ${macro}('${location}', '${name}') }}`;
};
exports.GenerateMacroLookup = GenerateMacroLookup;
const GetLocationFromStep = (step) => {
    if (step) {
        return step.operation.locationName;
    }
    else {
        return "";
    }
};
exports.GetLocationFromStep = GetLocationFromStep;
/**
 * Helper function to Generate a Create override SQL statement using Coalesce's staging macro
 * @param steps
 * @param stepCounters
 * @returns
 */
const GenerateCustomSQL = (steps, stepCounters, name, location) => {
    //iterate through all of the columns of the steps and generate the Select Statement
    let customSQL = "SELECT ";
    let joinString = "FROM ";
    let firstSource;
    stepCounters.forEach((stepCounter, index) => {
        var _c, _d;
        const stepData = steps[stepCounter];
        if (!stepData)
            return;
        const columns = ((_d = (_c = stepData.operation) === null || _c === void 0 ? void 0 : _c.metadata) === null || _d === void 0 ? void 0 : _d.columns) || [];
        columns.forEach((column, index) => {
            const { name } = column;
            customSQL += `\n ${name} AS ${name}`;
            if (index !== columns.length - 1) {
                customSQL += ",";
            }
        });
        const location = (0, exports.GetLocationFromStep)(stepData);
        const name = StepOperations.GetStepName(stepData);
        const lookup = (0, exports.GenerateMacroLookup)(MacroOperations.RefMacros.ref, location, name);
        if (index === 0) {
            firstSource = lookup;
            joinString += lookup;
        }
        else {
            joinString += generateInnerJoinString(lookup, firstSource, name);
        }
    });
    return `{{ stage('Override Create SQL') }}
	CREATE OR REPLACE VIEW {{ ref('${location}', '${name}')}} AS (
		${customSQL}\n ${joinString}
	)`;
};
exports.GenerateCustomSQL = GenerateCustomSQL;
const generateJoinString = (steps, predecessors) => {
    let joinString = "FROM ";
    let firstSourceLookup;
    let firstSourceName;
    let customSources = "";
    if (!predecessors.length)
        return "";
    try {
        predecessors.forEach((stepCounter, index) => {
            let location = (0, exports.GetLocationFromStep)(steps[stepCounter]);
            let name = StepOperations.GetStepName(steps[stepCounter]);
            let lookup = (0, exports.GenerateMacroLookup)(MacroOperations.RefMacros.ref, location, name);
            if (!firstSourceLookup) {
                firstSourceLookup = lookup;
                firstSourceName = name;
                joinString += `${firstSourceLookup} "${firstSourceName}"`;
            }
            else {
                if (steps[stepCounter].operation.sqlType == ESQLType.dimension || steps[stepCounter].operation.sqlType == ESQLType.persistentStage) {
                    const businessKeys = StepOperations.getColumnsWithCondition(steps[stepCounter].operation.metadata.columns, StepOperations.isPrimaryBusinessKey);
                    if (!(businessKeys === null || businessKeys === void 0 ? void 0 : businessKeys.length)) {
                        joinString += generateLeftJoinString(lookup, firstSourceName, name, "/*COLUMN*/");
                    }
                    else {
                        businessKeys.forEach((businessKey, index) => {
                            !index ?
                                joinString += generateLeftJoinString(lookup, firstSourceName, name, businessKey.name) :
                                joinString += `\nAND "${firstSourceName}"./*COLUMN*/ = "${name}"."${businessKey.name}"`;
                        });
                    }
                }
                else {
                    joinString += generateInnerJoinString(lookup, firstSourceName, name);
                }
            }
        });
    }
    catch (error) {
        joinString = "There was an error creating the joinString.  Please check your dependencies!";
    }
    if (customSources.length) {
        customSources += "\n\n\n\n";
    }
    customSources += joinString;
    return customSources;
};
exports.generateJoinString = generateJoinString;
/*
 * Used to populate a starter value in a view's custom sql area - we do this instead
 * of rendering the template because we don't want to render the lookups
 */
const GenerateSelectStatementForCustomOverride = (allSteps, currentStep, workspaceData) => {
    const stepData = allSteps[currentStep];
    const hydratedMetadata = hydrateColumnMetadata(stepData.operation.metadata, allSteps, workspaceData);
    return `SELECT ${hydratedMetadata.columns.map((col, index) => {
        const transform = `"${stepData.operation.name}"."${col.name}"`;
        if (!index) {
            return `${transform} AS ${col.name}`;
        }
        else {
            return `\n		${transform} AS ${col.name}`;
        }
    })} \nFROM {{ ref('${stepData.operation.locationName}', '${stepData.operation.name}') }} "${stepData.operation.name}"`;
};
exports.GenerateSelectStatementForCustomOverride = GenerateSelectStatementForCustomOverride;
const getSourceMapFromOperationSafe = (operation, index) => {
    if (!operation.metadata.sourceMapping) {
        console.error("Source mapping doesn't exist", operation);
        throw new Error("Step doesn't have a sourceMapping attribute");
    }
    else {
        return operation.metadata.sourceMapping[index];
    }
};
exports.getSourceMapFromOperationSafe = getSourceMapFromOperationSafe;
const getUpdatedSourceMapName = (sourceMap, newName) => {
    return Immer.produce(sourceMap, draftState => {
        draftState.name = newName;
    });
};
exports.getUpdatedSourceMapName = getUpdatedSourceMapName;
const getUpdatedSourceMapJoin = (sourceMap, newJoin) => {
    return Immer.produce(sourceMap, draftState => {
        draftState.join.joinCondition = newJoin;
    });
};
exports.getUpdatedSourceMapJoin = getUpdatedSourceMapJoin;
const getUpdatedSourceMapping = (sourceMapping, newSourceMap, index) => {
    return Immer.produce(sourceMapping, draftState => {
        draftState[index] = newSourceMap;
    });
};
exports.getUpdatedSourceMapping = getUpdatedSourceMapping;
/*
 *TransformTemplates contains tokens that can be used in the inline col transform and col editor.
 *Typing this syntax (i.e. {{SRC}}) in the editor will return
 *the SQL below in GetTransformTemplateStrings, which is called in hydrateTransform
 */
var ETransformTemplates;
(function (ETransformTemplates) {
    ETransformTemplates["Source"] = "{{SRC}}";
    ETransformTemplates["SourceColumn"] = "{{SRC_COL}}";
    ETransformTemplates["SourceNode"] = "{{SRC_NODE}}";
})(ETransformTemplates = exports.ETransformTemplates || (exports.ETransformTemplates = {}));
/*
 *Used to provide information to the SComponents.MonacoTooltip, typing exists in SComponents
 */
exports.TransformTokenDescriptions = {
    source: { title: ETransformTemplates.Source, description: "Resolves to fully qualified source column name" },
    sourceColumn: { title: ETransformTemplates.SourceColumn, description: "Resolves to source column name of the column" },
    sourceNode: { title: ETransformTemplates.SourceNode, description: "Resolves to source node name of the column" }
};
exports.GetTransformTemplateStrings = {
    [ETransformTemplates.SourceNode]: ({ tableName }) => `"${tableName}"`,
    [ETransformTemplates.SourceColumn]: ({ columnName }) => `"${columnName}"`,
    [ETransformTemplates.Source]: ({ tableName, columnName }) => `"${tableName}"."${columnName}"`
};
const hydrateTransform = (allStepData, currentColumn, transform, index) => {
    let hydratedTransform = transform;
    const sourceColumnRefData = MetadataOperations.getSourceColumnRef(currentColumn, index);
    const sourceColumn = sourceColumnRefData.getSourceColumnLocation(0);
    const sourceStepData = allStepData[sourceColumn.stepCounter];
    //early return in event that the column doesn't have a valid sourceStep
    if (!sourceStepData || !sourceColumnRefData.isValid()) {
        return transform;
    }
    const tableName = MetadataOperations.getTableName(sourceStepData);
    const columnName = MetadataOperations.getColumnName(sourceStepData.operation, sourceColumn.columnCounter);
    //flush out the template with the full data		
    Object.values(ETransformTemplates).forEach(v => {
        while (hydratedTransform.includes(v)) {
            hydratedTransform = hydratedTransform.replace(v, exports.GetTransformTemplateStrings[v]({ tableName, columnName }));
        }
    });
    return hydratedTransform;
};
exports.hydrateTransform = hydrateTransform;
const hydrateColumnMetadata = (metadata, allSteps, workspaceData, locationName) => {
    /*
     * CD-852 account for old metadata shape from development git repos
     * make sure we're checking the versioning correctly
     */
    const hydratedMetadata = {
        columns: [],
        description: metadata.description,
        sourceMapping: metadata.sourceMapping,
        locationName: locationName,
        mappings: metadata.mapping,
        sourceNames: metadata.sourceNames,
        workspaceID: workspaceData.currentWorkspace,
        workspaceName: workspaceData.workspaces[workspaceData.currentWorkspace].name
    };
    hydratedMetadata.columns = metadata.columns.map((data) => {
        return Object.assign({}, data);
    }) || [];
    return hydratedMetadata;
};
const checkForType1Dim = (columns) => {
    return columns.every(column => !Common.getValueSafe(column, ["isChangeTracking"], false));
};
exports.checkForType1Dim = checkForType1Dim;
const getUserContextFromRunInfo = (teamID, runInfo, workspaceID) => {
    var _c, _d, _e, _f, _g, _h, _j;
    return {
        accountName: (_c = runInfo.userCredentials) === null || _c === void 0 ? void 0 : _c.snowflakeAccount,
        user: (_d = runInfo.userCredentials) === null || _d === void 0 ? void 0 : _d.snowflakeUsername,
        password: (_e = runInfo.userCredentials) === null || _e === void 0 ? void 0 : _e.snowflakePassword,
        role: ((_f = runInfo.userCredentials) === null || _f === void 0 ? void 0 : _f.snowflakeRole) || "",
        orgID: teamID,
        environmentID: workspaceID,
        warehouse: ((_g = runInfo.userCredentials) === null || _g === void 0 ? void 0 : _g.snowflakeWarehouse) || "",
        authenticator: ((_h = runInfo.userCredentials) === null || _h === void 0 ? void 0 : _h.snowflakeAuthType) || "",
        keyPairPath: ((_j = runInfo.userCredentials) === null || _j === void 0 ? void 0 : _j.snowflakeKeyPairPath) || "",
    };
};
exports.getUserContextFromRunInfo = getUserContextFromRunInfo;
const ConvertFromUserContextToSnowflakeUserCrendentials = (userContext) => {
    return {
        snowflakeAccount: userContext.accountName || "",
        snowflakeUsername: userContext.user || "",
        snowflakePassword: userContext.password || "",
        snowflakeKeyPairPath: userContext.keyPairPath || "",
        snowflakeRole: userContext.role || "",
        snowflakeWarehouse: userContext.warehouse || "",
        snowflakeAuthType: userContext.authenticator
    };
};
exports.ConvertFromUserContextToSnowflakeUserCrendentials = ConvertFromUserContextToSnowflakeUserCrendentials;
//can throw a RunError
const RunPost = (url, data) => {
    return RunnerOperations.RunPost(url, data);
};
exports.RunPost = RunPost;
var ERunStatus;
(function (ERunStatus) {
    ERunStatus["waitingToRun"] = "waitingToRun";
    ERunStatus["running"] = "running";
    ERunStatus["completed"] = "completed";
    ERunStatus["failed"] = "failed";
})(ERunStatus = exports.ERunStatus || (exports.ERunStatus = {}));
var ERunType;
(function (ERunType) {
    ERunType["deploy"] = "deploy";
    ERunType["refresh"] = "refresh";
})(ERunType = exports.ERunType || (exports.ERunType = {}));
exports.RunTypeDetails = {
    [ERunType.deploy]: {
        title: "Deploy",
        info: (runInfo) => {
            //grab commit message for display
            if (runInfo.runDetails.deployCommitMessage) {
                return "Commit: " + runInfo.runDetails.deployCommitMessage;
            }
            else {
                return "Untracked commit for deploy";
            }
        }
    },
    [ERunType.refresh]: {
        title: "Refresh",
        info: (runInfo) => {
            //check for job
            if (runInfo.runDetails.jobID) {
                return `Ran Job: ${runInfo.runDetails.jobID}`;
            }
            else {
                return "Refreshed all Nodes";
            }
        }
    }
};
exports.CustomMonacoSQLActions = {
    toUpperCase: (editorToUse, monaco) => {
        return {
            // An unique identifier of the contributed action.
            id: "To Uppercase",
            // A label of the action that will be presented to the user.
            label: "To Uppercase",
            // An optional array of keybindings for the action.
            keybindings: [
                // chord
                monaco.KeyMod.CtrlCmd | monaco.KeyCode.KEY_U
            ],
            // A precondition for this action.
            precondition: null,
            // A rule to evaluate on top of the precondition in order to dispatch the keybindings.
            keybindingContext: null,
            contextMenuGroupId: "navigation",
            contextMenuOrder: 1.5,
            /*
             * Method that will be executed when the action is triggered.
             * @param editor The editor instance is passed in as a convinience
             */
            run: function (ed) {
                // position of text
                const selection = ed.getSelection();
                // value of text
                const value = ed.getModel().getValueInRange(ed.getSelection());
                // required param
                const id = { major: 1, minor: 1 };
                // operation to execute             
                const op = { identifier: id, range: selection, text: value.toUpperCase(), forceMoveMarkers: true };
                editorToUse.executeEdits("my-source", [op]);
            }
        };
    },
    toLowerCase: (editorToUse, monaco) => {
        return {
            // An unique identifier of the contributed action.
            id: "To Lowercase",
            // A label of the action that will be presented to the user.
            label: "To Lowercase",
            // An optional array of keybindings for the action.
            keybindings: [
                // chord
                monaco.KeyMod.CtrlCmd | monaco.KeyCode.KEY_L
            ],
            // A precondition for this action.
            precondition: null,
            // A rule to evaluate on top of the precondition in order to dispatch the keybindings.
            keybindingContext: null,
            contextMenuGroupId: "navigation",
            contextMenuOrder: 1.5,
            /*
             * Method that will be executed when the action is triggered.
             * @param editor The editor instance is passed in as a convinience
             */
            run: function (ed) {
                // position of text
                const selection = ed.getSelection();
                // value of text
                const value = ed.getModel().getValueInRange(ed.getSelection());
                // required param
                const id = { major: 1, minor: 1 };
                // operation to execute
                const op = { identifier: id, range: selection, text: value.toLowerCase(), forceMoveMarkers: true };
                editorToUse.executeEdits("my-source", [op]);
            }
        };
    }
};
const initializeEditorForSQL = (editorToUse, monaco) => {
    Object.keys(exports.CustomMonacoSQLActions).forEach(action => {
        editorToUse.addAction(exports.CustomMonacoSQLActions[action](editorToUse, monaco));
    });
};
exports.initializeEditorForSQL = initializeEditorForSQL;
const RunResyncSource = (locations, operation, userContext, macros) => {
    /*
     * const location = getLocation(currentStepData.operation.locationID)
     * update to take all locations, and stepData.operation
     */
    return (0, exports.RunDescTable)(locations, operation, userContext, macros)
        .then((results) => {
        const snowflakeColumns = (0, exports.createSourceInputColumns)(results);
        return snowflakeColumns;
    });
};
exports.RunResyncSource = RunResyncSource;
//# sourceMappingURL=Runner.js.map