"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateRunSQLWithoutScheduler = exports.RunAnyTemplateWithoutScheduler = exports.CreateRunSQLWithScheduler = void 0;
const RunnerOperations = __importStar(require("./RunnerOperations"));
const Logging = __importStar(require("./Logging"));
const RunnerLogger = Logging.GetLogger(Logging.LoggingArea.Runner);
const CreateRunSQLWithScheduler = (token) => {
    return (templateParams) => {
        return RunnerOperations.RunAnyTemplateWithScheduler(templateParams, token);
    };
};
exports.CreateRunSQLWithScheduler = CreateRunSQLWithScheduler;
const RunAnyTemplateWithoutScheduler = (templateParams, teamDetailsAndFirebase, connectionCache) => {
    const startTime = new Date();
    return RunnerOperations.RunSQLWithoutScheduler(templateParams, teamDetailsAndFirebase, connectionCache)
        .then((result) => {
        const queryResult = RunnerOperations.GetQueryResultFromTemplateRunResult(result, startTime);
        return queryResult;
    })
        .catch((error) => {
        const context = {};
        if (!!templateParams.userContext) {
            context.orgID = templateParams.userContext.orgID;
            context.envID = templateParams.userContext.environmentID;
        }
        RunnerLogger.errorContext(context, "Got failure on template execution", error);
        throw error;
    });
};
exports.RunAnyTemplateWithoutScheduler = RunAnyTemplateWithoutScheduler;
const CreateRunSQLWithoutScheduler = (teamInfoAndFirebase, connectionCache) => {
    return (templateParams) => {
        return (0, exports.RunAnyTemplateWithoutScheduler)(templateParams, teamInfoAndFirebase, connectionCache);
    };
};
exports.CreateRunSQLWithoutScheduler = CreateRunSQLWithoutScheduler;
//# sourceMappingURL=SQLExecutorCreators.js.map