"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetOrgData = exports.UpdateCurrentUserPasswordFirebaseAuth = exports.createOrUpdateSuperUserAdmin = exports.AdminUserComponentsOnFinishAddUser = exports.AdminUserComponentsOnFinishEditUser = exports.RunPostUpdateFirestoreUserForAdmins = exports.SendNewUserPasswordChangeEmail = exports.RunPostAddUserFirestoreDocForAdmins = exports.GetUserEmailFromState = exports.EAccountTypes = exports.isValidRoleForCreation = exports.RecursivelyBatchFirebaseDocs = exports.GetTeamDataAdmin = exports.GetTeamData = exports.useFirestoreAuthDetails = exports.tailModalLayout = exports.modalLayout = exports.OnFinishEditOrg = exports.DeleteOrgAdmin = exports.deleteOrg = exports.createOrg = exports.CreateOrgAdmin = exports.passwordRegex = exports.listenOrgChangeCb = exports.onFinishUserEdit = exports.UpdateUserDetailsFirestore = exports.createOrUpdateUserAdmin = exports.deleteUserAdmin = exports.GenerateUserIDWithAuthority = exports.listenUserChangeCb = exports.useGetNameFromUserID = exports.useUserID = exports.GetLoginFailureCode = exports.getUserIDFromState = exports.getUserRoleFromState = exports.getOrgNameFromState = exports.getOrgIDFromState = exports.loginFailureCodes = exports.useSSOInfo = exports.useGetOrgIDAndSubdomain = exports.clientGetCustomToken = exports.EUserRoles = exports.FirebaseBatchOperations = exports.EAuthorityOptions = exports.getOktaUserInfoEndpoint = exports.getOktaTokenEndpoint = exports.getAuthServerBase = void 0;
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const Firebase = __importStar(require("./Firebase"));
const CommonOperations = __importStar(require("./CommonOperations"));
const State = __importStar(require("./State"));
const Runner = __importStar(require("./Runner"));
const Common = __importStar(require("./Common"));
const Logging = __importStar(require("./Logging"));
const L = Logging.GetLogger(Logging.LoggingArea.Firebase);
/*
 *  SSO
 * helper functions for OIDC endpoints
 */
const getAuthServerBase = (authServer) => {
    return `${authServer}`;
};
exports.getAuthServerBase = getAuthServerBase;
const getOktaTokenEndpoint = (authServer) => {
    return `${(0, exports.getAuthServerBase)(authServer)}/oauth2/v1/token`;
};
exports.getOktaTokenEndpoint = getOktaTokenEndpoint;
const getOktaUserInfoEndpoint = (authServer) => {
    return `${(0, exports.getAuthServerBase)(authServer)}/oauth2/v1/userinfo`;
};
exports.getOktaUserInfoEndpoint = getOktaUserInfoEndpoint;
var EAuthorityOptions;
(function (EAuthorityOptions) {
    EAuthorityOptions["okta"] = "okta";
    EAuthorityOptions["azure"] = "azure";
})(EAuthorityOptions = exports.EAuthorityOptions || (exports.EAuthorityOptions = {}));
var FirebaseBatchOperations;
(function (FirebaseBatchOperations) {
    FirebaseBatchOperations["set"] = "set";
    FirebaseBatchOperations["delete"] = "delete";
})(FirebaseBatchOperations = exports.FirebaseBatchOperations || (exports.FirebaseBatchOperations = {}));
var EUserRoles;
(function (EUserRoles) {
    EUserRoles["ADMIN"] = "Admin";
    EUserRoles["USER"] = "User";
    EUserRoles["SUPER_USER"] = "SuperUser";
})(EUserRoles = exports.EUserRoles || (exports.EUserRoles = {}));
;
//client-side function for getting a custom token to login to firebase
const clientGetCustomToken = (tokenToVerify, orgID, codeVerifier, redirect_uri) => {
    return Runner.RunPost(Common.START_RUN_URL + `/scheduler/customToken?code=${tokenToVerify}&orgID=${orgID}&codeVerifier=${codeVerifier}&redirect_uri=${redirect_uri}&authority=${EAuthorityOptions.okta}`, {}).then((res) => {
        return res.data.customToken;
    }).catch((err) => {
        throw err;
    });
};
exports.clientGetCustomToken = clientGetCustomToken;
//based on the window location - determien the orgID and subdomain
const useGetOrgIDAndSubdomain = () => {
    const [orgIDAndSubdomain, setOrgIDAndSubdomain] = (0, react_1.useState)(null);
    (0, react_1.useEffect)(() => {
        const hostname = window.location.hostname;
        const hostnameParts = hostname.split(".");
        if (hostname === "app") {
            setOrgIDAndSubdomain(null);
            return;
        }
        else if (window.ORG_ID) {
            setOrgIDAndSubdomain([window.ORG_ID, hostname]);
        }
        const subdomain = hostnameParts[0];
        CommonOperations.getOrgsPublicCollection().where("dnsName", "==", subdomain).get().then((querySnapshot) => {
            if (querySnapshot.size !== 1) {
                //this should never happen 
                L.error("unable to find exact orgID, duplicate entries for dnsName?", subdomain);
            }
            else {
                setOrgIDAndSubdomain([querySnapshot.docs[0].id, subdomain]);
            }
        });
    }, []);
    return orgIDAndSubdomain;
};
exports.useGetOrgIDAndSubdomain = useGetOrgIDAndSubdomain;
/**
 * client-side hook that returns relevant SSOInformation
 * @return null if sso isn't applicable
 * @return sso info for the org bad on window subdomain
 * NOTE: has an override for dev environments for a special user that has SSO setup
 */
const useSSOInfo = () => {
    const orgID = (0, exports.useGetOrgIDAndSubdomain)();
    const [ssoInfo, setSSOInfo] = (0, react_1.useState)(null);
    (0, react_1.useEffect)(() => {
        if (!orgID) {
            setSSOInfo(null);
            return;
        }
        console.assert(orgID.length === 2);
        CommonOperations.getOrgPublicDocRef(orgID[0]).get().then((doc) => {
            if (!doc.data()) {
                /*
                 * this is a workaround for when the org data doesnt exist.
                 * this can happen sometimes when we are hardcoding the org for localhost - but are connecting to qa or prod
                 * and looking up by that org
                 */
                L.error("on data for org when looking up sso info", orgID);
                setSSOInfo(null);
                return;
            }
            setSSOInfo({
                authServer: doc.data().authServer,
                subdomain: orgID[1],
                orgID: orgID[0],
                clientID: doc.data().clientID,
                authority: doc.data().authority
            });
        });
    }, [orgID, setSSOInfo]);
    return ssoInfo;
};
exports.useSSOInfo = useSSOInfo;
//END SSO CODE 
// LOGIN code 
exports.loginFailureCodes = {
    invalidLogin: "Email/password is incorrect",
    badEmail: "Please enter a valid email address",
    mysteryError: "Login attempt failed. Our best and brightest scientists are currently working to figure out why"
};
const getOrgIDFromState = (state) => {
    return state.auth.fbTeamID;
};
exports.getOrgIDFromState = getOrgIDFromState;
/**
 * wrong, is bug for support page and git footer
 * @param state
 * @returns
 */
const getOrgNameFromState = (state) => {
    return state.orgData.orgName;
};
exports.getOrgNameFromState = getOrgNameFromState;
const getUserRoleFromState = (state) => {
    return state.auth.fbRole;
};
exports.getUserRoleFromState = getUserRoleFromState;
const getUserIDFromState = (state) => {
    return state.auth.fbUserID;
};
exports.getUserIDFromState = getUserIDFromState;
const GetLoginFailureCode = (error) => {
    switch (error) {
        case "auth/user-not-found":
        case "auth/wrong-password":
            return exports.loginFailureCodes.invalidLogin;
        case "auth/invalid-email":
            return exports.loginFailureCodes.badEmail;
        default:
            return exports.loginFailureCodes.mysteryError;
    }
};
exports.GetLoginFailureCode = GetLoginFailureCode;
const useUserID = () => {
    return (0, react_redux_1.useSelector)((state) => (0, exports.getUserIDFromState)(state));
};
exports.useUserID = useUserID;
const useGetNameFromUserID = () => {
    return (0, react_1.useCallback)((userID) => {
        return Firebase.getFirestore().collection("users").doc(userID).get().then((doc) => {
            let name = "";
            const user = doc.data();
            if (user) {
                name += user["firstName"] + " ";
                name += user["lastName"];
            }
            return name;
        });
    }, []);
};
exports.useGetNameFromUserID = useGetNameFromUserID;
const listenUserChangeCb = (change, dispatch) => {
    const { doc, type } = change;
    if (type === "added") {
        dispatch(State.getAddUserAction(doc.id, doc.data()));
    }
    else if (type === "modified") {
        dispatch(State.getUpdateUserAction(doc.id, doc.data()));
    }
    else if (type === "removed") {
        dispatch(State.getDeleteUserAction(doc.id));
    }
    else {
        console.log("unknown update type", type);
        console.assert(false);
    }
};
exports.listenUserChangeCb = listenUserChangeCb;
const GenerateUserIDWithAuthority = (userID, authority) => {
    return `${authority}-${userID}`;
};
exports.GenerateUserIDWithAuthority = GenerateUserIDWithAuthority;
const deleteUserAdmin = (firestore, userID) => {
    const userDocRef = CommonOperations.getUserDocRefAdmin(firestore, userID);
    return userDocRef.delete();
};
exports.deleteUserAdmin = deleteUserAdmin;
const createOrUpdateUserAdmin = (firestore, userID, orgID, email, firstName, lastName, role) => {
    const userDocRef = CommonOperations.getUserDocRefAdmin(firestore, userID);
    const newUser = {
        currentTeam: orgID,
        firstName, lastName,
        role,
        email
    };
    return userDocRef.set(newUser);
};
exports.createOrUpdateUserAdmin = createOrUpdateUserAdmin;
const UpdateUserDetailsFirestore = (userUpdates, token, userID) => {
    const url = Common.START_RUN_URL + `/scheduler/updateUserSuperUser?token=${token}`;
    const userDetails = Object.assign(Object.assign({}, userUpdates), { userID });
    return Runner.RunPost(url, userDetails);
};
exports.UpdateUserDetailsFirestore = UpdateUserDetailsFirestore;
const onFinishUserEdit = (values, userID, handleSuccess, errorHandler, infoAlert) => {
    var _a;
    const filteredValues = {};
    Object.keys(values).forEach((value) => {
        if (values[value] !== undefined) {
            filteredValues[value] = values[value];
        }
    });
    const fbToken = (_a = Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.refreshToken; //TODO: CD-1318
    return (0, exports.UpdateUserDetailsFirestore)(filteredValues, fbToken, userID)
        .then(() => {
        handleSuccess();
        infoAlert("User updated!");
    })
        .catch(error => {
        var _a;
        alert(((_a = error.error) === null || _a === void 0 ? void 0 : _a.errorString) || `${error} - please check console for details`);
        console.error(error);
    });
};
exports.onFinishUserEdit = onFinishUserEdit;
const listenOrgChangeCb = (change, dispatch) => {
    const { doc, type } = change;
    if (type === "added") {
        dispatch(State.getAddOrgAction(doc.id, doc.data()));
    }
    else if (type === "modified") {
        dispatch(State.getUpdateOrgAction(doc.id, doc.data()));
    }
    else if (type === "removed") {
        dispatch(State.getDeleteOrgAction(doc.id));
    }
    else {
        console.log("unknown update type", type);
        console.assert(false);
    }
};
exports.listenOrgChangeCb = listenOrgChangeCb;
exports.passwordRegex = new RegExp("(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)(?=.*[!\"#$%&'()*+,-.\\/:;<=>?@[\\]\\^_`{|}~]).{8,}");
const CreateOrgAdmin = (firestore, newOrgInfo) => {
    const doc = firestore.collection("orgs").doc();
    const orgCreateObj = Object.assign(Object.assign({}, newOrgInfo), { createdAt: new Date() });
    return doc.set(orgCreateObj).then(() => {
        return {
            orgID: doc.id, orgName: newOrgInfo.orgName
        };
    }).catch(err => {
        L.error("error creating org with admin", err);
        throw err;
    });
};
exports.CreateOrgAdmin = CreateOrgAdmin;
const createOrg = (values) => {
    const doc = Firebase.getFirestore().collection("orgs").doc();
    return doc.set(values).then(() => {
        return {
            orgID: doc.id, orgName: values.orgName
        };
    });
};
exports.createOrg = createOrg;
const deleteOrg = (orgID) => {
    const orgRef = Firebase.getFirestore().collection("orgs").doc(orgID);
    return (0, exports.RecursivelyBatchFirebaseDocs)(Firebase.getFirestore(), [], orgRef, FirebaseBatchOperations.delete);
};
exports.deleteOrg = deleteOrg;
const DeleteOrgAdmin = (firestore, orgID) => {
    const orgRef = firestore.collection("orgs").doc(orgID);
    return (0, exports.RecursivelyBatchFirebaseDocs)(firestore, [], orgRef, FirebaseBatchOperations.delete);
};
exports.DeleteOrgAdmin = DeleteOrgAdmin;
const OnFinishEditOrg = (values, orgID, handleSuccess, errorHandler) => {
    const filteredValues = {};
    Object.keys(values).forEach((key) => {
        if (values[key] !== undefined) {
            filteredValues[key] = values[key];
        }
    });
    return Firebase.getFirestore().collection("orgs").doc(orgID).update(filteredValues)
        .then(() => {
        handleSuccess();
    })
        .catch(errorHandler);
};
exports.OnFinishEditOrg = OnFinishEditOrg;
exports.modalLayout = {
    labelCol: { span: 8 },
    wrapperCol: { span: 16 },
};
exports.tailModalLayout = {
    wrapperCol: { offset: 8, span: 16 },
};
const useFirestoreAuthDetails = () => {
    const teamInfo = (0, react_redux_1.useSelector)(state => state.auth);
    return teamInfo;
};
exports.useFirestoreAuthDetails = useFirestoreAuthDetails;
const GetTeamData = (userID, email) => {
    return Firebase.getFirestore().collection("users").doc(userID).get()
        .then((userDoc) => {
        var _a, _b, _c, _d, _e, _f;
        const role = (_a = userDoc.data()) === null || _a === void 0 ? void 0 : _a.role;
        const payload = {
            fbEmail: (_b = userDoc.data()) === null || _b === void 0 ? void 0 : _b.email,
            fbRole: role,
            fbUserID: userID,
            fbTeamID: (_c = userDoc.data()) === null || _c === void 0 ? void 0 : _c.currentTeam,
            fbOrg: (_d = userDoc.data()) === null || _d === void 0 ? void 0 : _d.organization,
            fbFullName: `${(_e = userDoc.data()) === null || _e === void 0 ? void 0 : _e.firstName} ${(_f = userDoc.data()) === null || _f === void 0 ? void 0 : _f.lastName}`
        };
        return payload;
    }).catch(error => {
        console.error("error in get team data", error);
        throw new Error(error);
    });
};
exports.GetTeamData = GetTeamData;
const GetTeamDataAdmin = (firestore, userID) => {
    return firestore.collection("users").doc(userID).get()
        .then((userDoc) => {
        var _a, _b, _c, _d, _e;
        const role = (_a = userDoc.data()) === null || _a === void 0 ? void 0 : _a.role;
        const payload = {
            fbEmail: "",
            fbRole: role,
            fbUserID: userID,
            fbTeamID: (_b = userDoc.data()) === null || _b === void 0 ? void 0 : _b.currentTeam,
            fbOrg: (_c = userDoc.data()) === null || _c === void 0 ? void 0 : _c.organization,
            fbFullName: `${(_d = userDoc.data()) === null || _d === void 0 ? void 0 : _d.firstName} ${(_e = userDoc.data()) === null || _e === void 0 ? void 0 : _e.lastName}`
        };
        return payload;
    }).catch(error => {
        throw new Error(error);
    });
};
exports.GetTeamDataAdmin = GetTeamDataAdmin;
/**
 * Perform batch operations on every doc and collection underneath the given doc ref except collections specified to skip (set will copy, delete will fully delete)
 * @param firestore firestore app used to get doc refs
 * @param collectionsToSkip any collections with names fully matching any string passed in to this array will be skipped in the batching
 * @param batchFromDocRef docRef where information will be pulled from
 * @param operationType get, set, or delete the batched data; set requires a writeToDocRef
 * @param writeToDocRef doc ref that data will be copied into if operation type is set; not used for other operations
 */
const RecursivelyBatchFirebaseDocs = (firestore, collectionsToSkip, batchFromDocRef, operationType, writeToDocRef) => {
    return new Promise((resolveCopy, rejectCopy) => {
        const skipSet = new Set(collectionsToSkip);
        let transactionBatch = firestore.batch();
        let transactions = 0;
        let batches = 0;
        let batchesComplete = 0;
        let docsTotal = 0;
        let skippedDocsFromError = [];
        const nextDoc = (fromDocRef, toDocRef) => {
            return new Promise((resolveNextDoc, rejectNextDoc) => {
                const handleAddedTransaction = () => {
                    ++transactions;
                    if (transactions >= 450) { //firebase only allows batches up to 500 at a time (450 gives a buffer for anything weird happening)
                        docsTotal = docsTotal + transactions;
                        ++batches;
                        L.info(`Committing intermediate batch #${batches}, docs to commit:${transactions}`);
                        transactions = 0;
                        const thisBatch = batches;
                        transactionBatch.commit().then(() => {
                            batchesComplete++;
                            L.info(`Batch #${thisBatch} successfully committed`);
                        }).catch(err => {
                            rejectNextDoc(`Problem with batch on doc:${fromDocRef.path}, batches written successfully:${batchesComplete}; error:${err.toString()}`);
                        });
                        transactionBatch = firestore.batch(); /*creates a new batch immediately after commit is started; if it waits for the commit to finish,
                        other docs could attempt to add to the batch mid-commit and they would never be written to firebase*/
                    }
                };
                const handleCollections = () => {
                    fromDocRef.listCollections().then(collections => {
                        //if collections exist, recursively call nextDoc on each doc inside each collection until we reach the end of all the nested collections
                        if (!!!collections.length) {
                            resolveNextDoc();
                        }
                        else {
                            /*
                             * the array index may hit the end of the function in the wrong order if there's a significant difference in the number of docs in
                             * different collections so instead we need to use our own variable that's incremented in the .then()
                             * after the Promise.all to ensure we're on the last collection
                             */
                            let collectionIndex = 0;
                            collections.forEach(collection => {
                                if (skipSet.has(collection.id)) {
                                    collectionIndex++;
                                    return;
                                }
                                let docPromiseArr = [];
                                fromDocRef.collection(collection.id).listDocuments().then(docs => {
                                    if (collection.path.split("/").length <= 3) {
                                        L.info(`starting collection:${collection.path} length:${docs.length}`);
                                    }
                                    docs.forEach(doc => {
                                        const newWriteToDocRef = operationType === FirebaseBatchOperations.set ? toDocRef.collection(collection.id).doc(doc.id) : undefined;
                                        const thisDocRef = fromDocRef.collection(collection.id).doc(doc.id);
                                        docPromiseArr.push(nextDoc(thisDocRef, newWriteToDocRef));
                                    });
                                    Promise.all(docPromiseArr).then(() => {
                                        if (collection.path.split("/").length <= 3) {
                                            L.info(`resolving collection:${collection.path}`);
                                        }
                                        if (collectionIndex === collections.length - 1) {
                                            if (fromDocRef.path.split("/").length <= 3) {
                                                L.info(`resolving doc:${fromDocRef.path}`);
                                            }
                                            resolveNextDoc();
                                        }
                                        else {
                                            collectionIndex++;
                                            return;
                                        }
                                    });
                                });
                            });
                        }
                    });
                };
                if (operationType === FirebaseBatchOperations.set) {
                    fromDocRef.get().then(data => {
                        if (!!data) {
                            try {
                                transactionBatch.set(toDocRef, data.data());
                                handleAddedTransaction();
                            }
                            catch (_a) {
                                skippedDocsFromError.push(fromDocRef.path);
                                resolveNextDoc();
                            }
                        }
                        handleCollections();
                    }).catch(err => {
                        rejectNextDoc(`Problem retrieving firebase data for copying; doc:${fromDocRef.path}; transactions/batches/docsTotal:${transactions}/${batches}/${docsTotal};
							error:${err.toString()}`);
                    });
                }
                else if (operationType === FirebaseBatchOperations.delete) {
                    transactionBatch.delete(fromDocRef);
                    handleAddedTransaction();
                    handleCollections();
                }
                else {
                    rejectCopy("invalid operation type");
                }
            });
        };
        // need to ensure all batches are done in the background before moving on
        const checkAllBatchesComplete = () => {
            return new Promise((resolve, reject) => {
                const checkBatches = () => {
                    if (batchesComplete === batches) {
                        resolve();
                    }
                    else {
                        setTimeout(() => {
                            checkBatches();
                        }, 1000);
                    }
                };
                checkBatches();
            });
        };
        if (operationType === FirebaseBatchOperations.set && !writeToDocRef) {
            throw new Error("writeToDocRef must be provided for 'set' operations with this function");
        }
        nextDoc(batchFromDocRef, writeToDocRef).then(() => {
            if (transactions > 0) {
                docsTotal = docsTotal + transactions;
                ++batches;
                L.info(`Committing final batch #${batches}, docs to commit:${transactions}`);
                transactionBatch.commit().then(() => {
                    ++batchesComplete;
                    checkAllBatchesComplete().then(() => {
                        if (skippedDocsFromError.length > 0) {
                            L.info(`The following docs were skipped due to errors. This may be due to ghost records and should be manually checked. Docs:`, skippedDocsFromError.join(", "));
                        }
                        L.info(`Doc batch operation completed successfully, total docs committed:${docsTotal}`);
                        resolveCopy();
                    });
                }).catch(err => {
                    rejectCopy(`Problem on final batch commit: ${err}`);
                });
            }
            else {
                checkAllBatchesComplete().then(() => {
                    L.info(`Doc batch operation completed successfully, total docs committed:${docsTotal}`);
                    resolveCopy();
                });
            }
        }).catch(err => {
            L.error(`nextDoc error in RecursivelyBatchFirebaseDocs; transactions/batches/docsTotal:${transactions}/${batches}/${docsTotal}; error:${err.toString()}`);
            rejectCopy(err);
        });
    });
};
exports.RecursivelyBatchFirebaseDocs = RecursivelyBatchFirebaseDocs;
// ===== TEAMS - START =====
const FirebaseLogger = Logging.GetLogger(Logging.LoggingArea.Firebase);
const isValidRoleForCreation = (role) => {
    const roleValuesArr = Object.values(EUserRoles);
    return roleValuesArr.includes(role) && role !== EUserRoles.SUPER_USER;
};
exports.isValidRoleForCreation = isValidRoleForCreation;
var EAccountTypes;
(function (EAccountTypes) {
    EAccountTypes["sso"] = "SSO";
    EAccountTypes["normal"] = "normal";
})(EAccountTypes = exports.EAccountTypes || (exports.EAccountTypes = {}));
const GetUserEmailFromState = (state) => {
    return state.auth.fbEmail;
};
exports.GetUserEmailFromState = GetUserEmailFromState;
/**
 * uses the firebase auth id token of the current user (ie admin) to run runPost
 * target endpoint is /scheduler/updateUserAdmin
 * @param newUserInfo payload for the runPost
 * @returns
 */
const RunPostAddUserFirestoreDocForAdmins = (newUserInfo) => {
    return new Promise((resolve, reject) => {
        var _a;
        return (_a = Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.getIdToken().then((idToken) => {
            Common.assert(Logging.LoggingArea.Firebase, !!idToken, "firebase token missing! (RunPostAddUserFirestoreDocForAdmins)");
            const url = Common.START_RUN_URL + `/scheduler/updateUserAdmin?id_token=${idToken}`;
            const userDetails = Object.assign(Object.assign({}, newUserInfo), { email: newUserInfo.email.toLowerCase(), userID: null });
            return Runner.RunPost(url, userDetails);
        }).then((result) => {
            L.info("user successfully created (TeamOperations.RunPostAddUserFirestoreDocForAdmins)", newUserInfo);
            resolve(result);
        }).catch((error) => {
            L.error("Error initializing new user created by admin (TeamOperations.RunPostAddUserFirestoreDocForAdmins)", error);
            reject(error);
        });
    });
};
exports.RunPostAddUserFirestoreDocForAdmins = RunPostAddUserFirestoreDocForAdmins;
/**
 * Runs the firebase packaged function for sending password update emails
 * @param userDetails only passed in so that logging has access to the current orgID
 * @returns
 */
const SendNewUserPasswordChangeEmail = (userDetails) => {
    return new Promise((resolve, reject) => {
        const actionCodeSettings = { url: `${window.location.origin}/login` };
        Firebase.getFirebaseAuth().sendPasswordResetEmail(userDetails.email, actionCodeSettings)
            .then(() => {
            // Password reset email sent!
            FirebaseLogger.infoContext({ orgID: userDetails.currentTeam }, "New user password email successfully sent! (SendNewUserPasswordChangeEmail)");
            resolve();
        })
            .catch((error) => {
            FirebaseLogger.errorContext({ orgID: userDetails.currentTeam }, "Error sending new user password email (SendNewUserPasswordChangeEmail)", error);
            reject(error.message);
        });
    });
};
exports.SendNewUserPasswordChangeEmail = SendNewUserPasswordChangeEmail;
/**
 * uses the firebase auth id token of the current user (ie admin) to run runPost
 * target endpoint is /scheduler/updateUserAdmin
 * @param userUpdates
 * @param userID
 * @returns
 */
const RunPostUpdateFirestoreUserForAdmins = (userUpdates, userID) => {
    var _a;
    return (_a = Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.getIdToken().then((idToken) => {
        Common.assert(Logging.LoggingArea.Firebase, !!idToken, "firebase token missing! (HandleFinishEditUserForAdminsFirestore)");
        const url = Common.START_RUN_URL + `/scheduler/updateUserAdmin?id_token=${idToken}`;
        const userDetails = Object.assign(Object.assign({}, userUpdates), { userID });
        return Runner.RunPost(url, userDetails);
    });
};
exports.RunPostUpdateFirestoreUserForAdmins = RunPostUpdateFirestoreUserForAdmins;
/**
 * runs RunPostUpdateFirestoreUserForAdmins and then packages the result into an IOperationResult
 * @param userEditDetails
 * @param userID
 * @param orgID
 * @returns A promise containing an IOperationResult
 */
const AdminUserComponentsOnFinishEditUser = (userEditDetails, userID, orgID) => {
    const filteredDetails = {};
    for (let key in userEditDetails) {
        if (!userEditDetails[key]) {
            filteredDetails[key] = userEditDetails[key];
        }
    }
    return new Promise((resolve, reject) => {
        return (0, exports.RunPostUpdateFirestoreUserForAdmins)(userEditDetails, userID)
            .then((result) => {
            const { data, status, statusText } = result;
            const operationResult = {
                data,
                status,
                statusText,
                functionNameForLogging: "onFinishEditUser"
            };
            resolve(operationResult);
        })
            .catch((error) => {
            reject(error);
        });
    });
};
exports.AdminUserComponentsOnFinishEditUser = AdminUserComponentsOnFinishEditUser;
/**
 * runs RunPostUpdateFirestoreUserForAdmins and then packages the result into an IOperationResult, and then runs SendNewUserPasswordChangeEmail
 * This function is currently only exported so that it can be used in testing
 * password should only ever be passed in as part of testing, as a way to circumvent the random password and password reset systems
 * @param values
 * @param orgID
 * @returns
 */
const AdminUserComponentsOnFinishAddUser = (values, orgID) => {
    const hasPassword = !!values.password;
    const newPassword = hasPassword ? values.password : Common.GenerateRandomString();
    const userDetails = {
        firstName: values.firstName,
        lastName: values.lastName,
        email: values.email,
        role: values.role,
        currentTeam: orgID,
        password: newPassword,
        accountType: EAccountTypes.normal
    };
    return new Promise((resolve, reject) => {
        (0, exports.RunPostAddUserFirestoreDocForAdmins)(userDetails)
            .then((result) => {
            const { data, status, statusText } = result;
            const operationResult = {
                data,
                status,
                statusText,
                functionNameForLogging: "onFinishAddUser"
            };
            if (hasPassword) {
                resolve(operationResult);
            }
            else {
                return (0, exports.SendNewUserPasswordChangeEmail)(userDetails)
                    .then(() => {
                    resolve(operationResult);
                })
                    .catch((sendPasswordError) => {
                    reject(sendPasswordError);
                });
            }
        })
            .catch((addUserError) => {
            reject(addUserError);
        });
    });
};
exports.AdminUserComponentsOnFinishAddUser = AdminUserComponentsOnFinishAddUser;
const createOrUpdateSuperUserAdmin = (firestore, userID, orgID, email, firstName, lastName, role) => {
    const userDocRef = CommonOperations.getUserDocRefAdmin(firestore, userID);
    const newUser = {
        currentTeam: orgID,
        firstName, lastName,
        role: role || EUserRoles.SUPER_USER,
        email
    };
    return userDocRef.set(newUser);
};
exports.createOrUpdateSuperUserAdmin = createOrUpdateSuperUserAdmin;
const UpdateCurrentUserPasswordFirebaseAuth = (values, logger, userID, orgID) => {
    const credential = Firebase.justFirebase.auth.EmailAuthProvider.credential(Firebase.getFirebaseAuth().currentUser.email, values.oldPass);
    Common.assert(Logging.LoggingArea.UserSettings, !!Firebase.getFirebaseAuth().currentUser, "No current user signed in to firebase");
    //verifies the user info since we can't the user's password from the firebase .currentUser object to directly compare
    return Firebase.getFirebaseAuth().currentUser.reauthenticateWithCredential(credential)
        .then(() => {
        if (values.newPass === values.newPassReenter) {
            return Firebase.getFirebaseAuth().currentUser.updatePassword(values.newPass);
        }
        else {
            throw Error("New Password reenter does not match new password!");
        }
    })
        .then(() => {
        logger.infoContext({ userID, orgID }, "password succesfully updated using security settings tab");
        return null;
    })
        .catch((err) => {
        logger.alertContext({ userID, orgID }, "(SecurityTab) Error: error updating user password", err);
        throw Error(err);
    });
};
exports.UpdateCurrentUserPasswordFirebaseAuth = UpdateCurrentUserPasswordFirebaseAuth;
const GetOrgData = (orgID) => {
    const docRef = CommonOperations.getOrgDataDocRef(orgID);
    return docRef.get()
        .then(doc => {
        const orgData = doc.data();
        return orgData;
    });
};
exports.GetOrgData = GetOrgData;
//# sourceMappingURL=TeamOperations.js.map