"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useUserDefinedStepTypesYAML = exports.ValidateMultipleRunTypesAndReturnSuccessOrErrorMessages = exports.ValidateRunTypeWithThrow = exports.ValidateRunTypeConstraint = exports.validateRunType = exports.IsFirstClassConfigElement = exports.FirstClassConfigElement = exports.NodeSpec = exports.RStepTypesParsed = exports.RDataDotYaml = exports.RStepTypesUnparsed = exports.GetDefaultMaterializationType = exports.materializationTypes = exports.EMappingColumnType = exports.SystemColumnPlacement = exports.TabularSpec = exports.TextBoxSyntax = exports.SpecUIType = exports.isDefaultNodeType = exports.createNodeTypeRowData = exports.NodeTypeStatus = exports.NodeTypeActions = exports.useTemplateEditorState = exports.createTemplateMetadata = exports.getDeleteColumnTemplate = exports.getRenameColumnTemplate = exports.getAlterColumnTemplate = exports.getAddColumnTemplate = exports.getDeleteViewTemplate = exports.getDeleteTableTemplate = exports.getCreateTableTemplate = exports.getRemoveDeploySuffixTemplate = exports.getRenameTableTemplate = exports.getCloneTableTemplate = exports.getSwapClonedTableTemplate = exports.getDeleteClonedTableTemplate = exports.EditTypes = exports.deploySuffix = exports.getGenericTemplate = exports.GenericTemplateTypes = exports.getPreviewString = exports.areStepsEligibleForTemplates = exports.getParsedSQLStagesFromString = exports.parseSQLStagesFromTemplateStages = exports.getSQLStagesFromTemplateString = exports.ParsedSQLStageRunType = exports.EQueryResultContinueOnFailure = exports.EQueryResultType = exports.PlatformType = exports.TemplateString = void 0;
exports.ValidateRequiredConfigFlags = exports.GetTableCustomNodeAttributeChecker = exports.GetSimpleCustomNodeAttributeChecker = exports.GetSimpleNodeAttributeChecker = void 0;
const react_redux_1 = require("react-redux");
const Runner = __importStar(require("./Runner"));
const Common = __importStar(require("./Common"));
const RunnerOperations = __importStar(require("./RunnerOperations"));
const StepOperations = __importStar(require("./StepOperations"));
const R = __importStar(require("runtypes"));
const Immer = __importStar(require("immer"));
const StepTypes = __importStar(require("./StepTypes"));
const AdvancedDeployOperations = __importStar(require("./AdvancedDeployOperations"));
var TemplateString;
(function (TemplateString) {
    TemplateString["SHOW_OBJECTS_SQL"] = "SHOW OBJECTS IN ACCOUNT";
    TemplateString["SELECT_ONE_SQL"] = "select 1";
    TemplateString["SHOW_DATABASES"] = "SHOW DATABASES";
    TemplateString["SHOW_SCHEMAS"] = "SHOW SCHEMAS";
})(TemplateString = exports.TemplateString || (exports.TemplateString = {}));
var PlatformType;
(function (PlatformType) {
    PlatformType["snowflake"] = "snowflake";
})(PlatformType = exports.PlatformType || (exports.PlatformType = {}));
var EQueryResultType;
(function (EQueryResultType) {
    EQueryResultType["sql"] = "sql";
    EQueryResultType["sqlTest"] = "sqlTest";
})(EQueryResultType = exports.EQueryResultType || (exports.EQueryResultType = {}));
var EQueryResultContinueOnFailure;
(function (EQueryResultContinueOnFailure) {
    EQueryResultContinueOnFailure["true"] = "True";
    EQueryResultContinueOnFailure["false"] = "False";
})(EQueryResultContinueOnFailure = exports.EQueryResultContinueOnFailure || (exports.EQueryResultContinueOnFailure = {}));
exports.ParsedSQLStageRunType = R.Record({
    name: R.String,
    code: R.String,
    type: R.Union(R.Literal(EQueryResultType.sql), R.Literal(EQueryResultType.sqlTest)),
    continueOnFailure: R.Union(R.Literal(EQueryResultContinueOnFailure.true), R.Literal(EQueryResultContinueOnFailure.false))
});
const getSQLStagesFromTemplateString = (templateString) => {
    const templateStagesRegex = new RegExp(/coalesce_stage_start\nname: ([\s\S]*?)\ntype: ([\s\S]*?)\ncode:\n([\s\S]*?)($|---)/, "g");
    const templateStages = templateString.match(templateStagesRegex);
    return templateStages || [];
};
exports.getSQLStagesFromTemplateString = getSQLStagesFromTemplateString;
/**
 *
 * @params
 * template stage - the return value from getSQLStagesFromTemplateString
 * regex - whatever regex you want to use to grab a given attribute from the template stage
 * @returns
 * a string that is the value of the attribute that we're looking for
 */
const getSQLStageAttributeFromParsedString = (templateStage, regex) => {
    const execResult = regex.exec(templateStage);
    if (!execResult) {
        return null;
    }
    else {
        const formattedSQL = execResult[1];
        return formattedSQL;
    }
};
const parseSQLStagesFromTemplateStages = (templateStages) => {
    const output = [];
    const nameRegex = new RegExp(/name: ([\s\S]*?)\n/);
    const typeRegex = new RegExp(/type: ([\s\S]*?)\n/);
    const codeRegex = new RegExp(/code:\n([\s\S]*?\n*?)($|---)/);
    const continueOnFailureRegex = new RegExp(/continue_on_failure: ([\s\S]*?)\n/);
    templateStages.forEach((templateStage) => {
        const name = getSQLStageAttributeFromParsedString(templateStage, nameRegex);
        const code = getSQLStageAttributeFromParsedString(templateStage, codeRegex);
        const type = getSQLStageAttributeFromParsedString(templateStage, typeRegex);
        let continueOnFailure = getSQLStageAttributeFromParsedString(templateStage, continueOnFailureRegex);
        /**
         * our tests may be using older versions of template/macros, etc, so this value may be null when we don't expect it,
         * causing tests to fail, so this is a temporary quick fix
         */
        if (continueOnFailure === null) {
            continueOnFailure = "True";
        }
        output.push({
            name,
            code,
            type,
            continueOnFailure
        });
    });
    return output;
};
exports.parseSQLStagesFromTemplateStages = parseSQLStagesFromTemplateStages;
const getParsedSQLStagesFromString = (templateString) => {
    var _a;
    // parse and convert to an array of yaml docs
    const sqlStageArray = (0, exports.getSQLStagesFromTemplateString)(templateString);
    /*
     * this code is staying here until we find a solution for handling run render results/ determening when an empty sqlStageArray is an error vs not
     * if (!sqlStageArray) {
     *     return {parsedSQLStages: [], error: 'There was an error parsing your SQL, please check your templates.'}
     * } else {
     */
    const convertedSQLStageArray = (0, exports.parseSQLStagesFromTemplateStages)(sqlStageArray);
    // iterate over yaml docs array and validate the type
    const validationResults = convertedSQLStageArray.map(sqlStage => {
        return (0, exports.validateRunType)(exports.ParsedSQLStageRunType, sqlStage);
    });
    // determine if there's an invalid result
    const resultWithError = (_a = validationResults.find(result => !result.success)) !== null && _a !== void 0 ? _a : null;
    if (resultWithError) {
        return { parsedSQLStages: [], error: resultWithError.errorString };
    }
    return { parsedSQLStages: convertedSQLStageArray, error: null };
    // }
};
exports.getParsedSQLStagesFromString = getParsedSQLStagesFromString;
//steps are only eligible for use as a scratch in templates if they have SQL metadata and some kind of lineage
const areStepsEligibleForTemplates = (steps) => {
    const ineligibleTypes = [
        Runner.ESQLType.source
    ];
    return (Object.keys(steps).filter(stepCounter => {
        return !ineligibleTypes.includes(steps[stepCounter].operation.sqlType) && stepCounter !== StepOperations.scratchIDString;
    }));
};
exports.areStepsEligibleForTemplates = areStepsEligibleForTemplates;
//need to add to hydratedMetadata which source we want, or just pass it in here?
const previewStrings = {
    [PlatformType.snowflake]: () => {
        return `
            {% for source in sources %}
                {{ stage(source.name) }}
                    SELECT 
                    {% for col in source.columns %}
                        {{ get_source_transform(col) }} AS "{{ col.name }}"
                        {%- if not loop.last -%},{% endif %}
                    {% endfor %} 
                    {{ source.join }}
            {% endfor %}
            `;
    }
};
const getPreviewString = (platform) => {
    console.assert(platform === PlatformType.snowflake);
    return previewStrings[platform]();
};
exports.getPreviewString = getPreviewString;
var GenericTemplateTypes;
(function (GenericTemplateTypes) {
    GenericTemplateTypes["describe"] = "Describe";
    GenericTemplateTypes["describeView"] = "DescribeView";
    GenericTemplateTypes["custom"] = "Custom";
    GenericTemplateTypes["showTables"] = "ShowTables";
    GenericTemplateTypes["showViews"] = "ShowViews";
})(GenericTemplateTypes = exports.GenericTemplateTypes || (exports.GenericTemplateTypes = {}));
const genericTemplates = {
    Describe: () => {
        return `---
coalesce_stage_start
name: Create Describe
type: sql
code:
DESC TABLE {{ ref_no_link(nodeMetadata.destinationName, nodeMetadata.operationName)}}`;
    },
    DescribeView: () => {
        return `---
coalesce_stage_start
name: Create Describe View
type: sql
code:
DESC VIEW {{ref_no_link(nodeMetadata.destinationName, nodeMetadata.operationName)}}`;
    },
    Custom: () => {
        return `---
coalesce_stage_start
name: Create Custom
type: sql
code:
{{ nodeMetadata.sourceMapping[0].customSQL.customSQL }}`;
    },
    ShowTables: () => {
        return `---
coalesce_stage_start
name: Show Tables
type: sql
code:
SHOW TABLES LIKE '{{ nodeMetadata.operationName}}' IN SCHEMA {{ nodeMetadata.destinationName}}`;
    },
    ShowViews: () => {
        return `---
coalesce_stage_start
name: Show Views
type: sql
code:
SHOW VIEWS LIKE '{{ nodeMetadata.operationName}}' IN SCHEMA {{ nodeMetadata.destinationName}}`;
    }
};
const getGenericTemplate = (genericTemplateType) => {
    return genericTemplates[genericTemplateType]();
};
exports.getGenericTemplate = getGenericTemplate;
/**
 * Constant to define what name gets appeneded to cloned tables during Coalesce Deployment
 */
exports.deploySuffix = "_COALESCE_INTERNAL_TABLE";
//////////////////// Edit Tables
var EditTypes;
(function (EditTypes) {
    EditTypes["addMetadata"] = "AddMetadata";
    EditTypes["deleteMetadata"] = "DeleteMetadta";
    EditTypes["createTable"] = "CreateTable";
    EditTypes["cloneTable"] = "CloneTable";
    EditTypes["renameTable"] = "RenameTable";
    EditTypes["removeDeploySuffix"] = "RemoveDeploySuffix";
    EditTypes["editTableDescription"] = "EditTableDescription";
    EditTypes["deleteTable"] = "DeleteTable";
    EditTypes["deleteView"] = "DeleteView";
    EditTypes["addColumn"] = "AddColumn";
    EditTypes["alterColumn"] = "AlterColumn";
    EditTypes["renameColumn"] = "RenameColumn";
    EditTypes["deleteColumn"] = "DeleteColumn";
    EditTypes["swapClonedTable"] = "SwapClonedTable";
    EditTypes["deleteClonedTable"] = "DeleteClonedTable";
})(EditTypes = exports.EditTypes || (exports.EditTypes = {}));
/*
 * add _internal to alter
 * new template for SWAP (snowflake)
 */
const AlterTemplates = {
    [PlatformType.snowflake]: {
        [EditTypes.swapClonedTable]: () => `
        {{ stage('Swap Cloned Table') }}
        ALTER TABLE IF EXISTS {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}" SWAP WITH {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}"`,
        [EditTypes.cloneTable]: () => `
        {{ stage('Clone Table') }}
        CREATE OR REPLACE TABLE {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}" CLONE {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}"`,
        [EditTypes.renameTable]: () => `
        {{ stage('Rename Table') }}
        ALTER TABLE IF EXISTS {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}" RENAME TO {{ ref_no_link( nodeMetadata.destinationName , nodeMetadata.operationName) }}`,
        [EditTypes.removeDeploySuffix]: () => `
        {{ stage('Rename Table') }}
        ALTER TABLE IF EXISTS {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}" RENAME TO {{ nodeMetadata.oldLocation}}"{{ nodeMetadata.oldName}}"`,
        [EditTypes.deleteTable]: () => `
        {{ stage('Delete Table') }}
        DROP TABLE IF EXISTS {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}"`,
        [EditTypes.deleteView]: () => `
        {{ stage('Delete View') }}
        DROP VIEW IF EXISTS {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}"`,
        [EditTypes.addColumn]: () => `
        {{ stage('Add Column') }}
        ALTER TABLE {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}"
                                        ADD COLUMN 
                                        {% for col in nodeMetadata.addedColumns %}
                                            "{{col.name}}" {{col.dataType}} {%- if not col.nullable %} NOT NULL {%- if col.defaultValue | length > 0 %} DEFAULT {{ col.defaultValue }} {% endif %} {% endif %} {%- if col.description | length > 0 %} COMMENT '{{ col.description }}'{% endif %} {%- if not loop.last -%},{% endif %}
                                        {% endfor %}
                                        `,
        [EditTypes.alterColumn]: () => `
        {{ stage('Alter Column') }}
        ALTER TABLE {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}"
                                        ALTER (
                                        {% for colChanges in nodeMetadata.alteredColumns %}
                                            {% for type,value in colChanges.items() if not type == 'name' %}
                                                "{{colChanges.name}}" 
                                                {%- if type == 'dataType'  %} set data type {{value}} 
                                                {%- elif type == 'nullable' %} {%- if value %} DROP NOT NULL {% else %} SET NOT NULL {% endif %}
                                                {%- elif type == 'description' %} COMMENT '{{ value }}'
                                                {% endif %} 
                                                {%- if not loop.last -%},{% endif %}
                                            {% endfor %}
                                            {%- if not loop.last -%},{% endif %}
                                        {% endfor %}
        )`,
        [EditTypes.renameColumn]: () => `
        {{ stage('Rename Column') }}
        ALTER TABLE {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}"
                                            RENAME COLUMN "{{ nodeMetadata.oldColumn.name }}" TO "{{ nodeMetadata.newColumn.name }}"`,
        [EditTypes.deleteColumn]: () => `
        {{ stage('Delete Column') }}
        ALTER TABLE {{ nodeMetadata.oldLocation }}"{{ nodeMetadata.oldName}}${exports.deploySuffix}"
                                            DROP 
                                            {% for col in nodeMetadata.deletedColumns %}
                                                "{{col.name}}"
                                            {%- if not loop.last -%},{% endif %}
                                            {% endfor %}`
    }
};
const getDeleteClonedTableTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.deleteClonedTable]();
};
exports.getDeleteClonedTableTemplate = getDeleteClonedTableTemplate;
const getSwapClonedTableTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.swapClonedTable]();
};
exports.getSwapClonedTableTemplate = getSwapClonedTableTemplate;
const getCloneTableTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.cloneTable]();
};
exports.getCloneTableTemplate = getCloneTableTemplate;
const getRenameTableTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.renameTable]();
};
exports.getRenameTableTemplate = getRenameTableTemplate;
const getRemoveDeploySuffixTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.removeDeploySuffix]();
};
exports.getRemoveDeploySuffixTemplate = getRemoveDeploySuffixTemplate;
const getCreateTableTemplate = (stepTypesParsed, stepTypeID) => {
    // void case is handled further up in the call stack - exception will be thrown
    return RunnerOperations.GetTemplateStringFromStepDetails(stepTypesParsed, stepTypeID, RunnerOperations.OperationTypes.create);
};
exports.getCreateTableTemplate = getCreateTableTemplate;
const getDeleteTableTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.deleteTable]();
};
exports.getDeleteTableTemplate = getDeleteTableTemplate;
const getDeleteViewTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.deleteView]();
};
exports.getDeleteViewTemplate = getDeleteViewTemplate;
const getAddColumnTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.addColumn]();
};
exports.getAddColumnTemplate = getAddColumnTemplate;
const getAlterColumnTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.alterColumn]();
};
exports.getAlterColumnTemplate = getAlterColumnTemplate;
const getRenameColumnTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.renameColumn]();
};
exports.getRenameColumnTemplate = getRenameColumnTemplate;
const getDeleteColumnTemplate = (platformType) => {
    return AlterTemplates[platformType][EditTypes.deleteColumn]();
};
exports.getDeleteColumnTemplate = getDeleteColumnTemplate;
const createTemplateMetadata = (templateString) => {
    return {
        templateString
    };
};
exports.createTemplateMetadata = createTemplateMetadata;
const useTemplateEditorState = () => {
    return (0, react_redux_1.useSelector)(state => state.templateEditor);
};
exports.useTemplateEditorState = useTemplateEditorState;
var NodeTypeActions;
(function (NodeTypeActions) {
    NodeTypeActions["edit"] = "Edit";
    NodeTypeActions["duplicate"] = "Duplicate";
    NodeTypeActions["delete"] = "Delete";
})(NodeTypeActions = exports.NodeTypeActions || (exports.NodeTypeActions = {}));
var NodeTypeStatus;
(function (NodeTypeStatus) {
    NodeTypeStatus["healthy"] = "Healthy";
    NodeTypeStatus["hasError"] = "Has Error";
})(NodeTypeStatus = exports.NodeTypeStatus || (exports.NodeTypeStatus = {}));
const getStepTypeStatus = (stepTypeData) => {
    const isValid = StepTypes.isStepTypeValid(stepTypeData);
    if (isValid) {
        return NodeTypeStatus.healthy;
    }
    return NodeTypeStatus.hasError;
};
const createNodeTypeRowData = (stepTypeDetails) => {
    const invalidNodeTypesForTemplateEditor = [
        Runner.ESQLType.source
    ];
    let nodeTypeRowData = [];
    Object.keys(stepTypeDetails).forEach((stepType, index) => {
        if (!invalidNodeTypesForTemplateEditor.includes(stepType)) {
            nodeTypeRowData.push({
                name: StepTypes.getStepTypeNameSafe(stepTypeDetails, stepType),
                actions: [NodeTypeActions.edit, NodeTypeActions.duplicate, NodeTypeActions.delete],
                key: `${stepType}-${index}`,
                nodeType: stepType,
                isDisabled: !!StepTypes.getStepTypeIsDisabledSafe(stepTypeDetails, stepType),
                status: getStepTypeStatus(stepTypeDetails[stepType])
            });
        }
    });
    return nodeTypeRowData;
};
exports.createNodeTypeRowData = createNodeTypeRowData;
const isDefaultNodeType = (nodeType) => {
    return Object.values(Runner.ESQLType).includes(nodeType);
};
exports.isDefaultNodeType = isDefaultNodeType;
var SpecUIType;
(function (SpecUIType) {
    SpecUIType["columnSelector"] = "columnSelector";
    SpecUIType["dropdownSelector"] = "dropdownSelector";
    SpecUIType["textBox"] = "textBox";
    SpecUIType["toggleButton"] = "toggleButton";
    SpecUIType["tabular"] = "tabular";
    SpecUIType["columnDropdownSelector"] = "columnDropdownSelector";
})(SpecUIType = exports.SpecUIType || (exports.SpecUIType = {}));
//////// RUNTYPES
const ColumnSelectorSpec = R.Record({
    type: R.Literal(SpecUIType.columnSelector),
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    isRequired: R.Boolean,
    /*
     * R.Unknown - we need to make this attribute optional
     * but also give it the ability to support what it thinks
     * are objects (because of the jinja syntax). Unknown allows
     * both, as opposed to R.Dictionary which doesn't have
     * an optional method on it
     */
    enableIf: R.String.optional()
});
const DropdownSelectorSpec = R.Record({
    type: R.Literal(SpecUIType.dropdownSelector),
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    default: R.String.optional(),
    options: R.Array(R.String),
    isRequired: R.Boolean,
    enableIf: R.Unknown.optional()
});
var TextBoxSyntax;
(function (TextBoxSyntax) {
    TextBoxSyntax["sql"] = "sql";
    TextBoxSyntax["none"] = "none";
})(TextBoxSyntax = exports.TextBoxSyntax || (exports.TextBoxSyntax = {}));
const TextBoxSpec = R.Record({
    type: R.Literal(SpecUIType.textBox),
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    isRequired: R.Boolean,
    default: R.String.optional(),
    enableIf: R.Unknown.optional(),
    syntax: R.Union(R.Literal(TextBoxSyntax.sql), R.Literal(TextBoxSyntax.none)).optional()
});
const ToggleSpec = R.Record({
    type: R.Literal(SpecUIType.toggleButton),
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    default: R.Boolean.optional(),
    enableIf: R.Unknown.optional()
});
const ColumnDropdownSpec = R.Record({
    type: R.Literal(SpecUIType.columnDropdownSelector),
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    ineligibleColumns: R.Array(R.Number).optional()
});
const FirstClassConfigItem = R.Record({
    type: R.String,
    isRequired: R.Boolean.optional(),
    enableIf: R.String.optional(),
    /*
     * these bottom two attributes are to support potential defaults on
     * first class items in the future - for now this is just to support
     * materialization options
     */
    default: R.Union(R.String, R.Boolean).optional(),
    options: R.Array(R.String).optional()
});
const NonTabularSpec = R.Union(ColumnSelectorSpec, DropdownSelectorSpec, TextBoxSpec, ToggleSpec, ColumnDropdownSpec);
const RSpecUIType = Common.RuntypeFromEnum(SpecUIType);
const TableColumnsSpec = R.Record({
    type: RSpecUIType,
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    isRequired: R.Boolean.optional(),
    //displayName isn't used with tables, but needed to keep typing happy
    ineligibleColumns: R.Array(R.Number).optional()
});
exports.TabularSpec = R.Record({
    type: R.Literal(SpecUIType.tabular),
    attributeName: R.String.withConstraint(attributeName => !!attributeName.length),
    displayName: R.String,
    isRequired: R.Boolean,
    enableIf: R.Unknown.optional(),
    columns: R.Array(TableColumnsSpec)
});
const ConfigSpec = R.Union(NonTabularSpec, exports.TabularSpec);
var SystemColumnPlacement;
(function (SystemColumnPlacement) {
    SystemColumnPlacement["beginning"] = "beginning";
    SystemColumnPlacement["end"] = "end";
})(SystemColumnPlacement = exports.SystemColumnPlacement || (exports.SystemColumnPlacement = {}));
const SystemColumnSpecDef = R.Record({
    displayName: R.String,
    transform: R.String,
    dataType: R.String,
    placement: R.String,
    attributeName: R.String,
    enableIf: R.Unknown.optional()
});
var EMappingColumnType;
(function (EMappingColumnType) {
    EMappingColumnType["textBox"] = "textBox";
    /*
     * these two types won't be available for user defined columns yet, and
     * therefore aren't a part of the run type below - they're just here for enforcing
     * similar typing for our first class columns (specifically the nullable
     * column and the source mapping column)
     */
    EMappingColumnType["dropdown"] = "dropdown";
    EMappingColumnType["cascader"] = "cascader";
})(EMappingColumnType = exports.EMappingColumnType || (exports.EMappingColumnType = {}));
const MappingColumnSpec = R.Record({
    headerName: R.String,
    attributeName: R.String,
    type: R.Union(R.Literal(EMappingColumnType.textBox))
});
var materializationTypes;
(function (materializationTypes) {
    materializationTypes["table"] = "table";
    materializationTypes["view"] = "view";
})(materializationTypes = exports.materializationTypes || (exports.materializationTypes = {}));
/*
 * This is only for backwards compatibility to continue to support nodes initializaed with no materialization
 *      type, or views that default to 'view' instead of 'table'
 */
const GetDefaultMaterializationType = (SQLType) => {
    if (SQLType === Runner.ESQLType.view) {
        return materializationTypes.view;
    }
    return materializationTypes.table;
};
exports.GetDefaultMaterializationType = GetDefaultMaterializationType;
const tableViewUnion = R.Union(R.Literal(materializationTypes.table), R.Literal(materializationTypes.view));
// do we keep these two runTypes separate?
const MaterializationOptionSpecDef = R.Record({
    default: tableViewUnion,
    options: R.Array(tableViewUnion)
});
const ConfigItemUnion = R.Union(FirstClassConfigItem, ConfigSpec);
const NodeSpecConfigGroup = R.Record({
    groupName: R.String,
    description: R.String.optional(),
    items: R.Array(ConfigItemUnion),
    enableIf: R.String.optional() // TODO: support in the future
});
const NodeSpecConfig = R.Array(NodeSpecConfigGroup);
const RNodeSpec = R.Record({
    // default spec
    capitalized: R.String,
    short: R.Union(R.String, R.Void),
    tagColor: R.String,
    plural: R.String,
    // first party config
    isGhostRecordColumnsEnabled: R.Boolean.optional(),
    systemColumns: R.Array(SystemColumnSpecDef).optional(),
    isDataVaultEnabled: R.Boolean.optional(),
    isMultisourceToggleEnabled: R.Boolean.optional(),
    isOverrideSQLEnabled: R.Boolean.optional(),
    fetchDataOnSuccess: R.Boolean.optional(),
    isDMLEnabled: R.Boolean.optional(),
    isBusinessKeysEnabled: R.Boolean.optional(),
    isChangeTrackingEnabled: R.Boolean.optional(),
    materializationOptions: MaterializationOptionSpecDef.optional(),
    // deploy options - optional as not part of default node specs
    deployStrategy: R.Union(R.Literal(AdvancedDeployOperations.EDeployStrategy.default), R.Literal(AdvancedDeployOperations.EDeployStrategy.advanced)).optional(),
    // generic UI config
    config: NodeSpecConfig.optional(),
    // mapping column config
    mappingColumns: R.Array(MappingColumnSpec).optional()
});
///////// Other run types (necessary due to weird import/inclusion of below being undefined when type stacking)
const RMapping = R.Record({
    database: R.String,
    schema: R.String,
    id: R.Optional(R.Number),
    locationName: R.String
});
const REnvironment = R.Record({
    createdAt: R.Record({
        nanoseconds: R.Number,
        seconds: R.Number,
    }),
    createdBy: R.String,
    description: R.String,
    devEnv: R.Boolean,
    id: R.Union(R.String, R.Number),
    mappings: R.Dictionary(RMapping),
    name: R.String,
    oauthEnabled: R.Optional(R.Boolean),
    status: R.Optional(R.String),
});
const RJob = R.Record({
    id: R.Number,
    name: R.String,
    steps: R.Array(R.Union(R.Number, R.String)),
    subgraphs: R.Array(R.Union(R.Number, R.String))
});
const RLocation = R.Record({
    default: R.Boolean,
    id: R.Optional(R.Number),
    locationName: R.String
});
const RMacro = R.Record({
    id: R.Number,
    macroString: R.String
});
const RSubgraph = R.Record({
    id: R.Number,
    name: R.String,
    steps: R.Array(R.Union(R.String, R.Number))
});
const RNodeSpecParentUnparsed = R.Record({
    error: R.Union(R.Null, R.String),
    nodeMetadataSpec: R.String,
    templates: R.Record({
        create: R.Record({
            templateString: R.String,
        }),
        run: R.Record({
            templateString: R.String
        })
    })
});
const RNodeSpecParentParsed = R.Record({
    error: R.Union(R.Null, R.String),
    nodeMetadataSpec: RNodeSpec,
    templates: R.Record({
        create: R.Record({
            templateString: R.String,
        }),
        run: R.Record({
            templateString: R.String
        })
    })
});
const RStepTypeUnparsed = R.Record({
    id: R.String,
    isDisabled: R.Boolean,
    metadata: RNodeSpecParentUnparsed,
    name: R.String,
    version: R.Number
});
const RStepTypeParsed = R.Record({
    id: R.String,
    isDisabled: R.Boolean,
    metadata: RNodeSpecParentParsed,
    name: R.String,
    version: R.Number
});
exports.RStepTypesUnparsed = R.Dictionary(RStepTypeUnparsed);
/**
 * Run Type for a freshly parsed data.yml file
 */
exports.RDataDotYaml = R.Record({
    environments: R.Dictionary(REnvironment),
    jobs: R.Dictionary(RJob),
    locations: R.Dictionary(RLocation),
    macros: R.Dictionary(RMacro),
    stepTypes: exports.RStepTypesUnparsed,
    subgraphs: R.Dictionary(RSubgraph)
});
exports.RStepTypesParsed = R.Dictionary(RStepTypeParsed);
exports.NodeSpec = RNodeSpec;
var FirstClassConfigElement;
(function (FirstClassConfigElement) {
    FirstClassConfigElement["businessKeyColumns"] = "businessKeyColumns";
    FirstClassConfigElement["changeTrackingColumns"] = "changeTrackingColumns";
    FirstClassConfigElement["multisourceToggle"] = "multisourceToggle";
    FirstClassConfigElement["overrideSQLToggle"] = "overrideSQLToggle";
    FirstClassConfigElement["materializationSelector"] = "materializationSelector";
})(FirstClassConfigElement = exports.FirstClassConfigElement || (exports.FirstClassConfigElement = {}));
const IsFirstClassConfigElement = (configElement) => {
    return Object.values(FirstClassConfigElement).includes(configElement.type);
};
exports.IsFirstClassConfigElement = IsFirstClassConfigElement;
/**
 * Function for run time validation using the runTypes library and types above
 *
 * @param runType - a return value from R.Record
 * @param objectToValidate - whatever value we're checking against R.Record
 * @returns a validation result that returns { success: false } when the type doesn't match
 */
const validateRunType = (runType, objectToValidate) => {
    const validationResult = runType.validate(objectToValidate);
    if (validationResult.success) {
        return { success: true, errorString: null };
    }
    else {
        return { success: false, errorString: JSON.stringify(validationResult.details, null, 2) };
    }
};
exports.validateRunType = validateRunType;
// see CD-2753 - we can use this in the future. https://github.com/pelotom/runtypes#constraint-checking
const ValidateRunTypeConstraint = (runType, objectToValidate) => {
    try {
        // .check throws an exception
        runType.check(objectToValidate);
        return { success: true, errorString: null };
    }
    catch (error) {
        return { success: false, errorString: error.message };
    }
};
exports.ValidateRunTypeConstraint = ValidateRunTypeConstraint;
const ValidateRunTypeWithThrow = (runType, objectToValidate) => {
    const validationResult = (0, exports.validateRunType)(runType, objectToValidate);
    if (validationResult.errorString !== null) {
        throw new Error(validationResult.errorString);
    }
};
exports.ValidateRunTypeWithThrow = ValidateRunTypeWithThrow;
const ValidateMultipleRunTypesAndReturnSuccessOrErrorMessages = (runTypesAndObjectsToVerify) => {
    const validationResults = runTypesAndObjectsToVerify.map(({ runType, object }) => {
        return (0, exports.validateRunType)(runType, object);
    });
    const valid = validationResults.every(result => result.success);
    if (!valid) {
        const allFailedResults = validationResults.filter(result => !result.success);
        const newErrorMessage = allFailedResults.map(result => result.errorString).join(";\n");
        throw new Error(newErrorMessage);
    }
    return { success: true, errorString: null };
};
exports.ValidateMultipleRunTypesAndReturnSuccessOrErrorMessages = ValidateMultipleRunTypesAndReturnSuccessOrErrorMessages;
const useUserDefinedStepTypesYAML = () => {
    const allStepTypesYAML = (0, react_redux_1.useSelector)(state => state.stepTypesParsed);
    return Immer.produce(allStepTypesYAML, draftState => {
        const defaultStepTypes = StepTypes.getDefaultStepTypes();
        Object.keys(defaultStepTypes).forEach(baseType => {
            delete draftState[baseType];
        });
    });
};
exports.useUserDefinedStepTypesYAML = useUserDefinedStepTypesYAML;
const GetInvalidValidationResult = (errorMessage) => {
    return {
        errorMessage,
        isValid: false
    };
};
const GetValidValidationResult = () => {
    return {
        errorMessage: null,
        isValid: true
    };
};
/////// isRequired validation
const CheckIfAttributeIsValid = (attribute) => {
    // 0 and false can be valid attribute values, so they need to be excluded from falsy values as a whole
    return !(!attribute && attribute !== 0 && attribute !== false);
};
const GetSimpleNodeAttributeChecker = (attributeName, errorMessage) => {
    return (nodeMetadata) => {
        const attribute = Common.getValueSafe(nodeMetadata, [attributeName], undefined);
        if (!CheckIfAttributeIsValid(attribute)) {
            return GetInvalidValidationResult(errorMessage);
        }
        return GetValidValidationResult();
    };
};
exports.GetSimpleNodeAttributeChecker = GetSimpleNodeAttributeChecker;
const GetSimpleCustomNodeAttributeChecker = (errorMessage) => {
    return (nodeMetadata, elementSpec) => {
        const attribute = Common.getValueSafe(nodeMetadata, ["config", elementSpec.attributeName], undefined);
        if (!CheckIfAttributeIsValid(attribute)) {
            return GetInvalidValidationResult(errorMessage);
        }
        return GetValidValidationResult();
    };
};
exports.GetSimpleCustomNodeAttributeChecker = GetSimpleCustomNodeAttributeChecker;
const GetTableCustomNodeAttributeChecker = () => {
    return (nodeMetadata, tableSpec) => {
        const requiredAttributes = [];
        tableSpec.columns.forEach(element => {
            if (element.isRequired) {
                requiredAttributes.push(element.attributeName);
            }
        });
        const missingRequiredAttributes = [];
        const itemsArray = Common.getValueSafe(nodeMetadata, ["config", tableSpec.attributeName, "items"], []);
        itemsArray.forEach((rowSpec, rowIndex) => {
            requiredAttributes.forEach(attributeName => {
                const attribute = Common.getValueSafe(rowSpec, [attributeName], undefined);
                if (!CheckIfAttributeIsValid(attribute)) {
                    missingRequiredAttributes.push({ attributeName, rowIndex });
                }
            });
        });
        if (!missingRequiredAttributes.length) {
            return GetValidValidationResult();
        }
        else {
            const errorMessage = `Missing required elements in table: ${missingRequiredAttributes.reduce((existingString, currentAttribute) => {
                return `${existingString}; ${currentAttribute.attributeName} in row ${currentAttribute.rowIndex}`;
            }, "")}`;
            return GetInvalidValidationResult(errorMessage);
        }
    };
};
exports.GetTableCustomNodeAttributeChecker = GetTableCustomNodeAttributeChecker;
const GetValidationCBForConfigElement = (configItem) => {
    const configElementLookup = {
        // first class node level attributes
        [FirstClassConfigElement.multisourceToggle]: {
            validateCB: (0, exports.GetSimpleNodeAttributeChecker)(Runner.EFirstClassAttributesNode.isMultisource, "Missing required element: isMultisource"),
        },
        [FirstClassConfigElement.overrideSQLToggle]: {
            validateCB: (0, exports.GetSimpleNodeAttributeChecker)(Runner.EFirstClassAttributesNode.overrideSQL, "Missing required element: overrideSQL"),
        },
        [FirstClassConfigElement.materializationSelector]: {
            validateCB: (0, exports.GetSimpleNodeAttributeChecker)(Runner.EFirstClassAttributesNode.materializationType, "Missing required element: materializationType"),
        },
        // first class column level attributes
        [FirstClassConfigElement.businessKeyColumns]: {
            validateCB: (nodeMetadata) => {
                const valueExists = StepOperations.HasColumnWithCondition(nodeMetadata.metadata.columns, StepOperations.isPrimaryBusinessKey);
                if (!valueExists) {
                    return GetInvalidValidationResult(`Please select a business key column`);
                }
                else {
                    return GetValidValidationResult();
                }
            },
        },
        [FirstClassConfigElement.changeTrackingColumns]: {
            validateCB: (nodeMetadata) => {
                const valueExists = StepOperations.HasColumnWithCondition(nodeMetadata.metadata.columns, StepOperations.isChangeTracking);
                if (!valueExists) {
                    return GetInvalidValidationResult(`Please select a business key column`);
                }
                else {
                    return GetValidValidationResult();
                }
            }
        },
        // custom node level attributes
        [SpecUIType.textBox]: {
            validateCB: (0, exports.GetSimpleCustomNodeAttributeChecker)(`Missing required element: ${configItem.attributeName}`)
        },
        [SpecUIType.dropdownSelector]: {
            validateCB: (0, exports.GetSimpleCustomNodeAttributeChecker)(`Missing required element: ${configItem.attributeName}`)
        },
        [SpecUIType.toggleButton]: {
            validateCB: (0, exports.GetSimpleCustomNodeAttributeChecker)(`Missing required element: ${configItem.attributeName}`)
        },
        /*
         * [SpecUIType.columnDropdownSelector]: {
         *     validateCB: GetSimpleCustomNodeAttributeChecker(`Missing required element: ${(configItem as ConfigSpec).attributeName}`)
         * },
         * CD-2833 re-enable after refactor
         */
        [SpecUIType.tabular]: {
            validateCB: (0, exports.GetTableCustomNodeAttributeChecker)()
        },
        // custom column level attribute
        [SpecUIType.columnSelector]: {
            validateCB: (nodeMetadata, elementSpec) => {
                const attributeExists = StepOperations.HasColumnWithCustomAttribute(nodeMetadata.metadata.columns, elementSpec.attributeName);
                if (!attributeExists) {
                    return GetInvalidValidationResult(`At least one column with attribute ${elementSpec.attributeName} is required`);
                }
                else {
                    return GetValidValidationResult();
                }
            }
        }
    };
    return configElementLookup[configItem.type].validateCB;
};
/**
 * @param nodeMetadata the current step's metadata
 * @param parsedNodeConfig the parsed config options to compare against
 */
const ValidateRequiredConfigFlags = (nodeMetadata, parsedNodeConfig) => {
    let doAllPass = true;
    if (!parsedNodeConfig)
        return doAllPass;
    doAllPass = parsedNodeConfig.every((group) => {
        return group.items.every(item => {
            if (item.isRequired) {
                const validateCB = GetValidationCBForConfigElement(item);
                const validationResult = validateCB(nodeMetadata, item);
                return validationResult.isValid;
            }
            else {
                return true;
            }
        });
    });
    return doAllPass;
};
exports.ValidateRequiredConfigFlags = ValidateRequiredConfigFlags;
//# sourceMappingURL=Templates.js.map