"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runCoa = exports.initCli = exports.GenerateUserConnection = exports.InvalidateEnvironmentOAuthInfo = exports.InitializeTestEnvironmentWithStore = exports.FormatTeamInfoFromEnvironmentInfo = exports.CreateTestReduxStore = exports.TEST_ORG_IDS = exports.RunTestTemplate = exports.RunCreateLargeStringRecords = exports.SELECT_100_FROM_LARGE_STRING_RECORDS = exports.CREATE_LARGE_STRING_RECORDS_TABLE = exports.CREATE_TEST_SUITE_DATA_SCHEMA = exports.CREATE_COALESCE_SAMPLE_DATABASE_TEMPLATE = exports.CreateUserContext = exports.ChangeEnvironmentHealthStatus = exports.schedulerPost = exports.FirebaseGetIDToken = exports.FirebaseLogin = exports.ConfigureWorkspaceWithParams = exports.LogInAndAuthenticateWithOAuth = exports.GetAuthCode = exports.useSimpleStateAccessor = exports.MakeRegistrationRequestWithInvalidPassword = exports.GetRegistrationDataWithInvalidPassword = exports.WaitUntilWorkspaceIsReadyAndNotFailedNonAdmin = exports.WaitUntilWorkspaceIsReadyAndNotFailed = exports.FullSnowflakeDeployTest = exports.RunGitDataGrabAndFlushToFirestore = exports.ValidateWorkspaceReceivedMappingsFromFlush = exports.ValidateDocumentExists = exports.SnowflakeDeployTestVerifyCbs = exports.getTableQueryResults = exports.SnowflakeDeployTestModifyCbs = exports.GetEditedTestColumnName = exports.GetAddedTestColumnName = exports.GetEditedTestTableName = exports.GetAddedTestTableName = exports.DeployTestType = exports.AddWorkspaceToOrg = exports.FormatUserConnection = exports.copyFirebaseOrgWithFreshWorkspace = exports.StandardOrgCollections = exports.deleteTestEnvironment = exports.createNewTestEnvironment = exports.GetCommonValidConnectionDetails = exports.BasicAuthTestContextObject = exports.CLITestCredentials = exports.CommonTestCredentials = exports.adminFirebase = void 0;
exports.GetNewTestEmail = exports.MockColumnsWithOldHashMetadata = exports.DeleteCurrentUserFirebase = exports.GetCurrentUserFirebase = exports.DeleteFirestoreDoc = exports.LogIntoTestUser = exports.LogIntoUserWithCreds = exports.GetMockConfigItemSpec = exports.GetMockSQLOperation = exports.mockTableData = void 0;
const CommonOperations = __importStar(require("./CommonOperations"));
const Common = __importStar(require("./Common"));
const Firebase = __importStar(require("./Firebase"));
const TeamOperations = __importStar(require("./TeamOperations"));
const Logging = __importStar(require("./Logging"));
const Workspaces = __importStar(require("./Workspaces"));
const Templates = __importStar(require("./Templates"));
const RunnerOperations = __importStar(require("./RunnerOperations"));
const Runner = __importStar(require("./Runner"));
const MacroOperations = __importStar(require("./MacroOperations"));
const ConnectionOperations = __importStar(require("./ConnectionOperations"));
const StepTypes = __importStar(require("./StepTypes"));
const StorageMap = __importStar(require("./StorageMap"));
const Axios = __importStar(require("axios"));
const Snowflake = __importStar(require("./Snowflake"));
const State = __importStar(require("./State"));
const react_redux_1 = require("react-redux");
const immer = __importStar(require("immer"));
const Runs = __importStar(require("./Runs"));
const randomstring = __importStar(require("randomstring"));
const qs = require("qs");
/*
 * let admin;
 * if (process.env.NODE_ENV === "test")
 */
const admin = require("firebase-admin");
exports.adminFirebase = admin;
const L = Logging.GetLogger(Logging.LoggingArea.Testing);
exports.CommonTestCredentials = {
    snowflakeAccount: "ww56326.us-central1.gcp",
    username: "mx2323",
    password: "ThisIsAPassword1!",
    snowflakeRole: "SYSADMIN",
    snowflakeWarehouse: "COMPUTE_WH",
};
exports.CLITestCredentials = {
    snowflakeAccount: exports.CommonTestCredentials.snowflakeAccount,
    snowflakeUsername: exports.CommonTestCredentials.username,
    snowflakePassword: exports.CommonTestCredentials.password,
    snowflakeRole: exports.CommonTestCredentials.snowflakeRole,
    snowflakeWarehouse: exports.CommonTestCredentials.snowflakeWarehouse,
};
exports.BasicAuthTestContextObject = {
    user: exports.CommonTestCredentials.username,
    password: exports.CommonTestCredentials.password,
    accountName: exports.CommonTestCredentials.snowflakeAccount,
    role: "",
    warehouse: "",
    orgID: "1",
    environmentID: 1,
    database: "",
    destinationSchema: ""
};
const GetCommonValidConnectionDetails = (userID) => {
    return {
        role: "",
        warehouse: "",
        user: exports.CommonTestCredentials.username,
        userID
    };
};
exports.GetCommonValidConnectionDetails = GetCommonValidConnectionDetails;
const createNewTestEnvironment = (role) => {
    // (window as any).ENVIRONMENT = "development"
    process.env.RUNTIME_ENVIRONMENT = "development";
    if (!admin.apps.length) {
        admin.initializeApp({
            credential: admin.credential.applicationDefault(),
        });
    }
    Firebase.initializeFirebase();
    L.debug("initialized firebase");
    return new Promise((resolve, reject) => {
        const dateString = Date.now().toString();
        let environmentInfo;
        const userEmail = `test${dateString}@fake.com`;
        const userID = `name-${dateString}`;
        const workspaceIDToSet = "1"; //This was already defaulted to 1 but hardcoded, putting this as a single source of truth in case it needs to change in the future
        let newOrgResult;
        L.debug("creating org");
        return TeamOperations.CreateOrgAdmin(admin.firestore(), { orgName: `testOrg - ${dateString}` })
            .then((result) => {
            newOrgResult = result;
            L.debug("Created org");
            return admin.auth().createUser({ uid: userID, email: userEmail, password: "password" });
        })
            .then(() => {
            return Firebase.getFirebaseAuth().signInWithEmailAndPassword(userEmail, "password");
        })
            .then(() => {
            environmentInfo = {
                createdUserEmail: userEmail,
                createdUserID: userID,
                orgID: newOrgResult.orgID,
                orgName: newOrgResult.orgName,
                workspaceID: workspaceIDToSet,
                logContext: {
                    envID: workspaceIDToSet,
                    orgID: newOrgResult.orgID,
                    userID: userID
                }
            };
            L.debug("Created environment", environmentInfo);
            return TeamOperations.createOrUpdateSuperUserAdmin(admin.firestore(), `name-${dateString}`, newOrgResult.orgID, userEmail, "first name", "last name", role);
        })
            .then((userValue) => {
            L.debug("Added user");
            // set any values you want your default dev environment to contain here
            const defaultWorkspaceConfig = {
                connectionAccount: exports.CommonTestCredentials.snowflakeAccount,
                oauthClientID: "z6cAxBLn2/ouwO3+83G08xu/Eog=",
                oauthClientSecret: "ejG2QVO77HReCa2OY8oGhvV17jucylFqNhibze4aI+Y="
            };
            return (0, exports.ConfigureWorkspaceWithParams)(environmentInfo.orgID, workspaceIDToSet, defaultWorkspaceConfig);
        })
            .then(() => {
            const userConnection = (0, exports.FormatUserConnection)(environmentInfo.createdUserID);
            return CommonOperations.getDocumentRefAdmin(admin.firestore(), environmentInfo.orgID, parseInt(environmentInfo.workspaceID), CommonOperations.DocRefs.users).doc(environmentInfo.createdUserID).set(userConnection);
        })
            .then(() => {
            resolve(environmentInfo);
        })
            .catch(error => {
            reject(error);
        });
    });
};
exports.createNewTestEnvironment = createNewTestEnvironment;
const deleteTestEnvironment = (environmentInfo) => {
    console.log("deleting environment", environmentInfo);
    L.debug("deleting test environment!");
    return new Promise((resolve, reject) => {
        return TeamOperations.DeleteOrgAdmin(admin.firestore(), environmentInfo.orgID)
            .then(() => {
            return TeamOperations.deleteUserAdmin(admin.firestore(), environmentInfo.createdUserID);
        }).then(() => {
            return admin.auth().deleteUser(environmentInfo.createdUserID);
        }).then(() => {
            L.debug("terminating connections");
            Firebase.getFirestore().terminate();
            resolve();
        }).catch(err => reject(err));
    });
};
exports.deleteTestEnvironment = deleteTestEnvironment;
var StandardOrgCollections;
(function (StandardOrgCollections) {
    StandardOrgCollections["environments"] = "environments";
    StandardOrgCollections["mappings"] = "mappings";
    StandardOrgCollections["runs"] = "runs";
    StandardOrgCollections["workspaces"] = "workspaces";
})(StandardOrgCollections = exports.StandardOrgCollections || (exports.StandardOrgCollections = {}));
/**
 * Function copies all data from one doc to another. Paths that don't exist will be created, paths that do exist are overwritten.
 * Writes to firebase are batched in groups of 450. Large docs may only partly succeed if they contain more than 450 docs within them.
 * Can specify which collections to be skipped in copying to save time/resources if not needed.
 * @param firestore firestore used to get doc refs passed in
 * @param fromDocRef doc ref that data will be copied from
 * @param toDocRef doc ref that data will be pasted to
 * @param collectionsToSkip any collections with names matching (full match, no partial) the strings passed in here will not be copied over; not path-dependent,
 * collections with these names at any level will be skipped
 */
const copyFirebaseDoc = (firestore, fromDocRef, toDocRef, collectionsToSkip) => {
    return TeamOperations.RecursivelyBatchFirebaseDocs(firestore, collectionsToSkip, fromDocRef, TeamOperations.FirebaseBatchOperations.set, toDocRef);
};
const copyFirebaseOrgWithFreshWorkspace = (fromOrgID, toOrgID, createdByUserID, collectionsToCopy) => {
    const firestore = admin.firestore();
    const fromOrg = CommonOperations.getOrgDataDocRefAdmin(firestore, fromOrgID);
    const toOrg = CommonOperations.getOrgDataDocRefAdmin(firestore, toOrgID);
    const fullCollectionArray = Object.values(StandardOrgCollections);
    const collectionsToSkip = fullCollectionArray.filter(coll => !collectionsToCopy.includes(coll));
    let newWorkspaceID;
    return copyFirebaseDoc(firestore, fromOrg, toOrg, collectionsToSkip).then(() => {
        return Workspaces.AddWorkspaceAdmin(firestore, toOrgID, "Test", createdByUserID)
            .then(workspaceID => {
            newWorkspaceID = workspaceID;
            return Workspaces.UpdateWorkspaceAdmin(firestore, toOrgID, newWorkspaceID, { connectionAccount: exports.BasicAuthTestContextObject.accountName });
        })
            .then(() => {
            //create basic auth user using basicAuthTestContextObject info
            const userConnection = (0, exports.FormatUserConnection)(createdByUserID);
            return CommonOperations.getDocumentRefAdmin(firestore, toOrgID, newWorkspaceID, CommonOperations.DocRefs.users).doc(createdByUserID).set(userConnection);
        })
            .then(() => newWorkspaceID);
    });
};
exports.copyFirebaseOrgWithFreshWorkspace = copyFirebaseOrgWithFreshWorkspace;
const FormatUserConnection = (userID) => {
    return {
        connectionType: ConnectionOperations.EUserConnectionTypes.basic,
        connectionDetails: {
            //BasicAuthTestContextObject always has values
            user: exports.BasicAuthTestContextObject.user,
            userID: userID,
            role: exports.BasicAuthTestContextObject.role,
            warehouse: exports.BasicAuthTestContextObject.warehouse
        }
    };
};
exports.FormatUserConnection = FormatUserConnection;
const AddWorkspaceToOrg = (orgID, createdByUserID) => {
    const firestore = admin.firestore();
    return Workspaces.AddWorkspaceAdmin(firestore, orgID, "Test", createdByUserID).then(workspaceID => {
        return workspaceID;
    });
};
exports.AddWorkspaceToOrg = AddWorkspaceToOrg;
var DeployTestType;
(function (DeployTestType) {
    DeployTestType["addTable"] = "addTable";
    DeployTestType["addView"] = "addView";
    DeployTestType["editTable"] = "editTable";
    DeployTestType["editView"] = "editView";
    DeployTestType["deleteTable"] = "deleteTable";
    DeployTestType["deleteView"] = "deleteView";
    DeployTestType["addColumn"] = "addColumn";
    DeployTestType["editColumn"] = "editColumn";
    DeployTestType["deleteColumn"] = "deleteColumn";
    DeployTestType["failAddTable"] = "failAddTable";
})(DeployTestType = exports.DeployTestType || (exports.DeployTestType = {}));
const GetAddedTestTableName = (stepCounter) => {
    return `ADDED_STEP_${stepCounter}-TEST`;
};
exports.GetAddedTestTableName = GetAddedTestTableName;
const GetEditedTestTableName = (stepCounter) => {
    return `${(0, exports.GetAddedTestTableName)(stepCounter)}_EDIT-TEST`;
};
exports.GetEditedTestTableName = GetEditedTestTableName;
const GetAddedTestColumnName = (columnCounter) => {
    return `ADDED_COLUMN_${columnCounter}-TEST`;
};
exports.GetAddedTestColumnName = GetAddedTestColumnName;
const GetEditedTestColumnName = (columnCounter) => {
    return `${(0, exports.GetAddedTestColumnName)(columnCounter)}_EDIT-TEST`;
};
exports.GetEditedTestColumnName = GetEditedTestColumnName;
// collection of functions to create modified mock data for FullSnowflakeDeployTest
const SnowflakeDeployTestModifyCbs = (testType) => {
    switch (testType) {
        case DeployTestType.addTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                const nonSourceStepCounters = Object.keys(startData.steps).filter(stepCounter => startData.steps[stepCounter].operation.sqlType !== "Source");
                L.info(`nonSourceStepCounters: ${nonSourceStepCounters.join(", ")}`);
                return new Promise((resolveAddTable, rejectAddTable) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "stepCounter", 1).then((stepCounter) => {
                        L.info("new step counter", stepCounter);
                        /*
                         * just copying data from the first non-source node for operation. shouldn't affect the test, if it does, we'll need a big refactor of
                         * creating steps funcs
                         */
                        const stepToCopy = startData.steps[nonSourceStepCounters[0]];
                        const newName = (0, exports.GetAddedTestTableName)(stepCounter);
                        L.info("step to copy", stepToCopy);
                        const newData = immer.produce(startData, draftState => {
                            draftState.steps[stepCounter] = Object.assign(Object.assign({}, stepToCopy), { stepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName }), name: newName });
                        });
                        L.info("new data", newData);
                        resolveAddTable([newData, [stepCounter], []]);
                    }).catch(err => {
                        L.error(`Error creating data for add table; Error:`, err);
                        rejectAddTable(err);
                    });
                });
            };
        case DeployTestType.addView:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                const nonSourceStepCounters = Object.keys(startData.steps).filter(stepCounter => startData.steps[stepCounter].operation.sqlType !== "Source");
                L.info(`nonSourceStepCounters: ${nonSourceStepCounters.join(", ")}`);
                return new Promise((resolveAddTable, rejectAddTable) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "stepCounter", 1).then((stepCounter) => {
                        /*
                         * just copying data from the first non-source node for operation. shouldn't affect the test, if it does, we'll need a big refactor of
                         * creating steps funcs
                         */
                        const stepToCopy = startData.steps[nonSourceStepCounters[0]];
                        const newName = (0, exports.GetAddedTestTableName)(stepCounter);
                        L.info("step to copy", stepToCopy);
                        const newData = immer.produce(startData, draftState => {
                            draftState.steps[stepCounter] = Object.assign(Object.assign({}, stepToCopy), { stepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName, materializationType: "view" }), name: newName });
                        });
                        resolveAddTable([newData, [stepCounter], []]);
                    }).catch(err => {
                        L.error(`Error creating data for add table; Error:`, err);
                        rejectAddTable(err);
                    });
                });
            };
        case DeployTestType.editView:
        case DeployTestType.editTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveEditTable, rejectEditTable) => {
                    const newData = immer.produce(startData, draftState => {
                        const tableToEdit = draftState.steps[stepCountersToModify[0]];
                        tableToEdit.name = (0, exports.GetEditedTestTableName)(stepCountersToModify[0]);
                        tableToEdit.operation.name = (0, exports.GetEditedTestTableName)(stepCountersToModify[0]);
                    });
                    resolveEditTable([newData, [], []]);
                });
            };
        case DeployTestType.deleteView:
        case DeployTestType.deleteTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveDeleteTable, rejectDeleteTable) => {
                    const newData = immer.produce(startData, draftState => {
                        delete draftState.steps[stepCountersToModify[0]];
                    });
                    resolveDeleteTable([newData, [], []]);
                });
            };
        case DeployTestType.addColumn:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveAddColumn, rejectAddColumn) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "columnCounter", 1).then((columnCounter) => {
                        const newColumnName = (0, exports.GetAddedTestColumnName)(columnCounter);
                        const newData = immer.produce(startData, draftState => {
                            const columnToCopy = draftState.steps[stepCountersToModify[0]].operation.metadata.columns[0];
                            draftState.steps[stepCountersToModify[0]].operation.metadata.columns[columnCounter] = Object.assign(Object.assign({}, columnToCopy), { name: newColumnName });
                        });
                        resolveAddColumn([newData, [], [columnCounter]]);
                    });
                });
            };
        case DeployTestType.editColumn:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveEditColumn, rejectEditColumn) => {
                    const newColumnName = (0, exports.GetEditedTestColumnName)(columnCountersToModify[0]);
                    const newData = immer.produce(startData, draftState => {
                        const columnToEdit = draftState.steps[stepCountersToModify[0]].operation.metadata.columns[columnCountersToModify[0]];
                        columnToEdit.name = newColumnName;
                    });
                    resolveEditColumn([newData, [], []]);
                });
            };
        case DeployTestType.deleteColumn:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveDeleteColumn, rejectDeleteColumn) => {
                    const newData = immer.produce(startData, draftState => {
                        delete draftState.steps[stepCountersToModify[0]].operation.metadata.columns[columnCountersToModify[0]];
                    });
                    resolveDeleteColumn([newData, [], []]);
                });
            };
        case DeployTestType.failAddTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                const nonSourceStepCounters = Object.keys(startData.steps).filter(stepCounter => startData.steps[stepCounter].operation.sqlType !== "Source");
                L.info(`nonSourceStepCounters: ${nonSourceStepCounters.join(", ")}`);
                return new Promise((resolveAddTable, rejectAddTable) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "stepCounter", 2).then((stepCounter) => {
                        /*
                         * just copying data from the first non-source node for operation. shouldn't affect the test, if it does,
                         * we'll need a big refactor of creating steps funcs
                         */
                        let localStepCounter = stepCounter;
                        const stepToCopy = startData.steps[nonSourceStepCounters[0]];
                        const newName = (0, exports.GetAddedTestTableName)(stepCounter);
                        L.info("step to copy", stepToCopy);
                        const newData = immer.produce(startData, draftState => {
                            draftState.steps[stepCounter] = Object.assign(Object.assign({}, stepToCopy), { stepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName }), name: newName });
                        });
                        localStepCounter++;
                        const completeNewData = immer.produce(newData, draftState => {
                            draftState.steps[localStepCounter] = Object.assign(Object.assign({}, stepToCopy), { localStepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName + 2, locationID: 99, locationName: "FAKE" }), name: newName + 2 });
                        });
                        resolveAddTable([completeNewData, [stepCounter], []]);
                    }).catch(err => {
                        L.error(`Error creating data for add table; Error:`, err);
                        rejectAddTable(err);
                    });
                });
            };
        default:
            break;
    }
};
exports.SnowflakeDeployTestModifyCbs = SnowflakeDeployTestModifyCbs;
const getStepData = (startingData, stepCounter, workspaceID, orgRef, testType) => {
    return new Promise((resolve, reject) => {
        if (testType === DeployTestType.deleteTable || testType === DeployTestType.deleteView) {
            resolve(startingData.steps[stepCounter].operation);
        }
        else {
            orgRef.collection("workspaces").doc(workspaceID.toString()).collection("steps").doc(stepCounter.toString()).get().then((step) => {
                L.info("step in getStepData:", step.data());
                resolve(step.data());
            }).catch(err => {
                L.error(`Error getting stepData in verifyCb (deploy test); Error:`, err);
                reject(err);
            });
        }
    });
};
const getPhysicalLocations = (orgRef) => {
    return new Promise((resolve, reject) => {
        //hard-coded to be workspace 34 but might need a way to get automatically? or just pass in
        orgRef.collection("workspaces").doc("34").get().then(environment => {
            const envData = environment.data();
            resolve(envData.mappings);
        }).catch(err => {
            L.error(`Error getting mappings in verifyCb (deploy test); Error:${err.toString()}`);
            reject(err);
        });
    });
};
const getTableQueryResults = (startingData, stepCounter, workspaceID, orgRef, testType) => {
    const userContext = {
        user: exports.CommonTestCredentials.username,
        password: exports.CommonTestCredentials.password,
        accountName: exports.CommonTestCredentials.snowflakeAccount,
        database: "HH_DB",
        destinationSchema: "HH_SCHEMA",
        warehouse: "",
        role: "ACCOUNTADMIN",
        environmentID: workspaceID,
        orgID: orgRef.id
    };
    return new Promise((resolve, reject) => {
        Promise.all([getStepData(startingData, stepCounter, workspaceID, orgRef, testType), getPhysicalLocations(orgRef)])
            .then(result => {
            const [allStepData, physicalLocations] = result;
            const verifiablePromises = [];
            /*
             * RunDescTable throws error on non-existent table and since we're hoping the table doesn't exist, we can't use that.
             * For editTable test, RunDescTable doesn't return the name but will return the unedited table if it failed, making
             * us think it succeeded.
             */
            if (testType === DeployTestType.deleteTable || testType === DeployTestType.editTable) {
                let newStepData = allStepData;
                if (testType === DeployTestType.editTable && !newStepData.name.includes("_EDIT-TEST")) {
                    newStepData = immer.produce(allStepData, (draftState) => {
                        draftState.name = draftState.name + "_EDIT-TEST";
                    });
                }
                verifiablePromises.push(RunnerOperations.RunShowTables(physicalLocations, newStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            else if (testType === DeployTestType.deleteView || testType === DeployTestType.editView) {
                verifiablePromises.push(RunnerOperations.RunShowViews(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            else if (testType === DeployTestType.addView) {
                verifiablePromises.push(RunnerOperations.RunDescView(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            else if (testType === DeployTestType.failAddTable) {
                //the successful create
                verifiablePromises.push(RunnerOperations.RunDescTable(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
                //the failed create
                verifiablePromises.push((0, exports.WaitUntilWorkspaceIsReadyAndNotFailed)(orgRef.id, workspaceID)
                    .then(() => {
                    console.log("Deploy verification succeeded, should have failed");
                    return {
                        data: {
                            columns: [],
                            rows: [0],
                            status: Snowflake.ESnowflakeDataReturnStatus.success
                        },
                        runDetails: {
                            compiledSQL: "",
                            exported_refs: [],
                            invalid_exported_refs: [],
                            ref_usage: {
                                invalid_ref: [],
                                invalid_ref_link: [],
                                invalid_ref_no_link: [],
                                ref: [],
                                ref_link: [],
                                ref_no_link: []
                            }
                        },
                    };
                })
                    .catch(error => {
                    console.error("Deploy verfication error: ", error);
                    return {
                        data: {
                            columns: [],
                            rows: [1],
                            status: Snowflake.ESnowflakeDataReturnStatus.success
                        },
                        runDetails: {
                            compiledSQL: "",
                            exported_refs: [],
                            invalid_exported_refs: [],
                            ref_usage: {
                                invalid_ref: [],
                                invalid_ref_link: [],
                                invalid_ref_no_link: [],
                                ref: [],
                                ref_link: [],
                                ref_no_link: []
                            }
                        }
                    };
                }).then(queryResult => queryResult));
            }
            else {
                verifiablePromises.push(RunnerOperations.RunDescTable(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            return Promise.all(verifiablePromises);
        }).then(templateRunResults => {
            const queryResults = templateRunResults.map(templateRunResult => {
                return RunnerOperations.GetQueryResultFromTemplateRunResult(templateRunResult, new Date());
            });
            resolve(queryResults);
        }).catch(err => {
            reject(err);
        });
    });
};
exports.getTableQueryResults = getTableQueryResults;
//collection of funcs to verify successful snowflake changes for deploy test (maybe incorporate into modifyCb func collection above?)
const SnowflakeDeployTestVerifyCbs = (testType) => {
    switch (testType) {
        case DeployTestType.addTable:
        case DeployTestType.addView:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        const success = queryResults.every(queryResult => !!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for added table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.editView:
        case DeployTestType.editTable:
            //this method currently assumes that firebase updated properly, as it uses the data from there to grab the name for RunDescTable
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        L.info("query results", queryResults);
                        //since the query is generated based on the new name, any row at all means success
                        const success = queryResults.every(queryResult => !!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for edited table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.deleteView:
        case DeployTestType.deleteTable:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        L.info("query results verify", queryResults);
                        const success = queryResults.every(queryResult => !!!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for deleted table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.addColumn:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then(queryResults => {
                        // queryResults is an array now, instead of a single queryResult, fix accordingly
                        const success = queryResults
                            .every(queryResult => !!queryResult.fields
                            .some(col => col.name === (0, exports.GetAddedTestColumnName)(columnCounters[0])));
                        resolve(success);
                        // resolve(queryResult.fields.some(col => col.name === GetAddedTestColumnName(columnCounter!)))
                    }).catch(err => {
                        L.error(`Error checking for added column in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.editColumn:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    // queryResults is an array now, instead of a single queryResult, fix accordingly
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then(queryResults => {
                        const success = queryResults.every(queryResult => {
                            return queryResult.fields.some(col => col.name === (0, exports.GetEditedTestColumnName)(columnCounters[0]));
                        });
                        resolve(success);
                        // resolve(queryResult.fields.some(col => col.name === GetEditedTestColumnName(columnCounter!)))
                    }).catch(err => {
                        L.error(`Error checking for edited column in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.deleteColumn:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then(queryResults => {
                        // queryResults is an array now, instead of a single queryResult, fix accordingly
                        const success = queryResults.every(queryResult => {
                            return queryResult.fields.some(col => col.name === (0, exports.GetEditedTestColumnName)(columnCounters[0]));
                        });
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for deleted column in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.failAddTable:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    (0, exports.getTableQueryResults)(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        const success = queryResults.every(queryResult => !!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for failed added table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        default:
            break;
    }
};
exports.SnowflakeDeployTestVerifyCbs = SnowflakeDeployTestVerifyCbs;
const ValidateDocumentExists = (docRef) => {
    return docRef.get()
        .then((doc) => {
        const exists = doc.exists;
        return exists;
    });
};
exports.ValidateDocumentExists = ValidateDocumentExists;
const ValidateWorkspaceReceivedMappingsFromFlush = (firestore, teamID, workspaceID) => {
    return CommonOperations.getWorkspaceDocumentRefAdmin(firestore, teamID, workspaceID).get()
        .then((doc) => {
        const data = doc.data();
        if (data) {
            return Object.keys(data.mappings || {}).length;
        }
        else {
            throw new Error("Workspace Document didn't exist");
        }
    });
};
exports.ValidateWorkspaceReceivedMappingsFromFlush = ValidateWorkspaceReceivedMappingsFromFlush;
const RunGitDataGrabAndFlushToFirestore = (fsSettings, commitOID, firebase, orgID, workspaceIDForTargetFlush) => {
    return Workspaces.GetAllWorkspaceDataFromGitCommit(fsSettings, commitOID, workspaceIDForTargetFlush)
        .then((desiredGitState) => {
        return Workspaces.getAllWorkspaceDataFromFirebase(firebase.firestore(), orgID, workspaceIDForTargetFlush)
            .then(replacingState => {
            return Workspaces.FlushFirestoreWorkspaceWithAllWorkspaceData(firebase.firestore(), orgID, workspaceIDForTargetFlush, desiredGitState, replacingState);
        });
    });
};
exports.RunGitDataGrabAndFlushToFirestore = RunGitDataGrabAndFlushToFirestore;
/**
 * This test makes sure deploy is working for various changes in data. Making custom modifyCb and verifyCb leaves any option open for what data changes are tested as long as the changes could plausibly be effected from the app itself.
 * @param orgID id of org to be deployed to
 * @param fbUserID valid firebase user id to be used with deploy
 * @param workspaceID workspace to be deployed to
 * @param modifyCb callback can take any form as long as it can take in the starting data and return modified data in a form that might actually be generated by the app (i.e. that would be pulled from git in an actual deploy).
 * This can return multiple changes to the data just as working in the app could. If the callback adds a step or column, it should return the counters of any added in the resolve, otherwise should return empty arrays for those values
 * @param verifyCb verifyCb can take any form as long as it returns just a boolean indicating if the expected result was seen. getTableQueryResult is set up for this specifically (but doesn't have to be used,
 * and can be called within the callback iteratively on multiple stepCounters if necessary, then the aggregated results can be handled by the callback itself however is needed.
 * @param stepCountersToModify stepCounters to modify (and then verify with). Should only be an empty array if the modifyCb will add any table to be tested on. Passed in at this level so tables added or modified from previous tests
 * can then be passed in to ensure testing on same table if necessary.
 * @param columnCountersToModify columnCounters to modify and then verify with. Can be an empty array if the test doesn't involve any column-level changes
 * @returns an object containing the success boolean, and arrays of any stepCounters or columnCounters that were added/modified
 */
const FullSnowflakeDeployTest = (orgID, fbUserID, fromWorkspaceID, toWorkspaceID, modifyCb, verifyCb, stepCountersToModify, columnCountersToModify, additionalWorkspaceData, snowflakePassword, snowflakeUsername) => {
    return new Promise((resolveTest, rejectTest) => {
        var _a;
        const firestore = admin.firestore();
        const orgRef = CommonOperations.getOrgDataDocRefAdmin(firestore, orgID);
        const fbToken = (_a = Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.refreshToken;
        const snowflakeUserCreds = {
            snowflakeAccount: exports.CommonTestCredentials.snowflakeAccount,
            snowflakePassword: snowflakePassword,
            snowflakeUsername: snowflakeUsername,
        };
        let startingData;
        let stepCountersToUse;
        let columnCountersToUse;
        return Workspaces.getAllWorkspaceDataFromFirebase(firestore, orgID, fromWorkspaceID).then((workspaceData) => {
            startingData = workspaceData;
            if (!Object.keys(workspaceData.stepTypes).length) {
                //missing, so sub in default stepTypes
                startingData = immer.produce(workspaceData, draftState => {
                    draftState.stepTypes = StepTypes.getDefaultStepTypes();
                });
            }
            //adding new table/view needs fresh workspace, so ids shouldn't match; other tests should be using same workspace, we now also need to inject in the accountName information ugh :|
            if (fromWorkspaceID !== toWorkspaceID) {
                startingData = immer.produce(workspaceData, draftState => {
                    draftState.workspaces.workspaces[toWorkspaceID] = Object.assign({}, draftState.workspaces.workspaces[fromWorkspaceID]);
                });
            }
            if (additionalWorkspaceData !== null) {
                startingData = immer.produce(additionalWorkspaceData, draftState => {
                    draftState.workspaces.workspaces[toWorkspaceID] = Object.assign(Object.assign({}, draftState.workspaces.workspaces[34]), { id: toWorkspaceID });
                    draftState.steps = Object.assign({}, startingData.steps);
                });
            }
            return modifyCb(firestore, orgRef, startingData, stepCountersToModify, columnCountersToModify);
        })
            .then((newDataResult) => {
            const [newData, stepCounters, columnCounters] = newDataResult;
            stepCountersToUse = stepCounters.length ? stepCounters : stepCountersToModify; //stepCountersToUse must have at least one step counter at this point in order to use a verify callback
            columnCountersToUse = columnCounters.length ? columnCounters : columnCountersToModify; //columnCountersToUse can still be empty if test doesn't involve changes to columns
            if (fromWorkspaceID !== toWorkspaceID) {
                startingData = immer.produce(startingData, draftState => {
                    draftState.workspaces.workspaces = {};
                    draftState.steps = {};
                });
            }
            const { nodeEdits } = Workspaces.getWorkspaceEdits(newData, startingData, toWorkspaceID, Templates.PlatformType.snowflake);
            L.info("new edits", nodeEdits);
            const reqBody = {
                runDetails: {
                    deployCommit: "test-no-commit",
                    deployCommitMessage: "test-message",
                    fromWorkspaceData: newData,
                    toWorkspaceID: toWorkspaceID,
                    dividedStepDataWithWorkspaceEdits: nodeEdits,
                    stepsInRun: Object.keys(nodeEdits.addedTable).length +
                        Object.keys(nodeEdits.alteredTable).length +
                        Object.keys(nodeEdits.deletedTable).length
                },
                userCredentials: snowflakeUserCreds,
                runType: Runner.ERunType.deploy,
                userID: fbUserID,
                runStatus: Runner.ERunStatus.waitingToRun,
                runHistory: [],
            };
            return RunnerOperations.RunPost(`${Common.START_RUN_URL}/scheduler/startDeploy?token=${fbToken}`, reqBody);
        }).then((result) => {
            if (result.data.error) {
                L.error(`Error with RunPost during test deploy; Error:`, result.data.error);
                throw new Error(result.data.error);
            }
            else {
                return new Promise((resolve, reject) => {
                    //There seems to be a delay between the Axios response and Snowflake actually updating, this is a band-aid to get around that
                    setTimeout(() => {
                        return verifyCb(orgRef, toWorkspaceID, startingData, stepCountersToUse, columnCountersToUse).then(success => {
                            resolve(success);
                        });
                    }, 15000);
                });
            }
        }).then((success) => {
            resolveTest({ success, stepCounters: stepCountersToUse, columnCounters: columnCountersToUse });
        }).catch((err) => {
            L.error(`Error while attempting to deploy (test); Error:`, err);
            rejectTest(err);
        });
    });
};
exports.FullSnowflakeDeployTest = FullSnowflakeDeployTest;
const WaitUntilWorkspaceIsReadyAndNotFailed = (orgID, workspaceID) => {
    const firestore = admin.firestore();
    return (0, exports.WaitUntilWorkspaceIsReadyAndNotFailedNonAdmin)(firestore, orgID, workspaceID);
};
exports.WaitUntilWorkspaceIsReadyAndNotFailed = WaitUntilWorkspaceIsReadyAndNotFailed;
const WaitUntilWorkspaceIsReadyAndNotFailedNonAdmin = (firestore, orgID, workspaceID) => {
    return new Promise((resolve, reject) => {
        const orgsRef = CommonOperations.getOrgsCollectionAdmin(firestore);
        const checkStatus = () => {
            orgsRef.doc(orgID).collection("workspaces").doc(workspaceID.toString()).get().then(workspace => {
                const status = workspace.data().status;
                if (status === Runner.EWorkspaceHealth.waiting) {
                    resolve();
                }
                else if (status === Runner.EWorkspaceHealth.failedDeploy || status === Runner.EWorkspaceHealth.failedRefresh) {
                    reject(`Workspace ${workspaceID} in failed state`);
                }
                else {
                    setTimeout(() => {
                        checkStatus();
                    }, 1000);
                }
            }).catch(err => {
                L.error("Encountered error while waiting for workspace to be ready:", err);
                reject(err);
            });
        };
        checkStatus();
    });
};
exports.WaitUntilWorkspaceIsReadyAndNotFailedNonAdmin = WaitUntilWorkspaceIsReadyAndNotFailedNonAdmin;
const GetRegistrationDataWithInvalidPassword = (invalidPassword) => {
    const dateString = Date.now();
    return {
        newOrg: {
            orgName: "testCompany"
        },
        newUser: {
            firstName: "testFirst",
            lastName: "testLast",
            role: "User",
            currentTeam: "NoTeamID",
            email: `testEmail${dateString}@notreal.com`,
            password: invalidPassword
        }
    };
};
exports.GetRegistrationDataWithInvalidPassword = GetRegistrationDataWithInvalidPassword;
const MakeRegistrationRequestWithInvalidPassword = (invalidPassword) => {
    //RunPost does not return the error data we actually need for testing
    return Axios.default.post(`${Common.START_RUN_URL}/scheduler/registerTrialOrg`, (0, exports.GetRegistrationDataWithInvalidPassword)(invalidPassword));
};
exports.MakeRegistrationRequestWithInvalidPassword = MakeRegistrationRequestWithInvalidPassword;
const useSimpleStateAccessor = () => {
    const state = (0, react_redux_1.useSelector)(state => (state));
    return state;
};
exports.useSimpleStateAccessor = useSimpleStateAccessor;
//TODO: might need some refactoring to get all OAuth tests working?
const GetAuthCode = (username, password, oauthClientID) => {
    const puppeteer = require("puppeteer");
    return new Promise((resolve, reject) => {
        let p = null;
        L.info("(GetAuthCode) starting");
        puppeteer.launch({ headless: true,
            args: ["--no-sandbox"]
        })
            .then((browser) => {
            return browser.newPage()
                .then((page) => {
                L.info("(GetAuthCode) navigated to new page");
                // client ID needs to have its special characters encoded to be valid in the URL
                const encodedClientID = encodeURIComponent(oauthClientID);
                p = page;
                return page.goto(`https://${exports.CommonTestCredentials.snowflakeAccount}.snowflakecomputing.com/oauth/authorize?response_type=code&redirect_uri=http%3A%2F%2Flocalhost%3A3000%2Foauthredirect&client_id=${encodedClientID}`, { waitUntil: "networkidle2" })
                    .then((page) => {
                    L.info("(GetAuthCode) waiting for initial navigation timeout");
                    return p.waitForTimeout(7000);
                }).then(() => {
                    L.info("(GetAuthCode) navigated to snowflake page");
                    return p.type("[name=username]", `${username}`)
                        .catch(() => {
                        /**
                         * certain tests that we want to fail (at least clientID for sure) won't load the page with
                         * the username element, but that's expected. So the catch() is here to handle those cases.
                         * for now
                         */
                        L.error("(GetAuthCode) error typing in username");
                        return p.$("div.message").then(handle => {
                            L.info("(GetAuthCode) getting snowflake page error message");
                            return handle.getProperty("innerHTML");
                        })
                            .then(messageText => {
                            L.info("(GetAuthCode) throwing snowflake error");
                            throw new Error(messageText);
                        });
                    });
                }).then(() => {
                    L.info("(GetAuthCode) returning password id inputEl");
                    return p.type("#password-id-inputEl", `${password}`);
                })
                    .then((result) => {
                    L.info("(GetAuthCode) intercepting request");
                    return p.setRequestInterception(true);
                })
                    .then(() => {
                    p.on("request", request => {
                        /*
                         * Capture any request that is a navigation requests that attempts to load a new document
                         * This will capture HTTP Status 301, 302, 303, 307, 308, HTML, and Javascript redirects
                         */
                        L.info("(GetAuthCode) making request", request);
                        if (request.isNavigationRequest() && request.resourceType() === "document") {
                            const redirect = request.url();
                            const values = qs.parse(redirect.split("?")[1]);
                            L.info("(GetAuthCode) resolving request with authCode");
                            resolve(values.code);
                        }
                        L.info("(GetAuthCode) done intercepting request");
                        request.continue();
                    });
                    /*
                     *p.on('response', response => {
                     *	const status = response.status()
                     *	console.log("got response", response)
                     *	if ((status >= 300) && (status <= 399)) {
                     *	  console.log('Redirect from', response.url(), 'to', response.headers()['location'])
                     *	}
                     *  })
                     */
                    L.info("(GetAuthCode) returning waitForNavigation/click Promise.all");
                    return Promise.all([
                        p.waitForNavigation(),
                        p.click("#base-button-1026-btnEl")
                    ]);
                }).then(() => {
                    L.info("(GetAuthCode) closing browser");
                    return browser.close();
                })
                    .catch((err) => {
                    L.error("(GetAuthCode) error!", err);
                    reject(err);
                });
            });
        });
    });
};
exports.GetAuthCode = GetAuthCode;
/**
 *
 * @returns a firebase refresh token to use in further requests
 */
const LogInAndAuthenticateWithOAuth = (
// credentials for logging into coalesce
appUsername, appPassword, 
// credentials for current snowflake account
snowflakeUsername, snowflakePassword, 
// urls, id and secret for current security configuration
oauthClientID, oauthClientSecret, authURL, tokenURL) => {
    let firebaseRefreshToken;
    return new Promise((resolve, reject) => {
        return (0, exports.FirebaseLogin)(appUsername, appPassword).then(refreshToken => {
            firebaseRefreshToken = refreshToken;
            return (0, exports.GetAuthCode)(snowflakeUsername, snowflakePassword, oauthClientID);
        }).then(authCode => {
            return ConnectionOperations.SendOAuthAuthenticationRequestToScheduler(authCode, 1, oauthClientID, oauthClientSecret, authURL, tokenURL);
        }).then(response => {
            resolve(firebaseRefreshToken);
            return firebaseRefreshToken;
        }).catch(error => {
            console.error("got authenticate oauth error", error);
            reject(error);
        });
    });
};
exports.LogInAndAuthenticateWithOAuth = LogInAndAuthenticateWithOAuth;
/**
 *
 * @param workspaceParams a dictionary of attributes to set on the targeted workspace
 */
const ConfigureWorkspaceWithParams = (teamID, workspaceID, workspaceParams) => {
    return Workspaces.getWorkspacesCollectionRef(teamID).doc(workspaceID).set(workspaceParams, { merge: true });
};
exports.ConfigureWorkspaceWithParams = ConfigureWorkspaceWithParams;
/**
 * helper that signs in with email and password and then resolves
 * with the logged in user's refresh token
 */
const FirebaseLogin = (email, password) => {
    return Firebase.getFirebaseAuth().signInWithEmailAndPassword(email, password).then(() => {
        return Firebase.getFirebaseAuth().currentUser.refreshToken;
    });
};
exports.FirebaseLogin = FirebaseLogin;
const FirebaseGetIDToken = () => {
    return Firebase.getFirebaseAuth().currentUser.getIdToken();
};
exports.FirebaseGetIDToken = FirebaseGetIDToken;
const schedulerPost = (endpoint, body) => {
    return Runner.RunPost(endpoint, body);
};
exports.schedulerPost = schedulerPost;
const ChangeEnvironmentHealthStatus = (teamID, environmentID, status) => {
    const environmentRef = Workspaces.getWorkspacesCollectionRefAdmin(exports.adminFirebase.firestore(), teamID).doc(environmentID.toString());
    return environmentRef.set({
        status: status
    }, { merge: true });
};
exports.ChangeEnvironmentHealthStatus = ChangeEnvironmentHealthStatus;
const CreateUserContext = (orgID) => {
    return {
        user: exports.CommonTestCredentials.username,
        password: exports.CommonTestCredentials.password,
        accountName: exports.CommonTestCredentials.snowflakeAccount,
        role: "",
        warehouse: "",
        orgID: orgID,
        environmentID: 1,
        database: "",
        destinationSchema: ""
    };
};
exports.CreateUserContext = CreateUserContext;
// TEMPLATES STRINGS USED FOR LARGE STRING RECORDS CREATION/TESTING
exports.CREATE_COALESCE_SAMPLE_DATABASE_TEMPLATE = `CREATE DATABASE IF NOT EXISTS "COALESCE_SAMPLE_DATABASE"`;
exports.CREATE_TEST_SUITE_DATA_SCHEMA = `CREATE SCHEMA IF NOT EXISTS "COALESCE_SAMPLE_DATABASE"."TEST_SUITE_DATA"`;
exports.CREATE_LARGE_STRING_RECORDS_TABLE = `CREATE TABLE IF NOT EXISTS  "COALESCE_SAMPLE_DATABASE"."TEST_SUITE_DATA"."LARGE_STRING_RECORDS"
	(   "COL1_STRING"   STRING,
		"COL2_STRING"   STRING,
		"COL3_STRING"   STRING,
		"COL4_STRING"   STRING,
		"COL5_VARIANT"  VARIANT,
		"COL6_VARIANT"  VARIANT
	)
	AS SELECT
		RANDSTR( 860800, random()),
		RANDSTR( 860800, random()),
		RANDSTR( 860800, random()),
		RANDSTR( 860800, random()),
		RANDSTR( 860800, random())::VARIANT,
		RANDSTR( 860800, random())::VARIANT
	FROM
		TABLE(GENERATOR(ROWCOUNT => 50));
`;
exports.SELECT_100_FROM_LARGE_STRING_RECORDS = `SELECT * FROM "COALESCE_SAMPLE_DATABASE"."TEST_SUITE_DATA"."LARGE_STRING_RECORDS" LIMIT 100`;
/**
 * runs a series of CREATE IF NOT EXISTS queries to ensure a standard large table exists to test against
 */
const RunCreateLargeStringRecords = (orgID, idToken) => {
    const userContext = (0, exports.CreateUserContext)(orgID);
    return (0, exports.RunTestTemplate)(userContext, exports.CREATE_COALESCE_SAMPLE_DATABASE_TEMPLATE, idToken)
        .then(() => {
        return (0, exports.RunTestTemplate)(userContext, exports.CREATE_TEST_SUITE_DATA_SCHEMA, idToken);
    })
        .then(() => {
        return (0, exports.RunTestTemplate)(userContext, exports.CREATE_LARGE_STRING_RECORDS_TABLE, idToken);
    })
        .catch(error => {
        L.error("Error creating LARGE_STRING_RECORDS: ", error);
    });
};
exports.RunCreateLargeStringRecords = RunCreateLargeStringRecords;
/**
 * @param templateString an already rendered template string
 * @returns
 */
const RunTestTemplate = (userContext, templateString, token) => {
    const templateParams = {
        userContext,
        templateString,
        // assumes that there isn't any jinja to render
        nodeMetadata: {},
        macrosString: ""
    };
    return RunnerOperations.RunAnyTemplateWithScheduler(templateParams, token);
};
exports.RunTestTemplate = RunTestTemplate;
/**
 * a dictionary of test orgs for use in testing. naming convention subject to change,
 * but for now they should follow this format:
 *
 * (RELEASE_VERSION)_(SUBTYPE)
 *
 * the subtype intending to indicate whether or not there's anything unique about the org i.e.
 * the org being brand new, or with a large graph, etc.
 *
 * if there is nothing unique to the org, just leave the subtype blank
 */
exports.TEST_ORG_IDS = {
    k2: "fnqUBiI3ikjsBJWkl8G8"
};
const CreateTestReduxStore = (userCredentials, teamInfo, workspaceID, firestore) => {
    let store;
    return Workspaces.getAllWorkspaceDataFromFirebase(firestore, teamInfo.fbTeamID, workspaceID)
        .then(workspaceData => {
        store = Runs.createReduxStore({}, workspaceData, userCredentials, teamInfo, workspaceID, null);
        return Workspaces.GetWorkspacesAdmin(firestore, teamInfo.fbTeamID);
    }).then(workspaces => {
        const userConnection = (0, exports.FormatUserConnection)(teamInfo.fbUserID);
        workspaces.forEach((workspace) => {
            /**
             * in order to have all the state available that we normally would, we need to dispatch
             * all workspaces and userConnections here. getAllWorkspaceDataFromFirebase only returns
             * the data needed for a deploy
             */
            store.dispatch(State.getCreateWorkspace(workspace.id, workspace));
            store.dispatch({
                type: State.getCreateEntityActionString(State.DocRefs.users),
                id: teamInfo.fbUserID,
                environmentID: workspace.id,
                value: userConnection
            });
        });
        const mappingCollection = StorageMap.getMappingCollectionRef(teamInfo.fbTeamID);
        return mappingCollection.get();
    }).then(mappingSnapshot => {
        mappingSnapshot.docs.forEach(mapping => {
            store.dispatch(State.getCreateMapping(mapping.id, mapping.data()));
        });
        return store;
    })
        .catch(error => {
        // get workspace data error
        throw error;
    });
};
exports.CreateTestReduxStore = CreateTestReduxStore;
const FormatTeamInfoFromEnvironmentInfo = (environmentInfo) => {
    return {
        fbTeamID: environmentInfo.orgID,
        fbEmail: environmentInfo.createdUserEmail,
        fbFullName: "First Last",
        fbOrg: "",
        fbRole: "",
        fbUserID: environmentInfo.createdUserID
    };
};
exports.FormatTeamInfoFromEnvironmentInfo = FormatTeamInfoFromEnvironmentInfo;
const InitializeTestEnvironmentWithStore = () => {
    // create new environment
    return (0, exports.createNewTestEnvironment)(null).then((environmentInfoResult) => {
        L.info("Created environment", environmentInfoResult);
        const environmentInfo = environmentInfoResult;
        const testOrgID = environmentInfo.orgID;
        const testUserID = environmentInfo.createdUserID;
        const testUserEmail = environmentInfo.createdUserEmail;
        // sign into firebase with our newly created user
        L.info("Scheduler started");
        return Firebase.getFirebaseAuth().signInWithEmailAndPassword(testUserEmail, "password")
            .then(user => {
            L.info("User successfully logged in");
            return (0, exports.copyFirebaseOrgWithFreshWorkspace)(exports.TEST_ORG_IDS.k2, testOrgID, testUserID, [StandardOrgCollections.workspaces, StandardOrgCollections.mappings]);
        }).then(() => {
            L.info("Org data successfully copied");
            const snowflakeCredentials = {
                snowflakeUsername: exports.CommonTestCredentials.username,
                snowflakePassword: exports.CommonTestCredentials.password,
                snowflakeAccount: exports.CommonTestCredentials.snowflakeAccount
            };
            const teamInfo = (0, exports.FormatTeamInfoFromEnvironmentInfo)(environmentInfo);
            // create our store from our copied data in the new org
            return (0, exports.CreateTestReduxStore)(snowflakeCredentials, teamInfo, 1, Firebase.getFirestore());
        }).then(store => {
            L.info("Redux store created");
            return { store, environmentInfo };
        }).catch(error => {
            L.error("Error during test setup (InitializeTestEnvironmentWithStore)", error);
            // error thrown to stop the test if this fails
            throw error;
        });
    });
};
exports.InitializeTestEnvironmentWithStore = InitializeTestEnvironmentWithStore;
const InvalidateEnvironmentOAuthInfo = (orgID, environmentID) => {
    return new Promise((resolve, reject) => {
        //get environment docs
        const envDocRef = Workspaces.GetEnvironmentDocRef(admin.firestore(), orgID, environmentID);
        //snag old value for the undo func and add to return object
        return envDocRef.get()
            .then((doc) => {
            if (doc.exists) {
                const data = doc.data();
                const clientID = data === null || data === void 0 ? void 0 : data.oauthClientID;
                const changeDataPromise = () => envDocRef.set({ oauthClientID: "" }, { merge: true });
                const undoDataPromise = () => envDocRef.set({ oauthClientID: clientID }, { merge: true });
                resolve({
                    promiseCallback: changeDataPromise,
                    undoPromiseCallback: undoDataPromise
                });
            }
            else {
                throw new Error("Environment doc didn't exist");
            }
        }).catch(error => {
            throw new Error("Error during TestUtil InvalidateEnvironmentOAuthInfo " + error);
        }).catch(error => {
            reject(error);
        });
    });
};
exports.InvalidateEnvironmentOAuthInfo = InvalidateEnvironmentOAuthInfo;
const GenerateUserConnection = (connectionType, connectionDetails) => {
    return {
        connectionType,
        connectionDetails
    };
};
exports.GenerateUserConnection = GenerateUserConnection;
const initCli = () => {
    return new Promise((resolve, reject) => {
        Common.executeCommand("yarn install --cwd shared/ && cd cli && yarn install && yarn run build && chmod a+rwx bin/index.js")
            .then((log) => {
            return resolve(log);
        })
            .catch(reject);
    });
};
exports.initCli = initCli;
const runCoa = (args) => {
    return Common.executeCommand(`cd cli && export RUNTIME_ENVIRONMENT=development && yarn install && tsc && bin/index.js ${args}`);
};
exports.runCoa = runCoa;
// Mock testing data
// shape of data returned from Shared.Snowflake.runListTables
exports.mockTableData = {
    COALESCE_SAMPLE_DATABASE: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        SRC1: [
            "CUSTOMERS_SRC1",
            "LINEITEM_SRC1",
            "ORDERS_SRC1"
        ],
        SRC2: [
            "CUSTOMERS_SRC2",
            "LINEITEM_SRC2",
            "ORDERS_SRC2"
        ],
        SRC3: [
            "CUSTOMERS_SRC3",
            "LINEITEM_SRC3",
            "ORDERS_SRC3"
        ],
        TEST_SUITE_DATA: [
            "BASIC_JSON_EXAMPLE",
            "LARGE_STRING_RECORDS",
            "LARGE_VARIANT_RECORDS"
        ],
        TPCH_SF001: [
            "CUSTOMER",
            "LINEITEM",
            "NATION",
            "ORDERS",
            "PART",
            "PARTSUPP",
            "REGION",
            "SUPPLIER"
        ]
    },
    DEMO_DB: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        PUBLIC: [
            "DIM_CUSTOMER",
            "DIM_NATION",
            "DIM_REGION",
            "FCT_REGION",
            "MONTHLY_SALES",
            "PSTG_NATION",
            "STGGG_MONTHLY_SALES",
            "STG_CUSTOMERsfsdfsfs",
            "STG_JLINEITEM",
            "STG_LINEITEM",
            "STG_NATION",
            "мой_стол"
        ]
    },
    HH_DB: {
        HH_SCHEMA: [
            "DIM_LINEITEM_PART",
            "DIM_SUPPLIER",
            "PSTG_REGION",
            "STG_CUSTOMER",
            "STG_CUSTOMER_PART",
            "STG_JCUSTOMER",
            "STG_JCUSTOMER1",
            "STG_LINEITEM_PART",
            "STG_NATION",
            "STG_SUPPLIER"
        ],
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ]
    },
    KYLE_EDW: {
        DW: [
            "STG_ORDERS_VIEW"
        ],
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        PROD_DW: [
            "DIM_CUSTOMER",
            "STG_CUSTOMER",
            "STG_LINEITEM_ORDERS",
            "STG_LINEITEM_ORDERS_CUSTOMER",
            "STG_ORDERS_TEST",
            "STG_ORDERS_VIEW",
            "STG_REGION",
            "STG_SUPPLIER"
        ],
        PUBLIC: [
            "STG_LARGE_RECORDS_DATA"
        ],
        QA_STG: [
            "STG_JCUSTOMER",
            "STG_SUPPLIER",
            "STG_SUPPLIER1",
            "VIEW_JCUSTOMER"
        ],
        STG: [
            "DIM_CUSTOMER",
            "STG_CUSTOMER",
            "STG_JCUSTOMER",
            "STG_LINEITEM_ORDERS",
            "STG_LINEITEM_ORDERS_CUSTOMER",
            "STG_NATION",
            "STG_ORDERS_TEST",
            "STG_ORDERS_TEST1",
            "STG_PART",
            "STG_REGION",
            "STG_SUPPLIER",
            "STG_SUPPLIER1",
            "VIEW_JCUSTOMER"
        ]
    },
    NICK_EDW: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        STG_DEV: [
            "STG_NATION"
        ]
    },
    PEN_TESTING_ORG1: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ]
    },
    PEN_TESTING_ORG2: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ]
    },
    QA_DB: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        PUBLIC: [
            "DIM_CUSTOMER",
            "DIM_NODE",
            "NEW_NATION",
            "STG_CUSTOMER_ORDERS",
            "STG_JNATION",
            "STG_LINEITEM",
            "STG_ORDERS",
            "STG_PART",
            "STG_REGION_SUPPLIER",
            "STG_SUPPLIER",
            "STG_SUPPLIER_NATION"
        ]
    },
    SCOTT_DB: {
        DW: [
            "STG_ORDERS_VIEW"
        ],
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        PROD_DW: [
            "DIM_CUSTOMER",
            "STG_CUSTOMER",
            "STG_LINEITEM_ORDERS",
            "STG_LINEITEM_ORDERS_CUSTOMER",
            "STG_ORDERS_TEST",
            "STG_ORDERS_VIEW",
            "STG_REGION",
            "STG_SUPPLIER"
        ],
        QA_DW: [
            "STG_ORDERS_VIEW"
        ],
        QA_STG: [
            "DIM_CUSTOMER",
            "STG_CUSTOMER",
            "STG_LINEITEM_ORDERS",
            "STG_LINEITEM_ORDERS_CUSTOMER",
            "STG_NATION",
            "STG_ORDERS_TEST",
            "STG_REGION",
            "STG_REGION1",
            "STG_SUPPLIER"
        ],
        STG: [
            "DIM_CUSTOMER",
            "STG_CUSTOMER",
            "STG_LINEITEM_ORDERS",
            "STG_LINEITEM_ORDERS_CUSTOMER",
            "STG_NATION",
            "STG_ORDERS_TEST",
            "STG_REGION",
            "STG_SUPPLIER"
        ]
    },
    SNOWFLAKE_SAMPLE_DATA: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        TPCDS_SF100TCL: [
            "CALL_CENTER",
            "CATALOG_PAGE",
            "CATALOG_RETURNS",
            "CATALOG_SALES",
            "CUSTOMER",
            "CUSTOMER_ADDRESS",
            "CUSTOMER_DEMOGRAPHICS",
            "DATE_DIM",
            "HOUSEHOLD_DEMOGRAPHICS",
            "INCOME_BAND",
            "INVENTORY",
            "ITEM",
            "PROMOTION",
            "REASON",
            "SHIP_MODE",
            "STORE",
            "STORE_RETURNS",
            "STORE_SALES",
            "TIME_DIM",
            "WAREHOUSE",
            "WEB_PAGE",
            "WEB_RETURNS",
            "WEB_SALES",
            "WEB_SITE"
        ],
        TPCDS_SF10TCL: [
            "CALL_CENTER",
            "CATALOG_PAGE",
            "CATALOG_RETURNS",
            "CATALOG_SALES",
            "CUSTOMER",
            "CUSTOMER_ADDRESS",
            "CUSTOMER_DEMOGRAPHICS",
            "DATE_DIM",
            "DBGEN_VERSION",
            "HOUSEHOLD_DEMOGRAPHICS",
            "INCOME_BAND",
            "INVENTORY",
            "ITEM",
            "PROMOTION",
            "REASON",
            "SHIP_MODE",
            "STORE",
            "STORE_RETURNS",
            "STORE_SALES",
            "TIME_DIM",
            "WAREHOUSE",
            "WEB_PAGE",
            "WEB_RETURNS",
            "WEB_SALES",
            "WEB_SITE"
        ],
        TPCH_SF1: [
            "CUSTOMER",
            "LINEITEM",
            "NATION",
            "ORDERS",
            "PART",
            "PARTSUPP",
            "REGION",
            "SUPPLIER"
        ],
        TPCH_SF10: [
            "CUSTOMER",
            "LINEITEM",
            "NATION",
            "ORDERS",
            "PART",
            "PARTSUPP",
            "REGION",
            "SUPPLIER"
        ],
        TPCH_SF100: [
            "CUSTOMER",
            "LINEITEM",
            "NATION",
            "ORDERS",
            "PART",
            "PARTSUPP",
            "REGION",
            "SUPPLIER"
        ],
        TPCH_SF1000: [
            "CUSTOMER",
            "LINEITEM",
            "NATION",
            "ORDERS",
            "PART",
            "PARTSUPP",
            "REGION",
            "SUPPLIER"
        ],
        WEATHER: [
            "DAILY_14_TOTAL",
            "DAILY_16_TOTAL",
            "HOURLY_14_TOTAL",
            "HOURLY_16_TOTAL",
            "WEATHER_14_TOTAL"
        ]
    },
    TEST_SUITE_DEV: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ],
        STG_DEV: [
            "PSQL_NATION",
            "STG_LINEITEM"
        ]
    },
    TEST_SUITE_PROD: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ]
    },
    TEST_SUITE_QA: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ]
    },
    UTIL_DB: {
        INFORMATION_SCHEMA: [
            "APPLICABLE_ROLES",
            "COLUMNS",
            "DATABASES",
            "ENABLED_ROLES",
            "EXTERNAL_TABLES",
            "FILE_FORMATS",
            "FUNCTIONS",
            "INFORMATION_SCHEMA_CATALOG_NAME",
            "LOAD_HISTORY",
            "OBJECT_PRIVILEGES",
            "PIPES",
            "PROCEDURES",
            "REFERENTIAL_CONSTRAINTS",
            "REPLICATION_DATABASES",
            "SCHEMATA",
            "SEQUENCES",
            "STAGES",
            "TABLES",
            "TABLE_CONSTRAINTS",
            "TABLE_PRIVILEGES",
            "TABLE_STORAGE_METRICS",
            "USAGE_PRIVILEGES",
            "VIEWS"
        ]
    }
};
const GetMockSQLOperation = () => {
    return new Runner.SQLOperation();
};
exports.GetMockSQLOperation = GetMockSQLOperation;
/**
 * currently hardcoded to return the spec for a textbox - currently this is all we need
 * for our tests
 *
 * @param isRequired allows you to specify whether or not the config item is required
 * @returns a valid config item spec
 */
const GetMockConfigItemSpec = (isRequired) => {
    return {
        type: Templates.SpecUIType.textBox,
        attributeName: "testTextBoxAttribute",
        displayName: "Test Text Box Attribute",
        isRequired
    };
};
exports.GetMockConfigItemSpec = GetMockConfigItemSpec;
const LogIntoUserWithCreds = (email, password) => {
    return Firebase.getFirebaseAuth().signInWithEmailAndPassword(email, password);
};
exports.LogIntoUserWithCreds = LogIntoUserWithCreds;
/**
 * logs in the generic test user according to createEnvironment, might want to make sure the password is still correct when using?
 */
const LogIntoTestUser = (email) => {
    return (0, exports.LogIntoUserWithCreds)(email, "password");
};
exports.LogIntoTestUser = LogIntoTestUser;
/**
 * deletes the document from firestore for the given UID
 */
const DeleteFirestoreDoc = (uid) => {
    return CommonOperations.getUserDocRefAdmin(Firebase.justFirebase.firestore(), uid).delete();
};
exports.DeleteFirestoreDoc = DeleteFirestoreDoc;
const GetCurrentUserFirebase = () => {
    return Firebase.getFirebaseAuth().currentUser;
};
exports.GetCurrentUserFirebase = GetCurrentUserFirebase;
/**
 * deletes the currently logged in user from firebase authentication
 */
const DeleteCurrentUserFirebase = () => {
    return Firebase.getFirebaseAuth().currentUser.delete();
};
exports.DeleteCurrentUserFirebase = DeleteCurrentUserFirebase;
const MockColumnsWithOldHashMetadata = () => {
    const nonHashColumns = new Array(3).fill(null).map((val, index) => {
        return {
            name: `FAKE_COLUMN_${index}`,
            nullable: true,
            dataType: CommonOperations.EDataType.TEXT,
            columnReference: { stepCounter: "1", columnCounter: index + 1 },
            description: "",
        };
    });
    const hashColumns = new Array(3).fill(null).map((val, index) => {
        return {
            name: `FAKE_HASH_COLUMN_${index}`,
            nullable: false,
            dataType: "STRING",
            columnReference: { stepCounter: "1", columnCounter: index + 4 },
            description: "",
            hashDetails: {
                // hashType isn't used in updating metadata, so just fill it with generic
                hashType: Runner.EHashType.generic,
                hubHashes: [],
                hashAlgorithm: Runner.EHashAlgorithms.sha1
            }
        };
    });
    // generate some old metadata in different forms for the non-hash columns
    nonHashColumns[0].hashColumns = [
        { stepCounter: "1", columnCounter: 4 }
    ];
    nonHashColumns[1].hashDetails = null;
    nonHashColumns[1].hashColumns = [];
    nonHashColumns[2].hashColumns = [
        { stepCounter: "1", columnCounter: 4 },
        { stepCounter: "1", columnCounter: 5 }
    ];
    nonHashColumns[2].hashDetails = null;
    // generate some old metadata in different forms for hash columns
    hashColumns[0].hashColumns = [];
    hashColumns[2].hashDetails.hubHashes = [
        { stepCounter: "1", columnCounter: 4 },
        { stepCounter: "1", columnCounter: 5 }
    ];
    return [...nonHashColumns, ...hashColumns];
};
exports.MockColumnsWithOldHashMetadata = MockColumnsWithOldHashMetadata;
const GetNewTestEmail = () => {
    return `heehousertest${Date.now()}${randomstring.generate({ length: 10, charset: "alphanumeric" })}@test.com`;
};
exports.GetNewTestEmail = GetNewTestEmail;
//# sourceMappingURL=TestUtil.js.map