"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResolveTest = exports.RejectTest = exports.CheckForExpectedErrorCode = exports.ChangeEnvironmentHealthStatus = exports.schedulerPost = exports.FirebaseLogin = exports.ConfigureWorkspaceWithParams = exports.LogInAndAuthenticateWithOAuth = exports.GetAuthCode = exports.useSimpleStateAccessor = exports.MakeRegistrationRequestWithInvalidPassword = exports.GetRegistrationDataWithInvalidPassword = exports.WaitUntilWorkspaceIsReadyAndNotFailed = exports.FullSnowflakeDeployTest = exports.SnowflakeDeployTestVerifyCbs = exports.getTableQueryResults = exports.SnowflakeDeployTestModifyCbs = exports.GetEditedTestColumnName = exports.GetAddedTestColumnName = exports.GetEditedTestTableName = exports.GetAddedTestTableName = exports.DeployTestType = exports.copyFirebaseOrgWithFreshWorkspace = exports.deleteTestEnvironment = exports.createNewTestEnvironment = exports.BasicAuthTestContextObject = exports.CommonTestCredentials = exports.adminFirebase = void 0;
const CommonOperations = __importStar(require("./CommonOperations"));
const Common = __importStar(require("./Common"));
const Firebase = __importStar(require("./Firebase"));
const TeamOperations = __importStar(require("./TeamOperations"));
const Logging = __importStar(require("./Logging"));
const Workspaces = __importStar(require("./Workspaces"));
const Templates = __importStar(require("./Templates"));
const RunnerOperations = __importStar(require("./RunnerOperations"));
const Runner = __importStar(require("./Runner"));
const MacroOperations = __importStar(require("./MacroOperations"));
const ConnectionOperations = __importStar(require("./ConnectionOperations"));
const StepTypes = __importStar(require("./StepTypes"));
const Axios = __importStar(require("axios"));
const react_redux_1 = require("react-redux");
const immer = __importStar(require("immer"));
const qs = require("qs");
/*
 * let admin;
 * if (process.env.NODE_ENV === "test")
 */
const admin = require("firebase-admin");
exports.adminFirebase = admin;
const L = Logging.GetLogger(Logging.LoggingArea.Testing);
exports.CommonTestCredentials = {
    snowflakeAccount: "ww56326.us-central1.gcp",
    username: "mx2323",
    password: "ThisIsAPassword1!"
};
exports.BasicAuthTestContextObject = {
    user: exports.CommonTestCredentials.username,
    password: exports.CommonTestCredentials.password,
    accountName: exports.CommonTestCredentials.snowflakeAccount,
    role: "",
    warehouse: "",
    orgID: "1",
    environmentID: 6,
    database: "",
    destinationSchema: ""
};
exports.createNewTestEnvironment = () => {
    // (window as any).ENVIRONMENT = "development"
    process.env.RUNTIME_ENVIRONMENT = "development";
    if (!admin.apps.length) {
        admin.initializeApp({
            credential: admin.credential.applicationDefault(),
        });
    }
    Firebase.initializeFirebase();
    L.debug("initialized firebase");
    return new Promise((resolve, reject) => {
        const dateString = Date.now().toString();
        let environmentInfo;
        const userEmail = `test${dateString}@fake.com`;
        const userID = `name-${dateString}`;
        let newOrgResult;
        L.debug("creating org");
        return TeamOperations.CreateOrgAdmin(admin.firestore(), { orgName: `testOrg - ${dateString}` })
            .then((result) => {
            newOrgResult = result;
            L.debug("Created org");
            return admin.auth().createUser({ uid: userID, email: userEmail, password: "password" });
        }).then(() => {
            environmentInfo = {
                createdUserEmail: userEmail,
                createdUserID: userID,
                orgID: newOrgResult.orgID,
                orgName: newOrgResult.orgName
            };
            L.debug("Created environment", environmentInfo);
            return TeamOperations.createOrUpdateSuperUserAdmin(admin.firestore(), `name-${dateString}`, newOrgResult.orgID, userEmail, "first name", "last name");
        }).then((userValue) => {
            L.debug("Added user");
            // set any values you want your default dev environment to contain here
            const defaultWorkspaceConfig = {
                connectionAccount: exports.CommonTestCredentials.snowflakeAccount,
                oauthClientID: "z6cAxBLn2/ouwO3+83G08xu/Eog=",
                oauthClientSecret: "ejG2QVO77HReCa2OY8oGhvV17jucylFqNhibze4aI+Y="
            };
            return exports.ConfigureWorkspaceWithParams(environmentInfo.orgID, "1", defaultWorkspaceConfig);
        }).then(() => {
            resolve(environmentInfo);
        })
            .catch(error => {
            reject(error);
        });
    });
};
exports.deleteTestEnvironment = (environmentInfo) => {
    console.log("deleting environment", environmentInfo);
    L.debug("deleting test environment!");
    return new Promise((resolve, reject) => {
        return TeamOperations.DeleteOrgAdmin(admin.firestore(), environmentInfo.orgID)
            .then(() => {
            return TeamOperations.deleteUserAdmin(admin.firestore(), environmentInfo.createdUserID);
        }).then(() => {
            return admin.auth().deleteUser(environmentInfo.createdUserID);
        }).then(() => {
            L.debug("terminating connections");
            Firebase.getFirestore().terminate();
            resolve();
        }).catch(err => reject(err));
    });
};
/**
 * Function copies all data from one doc to another. Paths that don't exist will be created, paths that do exist are overwritten.
 * Writes to firebase are batched in groups of 450. Large docs may only partly succeed if they contain more than 450 docs within them.
 * Can specify which collections to be skipped in copying to save time/resources if not needed.
 * @param firestore firestore used to get doc refs passed in
 * @param fromDocRef doc ref that data will be copied from
 * @param toDocRef doc ref that data will be pasted to
 * @param collectionsToSkip any collections with names matching (full match, no partial) the strings passed in here will not be copied over; not path-dependent,
 * collections with these names at any level will be skipped
 */
const copyFirebaseDoc = (firestore, fromDocRef, toDocRef, collectionsToSkip) => {
    return TeamOperations.RecursivelyBatchFirebaseDocs(firestore, collectionsToSkip, fromDocRef, TeamOperations.FirebaseBatchOperations.set, toDocRef);
};
exports.copyFirebaseOrgWithFreshWorkspace = (fromOrgID, toOrgID, createdByUserID) => {
    const firestore = admin.firestore();
    const fromOrg = CommonOperations.getOrgDataDocRefAdmin(firestore, fromOrgID);
    const toOrg = CommonOperations.getOrgDataDocRefAdmin(firestore, toOrgID);
    let newWorkspaceID;
    return copyFirebaseDoc(firestore, fromOrg, toOrg, ["runs"]).then(() => {
        return Workspaces.AddWorkspaceAdmin(firestore, toOrgID, "Test", createdByUserID)
            .then(workspaceID => {
            newWorkspaceID = workspaceID;
            return Workspaces.UpdateWorkspaceAdmin(firestore, toOrgID, newWorkspaceID, { connectionAccount: exports.BasicAuthTestContextObject.accountName });
        })
            .then(() => {
            //create basic auth user using basicAuthTestContextObject info
            return CommonOperations.getDocumentRefAdmin(firestore, toOrgID, newWorkspaceID, CommonOperations.DocRefs.users).doc(createdByUserID).set({
                connectionType: CommonOperations.EUserConnectionTypes.basic,
                user: exports.BasicAuthTestContextObject.user,
                userID: createdByUserID,
                role: exports.BasicAuthTestContextObject.role,
                warehouse: exports.BasicAuthTestContextObject.warehouse
            });
        })
            .then(() => newWorkspaceID);
    });
};
var DeployTestType;
(function (DeployTestType) {
    DeployTestType["addTable"] = "addTable";
    DeployTestType["addView"] = "addView";
    DeployTestType["editTable"] = "editTable";
    DeployTestType["editView"] = "editView";
    DeployTestType["deleteTable"] = "deleteTable";
    DeployTestType["deleteView"] = "deleteView";
    DeployTestType["addColumn"] = "addColumn";
    DeployTestType["editColumn"] = "editColumn";
    DeployTestType["deleteColumn"] = "deleteColumn";
    DeployTestType["failAddTable"] = "failAddTable";
})(DeployTestType = exports.DeployTestType || (exports.DeployTestType = {}));
exports.GetAddedTestTableName = (stepCounter) => {
    return `ADDED_STEP_${stepCounter}-TEST`;
};
exports.GetEditedTestTableName = (stepCounter) => {
    return `${exports.GetAddedTestTableName(stepCounter)}_EDIT-TEST`;
};
exports.GetAddedTestColumnName = (columnCounter) => {
    return `ADDED_COLUMN_${columnCounter}-TEST`;
};
exports.GetEditedTestColumnName = (columnCounter) => {
    return `${exports.GetAddedTestColumnName(columnCounter)}_EDIT-TEST`;
};
// collection of functions to create modified mock data for FullSnowflakeDeployTest
exports.SnowflakeDeployTestModifyCbs = (testType) => {
    switch (testType) {
        case DeployTestType.addTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                const nonSourceStepCounters = Object.keys(startData.steps).filter(stepCounter => startData.steps[stepCounter].operation.sqlType !== "Source");
                L.info(`nonSourceStepCounters: ${nonSourceStepCounters.join(", ")}`);
                return new Promise((resolveAddTable, rejectAddTable) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "stepCounter").then((stepCounter) => {
                        L.info("new step counter", stepCounter);
                        /*
                         * just copying data from the first non-source node for operation. shouldn't affect the test, if it does, we'll need a big refactor of
                         * creating steps funcs
                         */
                        const stepToCopy = startData.steps[nonSourceStepCounters[0]];
                        const newName = exports.GetAddedTestTableName(stepCounter);
                        L.info("step to copy", stepToCopy);
                        const newData = immer.produce(startData, draftState => {
                            draftState.steps[stepCounter] = Object.assign(Object.assign({}, stepToCopy), { stepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName }), name: newName });
                        });
                        L.info("new data", newData);
                        resolveAddTable([newData, [stepCounter], []]);
                    }).catch(err => {
                        L.error(`Error creating data for add table; Error:`, err);
                        rejectAddTable(err);
                    });
                });
            };
        case DeployTestType.addView:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                const nonSourceStepCounters = Object.keys(startData.steps).filter(stepCounter => startData.steps[stepCounter].operation.sqlType !== "Source");
                L.info(`nonSourceStepCounters: ${nonSourceStepCounters.join(", ")}`);
                return new Promise((resolveAddTable, rejectAddTable) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "stepCounter").then((stepCounter) => {
                        /*
                         * just copying data from the first non-source node for operation. shouldn't affect the test, if it does, we'll need a big refactor of
                         * creating steps funcs
                         */
                        const stepToCopy = startData.steps[nonSourceStepCounters[0]];
                        const newName = exports.GetAddedTestTableName(stepCounter);
                        L.info("step to copy", stepToCopy);
                        const newData = immer.produce(startData, draftState => {
                            draftState.steps[stepCounter] = Object.assign(Object.assign({}, stepToCopy), { stepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName, materializationType: "view" }), name: newName });
                        });
                        resolveAddTable([newData, [stepCounter], []]);
                    }).catch(err => {
                        L.error(`Error creating data for add table; Error:`, err);
                        rejectAddTable(err);
                    });
                });
            };
        case DeployTestType.editView:
        case DeployTestType.editTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveEditTable, rejectEditTable) => {
                    const newData = immer.produce(startData, draftState => {
                        const tableToEdit = draftState.steps[stepCountersToModify[0]];
                        tableToEdit.name = exports.GetEditedTestTableName(stepCountersToModify[0]);
                        tableToEdit.operation.name = exports.GetEditedTestTableName(stepCountersToModify[0]);
                    });
                    resolveEditTable([newData, [], []]);
                });
            };
        case DeployTestType.deleteView:
        case DeployTestType.deleteTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveDeleteTable, rejectDeleteTable) => {
                    const newData = immer.produce(startData, draftState => {
                        delete draftState.steps[stepCountersToModify[0]];
                    });
                    resolveDeleteTable([newData, [], []]);
                });
            };
        case DeployTestType.addColumn:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveAddColumn, rejectAddColumn) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "columnCounter").then((columnCounter) => {
                        const newColumnName = exports.GetAddedTestColumnName(columnCounter);
                        const newData = immer.produce(startData, draftState => {
                            const columnToCopy = draftState.steps[stepCountersToModify[0]].operation.metadata.columns[0];
                            draftState.steps[stepCountersToModify[0]].operation.metadata.columns[columnCounter] = Object.assign(Object.assign({}, columnToCopy), { name: newColumnName });
                        });
                        resolveAddColumn([newData, [], [columnCounter]]);
                    });
                });
            };
        case DeployTestType.editColumn:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveEditColumn, rejectEditColumn) => {
                    const newColumnName = exports.GetEditedTestColumnName(columnCountersToModify[0]);
                    const newData = immer.produce(startData, draftState => {
                        const columnToEdit = draftState.steps[stepCountersToModify[0]].operation.metadata.columns[columnCountersToModify[0]];
                        columnToEdit.name = newColumnName;
                    });
                    resolveEditColumn([newData, [], []]);
                });
            };
        case DeployTestType.deleteColumn:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                return new Promise((resolveDeleteColumn, rejectDeleteColumn) => {
                    const newData = immer.produce(startData, draftState => {
                        delete draftState.steps[stepCountersToModify[0]].operation.metadata.columns[columnCountersToModify[0]];
                    });
                    resolveDeleteColumn([newData, [], []]);
                });
            };
        case DeployTestType.failAddTable:
            return (firestore, orgRef, startData, stepCountersToModify, columnCountersToModify) => {
                const nonSourceStepCounters = Object.keys(startData.steps).filter(stepCounter => startData.steps[stepCounter].operation.sqlType !== "Source");
                L.info(`nonSourceStepCounters: ${nonSourceStepCounters.join(", ")}`);
                return new Promise((resolveAddTable, rejectAddTable) => {
                    CommonOperations.getNextCounter(firestore, orgRef, "stepCounter", 2).then((stepCounter) => {
                        /*
                         * just copying data from the first non-source node for operation. shouldn't affect the test, if it does,
                         * we'll need a big refactor of creating steps funcs
                         */
                        let localStepCounter = stepCounter;
                        const stepToCopy = startData.steps[nonSourceStepCounters[0]];
                        const newName = exports.GetAddedTestTableName(stepCounter);
                        L.info("step to copy", stepToCopy);
                        const newData = immer.produce(startData, draftState => {
                            draftState.steps[stepCounter] = Object.assign(Object.assign({}, stepToCopy), { stepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName }), name: newName });
                        });
                        localStepCounter++;
                        const completeNewData = immer.produce(newData, draftState => {
                            draftState.steps[localStepCounter] = Object.assign(Object.assign({}, stepToCopy), { localStepCounter, operation: Object.assign(Object.assign({}, stepToCopy.operation), { name: newName + 2, locationID: 99, locationName: "FAKE" }), name: newName + 2 });
                        });
                        resolveAddTable([completeNewData, [stepCounter], []]);
                    }).catch(err => {
                        L.error(`Error creating data for add table; Error:`, err);
                        rejectAddTable(err);
                    });
                });
            };
        default:
            break;
    }
};
const getStepData = (startingData, stepCounter, workspaceID, orgRef, testType) => {
    return new Promise((resolve, reject) => {
        if (testType === DeployTestType.deleteTable || testType === DeployTestType.deleteView) {
            resolve(startingData.steps[stepCounter].operation);
        }
        else {
            orgRef.collection("workspaces").doc(workspaceID.toString()).collection("steps").doc(stepCounter.toString()).get().then((step) => {
                L.info("step in getStepData:", step.data());
                resolve(step.data());
            }).catch(err => {
                L.error(`Error getting stepData in verifyCb (deploy test); Error:`, err);
                reject(err);
            });
        }
    });
};
const getPhysicalLocations = (orgRef) => {
    return new Promise((resolve, reject) => {
        //hard-coded to be workspace 34 but might need a way to get automatically? or just pass in
        orgRef.collection("workspaces").doc("34").get().then(environment => {
            const envData = environment.data();
            resolve(envData.mappings);
        }).catch(err => {
            L.error(`Error getting mappings in verifyCb (deploy test); Error:${err.toString()}`);
            reject(err);
        });
    });
};
exports.getTableQueryResults = (startingData, stepCounter, workspaceID, orgRef, testType) => {
    const userContext = {
        user: exports.CommonTestCredentials.username,
        password: exports.CommonTestCredentials.password,
        accountName: exports.CommonTestCredentials.snowflakeAccount,
        database: "HH_DB",
        destinationSchema: "HH_SCHEMA",
        warehouse: "",
        role: "ACCOUNTADMIN",
        environmentID: workspaceID,
        orgID: orgRef.id
    };
    return new Promise((resolve, reject) => {
        Promise.all([getStepData(startingData, stepCounter, workspaceID, orgRef, testType), getPhysicalLocations(orgRef)])
            .then(result => {
            const [allStepData, physicalLocations] = result;
            const verifiablePromises = [];
            /*
             * RunDescTable throws error on non-existent table and since we're hoping the table doesn't exist, we can't use that.
             * For editTable test, RunDescTable doesn't return the name but will return the unedited table if it failed, making
             * us think it succeeded.
             */
            if (testType === DeployTestType.deleteTable || testType === DeployTestType.editTable) {
                let newStepData = allStepData;
                if (testType === DeployTestType.editTable && !newStepData.name.includes("_EDIT-TEST")) {
                    newStepData = immer.produce(allStepData, (draftState) => {
                        draftState.name = draftState.name + "_EDIT-TEST";
                    });
                }
                verifiablePromises.push(RunnerOperations.RunShowTables(physicalLocations, newStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            else if (testType === DeployTestType.deleteView || testType === DeployTestType.editView) {
                verifiablePromises.push(RunnerOperations.RunShowViews(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            else if (testType === DeployTestType.addView) {
                verifiablePromises.push(RunnerOperations.RunDescView(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            else if (testType === DeployTestType.failAddTable) {
                //the successful create
                verifiablePromises.push(RunnerOperations.RunDescTable(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
                //the failed create
                verifiablePromises.push(exports.WaitUntilWorkspaceIsReadyAndNotFailed(orgRef.id, workspaceID)
                    .then(() => {
                    console.log("Deploy verification succeeded, should have failed");
                    return {
                        data: {
                            columns: [],
                            rows: [0]
                        },
                        runDetails: {
                            compiledSQL: "",
                            exported_refs: [],
                            invalid_exported_refs: []
                        }
                    };
                })
                    .catch(error => {
                    console.error("Deploy verfication error: ", error);
                    return {
                        data: {
                            columns: [],
                            rows: [1]
                        },
                        runDetails: {
                            compiledSQL: "",
                            exported_refs: [],
                            invalid_exported_refs: []
                        }
                    };
                }).then(queryResult => queryResult));
            }
            else {
                verifiablePromises.push(RunnerOperations.RunDescTable(physicalLocations, allStepData, userContext, MacroOperations.refMacroDefinitions));
            }
            return Promise.all(verifiablePromises);
        }).then(templateRunResults => {
            const queryResults = templateRunResults.map(templateRunResult => {
                return RunnerOperations.GetQueryResultFromTemplateRunResult(templateRunResult, new Date());
            });
            resolve(queryResults);
        }).catch(err => {
            reject(err);
        });
    });
};
//collection of funcs to verify successful snowflake changes for deploy test (maybe incorporate into modifyCb func collection above?)
exports.SnowflakeDeployTestVerifyCbs = (testType) => {
    switch (testType) {
        case DeployTestType.addTable:
        case DeployTestType.addView:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        const success = queryResults.every(queryResult => !!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for added table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.editView:
        case DeployTestType.editTable:
            //this method currently assumes that firebase updated properly, as it uses the data from there to grab the name for RunDescTable
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        L.info("query results", queryResults);
                        //since the query is generated based on the new name, any row at all means success
                        const success = queryResults.every(queryResult => !!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for edited table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.deleteView:
        case DeployTestType.deleteTable:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        L.info("query results verify", queryResults);
                        const success = queryResults.every(queryResult => !!!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for deleted table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.addColumn:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then(queryResults => {
                        // queryResults is an array now, instead of a single queryResult, fix accordingly
                        const success = queryResults
                            .every(queryResult => !!queryResult.fields
                            .some(col => col.name === exports.GetAddedTestColumnName(columnCounters[0])));
                        resolve(success);
                        // resolve(queryResult.fields.some(col => col.name === GetAddedTestColumnName(columnCounter!)))
                    }).catch(err => {
                        L.error(`Error checking for added column in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.editColumn:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    // queryResults is an array now, instead of a single queryResult, fix accordingly
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then(queryResults => {
                        const success = queryResults.every(queryResult => {
                            return queryResult.fields.some(col => col.name === exports.GetEditedTestColumnName(columnCounters[0]));
                        });
                        resolve(success);
                        // resolve(queryResult.fields.some(col => col.name === GetEditedTestColumnName(columnCounter!)))
                    }).catch(err => {
                        L.error(`Error checking for edited column in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.deleteColumn:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then(queryResults => {
                        // queryResults is an array now, instead of a single queryResult, fix accordingly
                        const success = queryResults.every(queryResult => {
                            return queryResult.fields.some(col => col.name === exports.GetEditedTestColumnName(columnCounters[0]));
                        });
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for deleted column in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        case DeployTestType.failAddTable:
            return (orgRef, workspaceID, startingData, stepCounters, columnCounters) => {
                return new Promise((resolve, reject) => {
                    exports.getTableQueryResults(startingData, stepCounters[0], workspaceID, orgRef, testType).then((queryResults) => {
                        const success = queryResults.every(queryResult => !!queryResult.rows.length);
                        resolve(success);
                    }).catch(err => {
                        L.error(`Error checking for failed added table in deploy test; Error:`, err);
                        reject(err);
                    });
                });
            };
        default:
            break;
    }
};
/**
 * This test makes sure deploy is working for various changes in data. Making custom modifyCb and verifyCb leaves any option open for what data changes are tested as long as the changes could plausibly be effected from the app itself.
 * @param orgID id of org to be deployed to
 * @param fbUserID valid firebase user id to be used with deploy
 * @param workspaceID workspace to be deployed to
 * @param modifyCb callback can take any form as long as it can take in the starting data and return modified data in a form that might actually be generated by the app (i.e. that would be pulled from git in an actual deploy).
 * This can return multiple changes to the data just as working in the app could. If the callback adds a step or column, it should return the counters of any added in the resolve, otherwise should return empty arrays for those values
 * @param verifyCb verifyCb can take any form as long as it returns just a boolean indicating if the expected result was seen. getTableQueryResult is set up for this specifically (but doesn't have to be used,
 * and can be called within the callback iteratively on multiple stepCounters if necessary, then the aggregated results can be handled by the callback itself however is needed.
 * @param stepCountersToModify stepCounters to modify (and then verify with). Should only be an empty array if the modifyCb will add any table to be tested on. Passed in at this level so tables added or modified from previous tests
 * can then be passed in to ensure testing on same table if necessary.
 * @param columnCountersToModify columnCounters to modify and then verify with. Can be an empty array if the test doesn't involve any column-level changes
 * @returns an object containing the success boolean, and arrays of any stepCounters or columnCounters that were added/modified
 */
exports.FullSnowflakeDeployTest = (orgID, fbUserID, fromWorkspaceID, toWorkspaceID, modifyCb, verifyCb, stepCountersToModify, columnCountersToModify, additionalWorkspaceData) => {
    return new Promise((resolveTest, rejectTest) => {
        var _a;
        const firestore = admin.firestore();
        const orgRef = CommonOperations.getOrgDataDocRefAdmin(firestore, orgID);
        const fbToken = (_a = Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.refreshToken;
        const snowflakeUserCreds = {
            snowflakeAccount: exports.CommonTestCredentials.snowflakeAccount,
            snowflakePassword: exports.CommonTestCredentials.password,
            snowflakeUsername: exports.CommonTestCredentials.username,
        };
        let startingData;
        let stepCountersToUse;
        let columnCountersToUse;
        return Workspaces.getAllWorkspaceDataFromFirebase(firestore, orgID, fromWorkspaceID).then((workspaceData) => {
            startingData = workspaceData;
            if (!Object.keys(workspaceData.stepTypes).length) {
                //missing, so sub in default stepTypes
                startingData = immer.produce(workspaceData, draftState => {
                    draftState.stepTypes = StepTypes.getDefaultStepTypes();
                });
            }
            //adding new table/view needs fresh workspace, so ids shouldn't match; other tests should be using same workspace, we now also need to inject in the accountName information ugh :|
            if (fromWorkspaceID !== toWorkspaceID) {
                startingData = immer.produce(workspaceData, draftState => {
                    draftState.workspaces.workspaces[toWorkspaceID] = Object.assign({}, draftState.workspaces.workspaces[fromWorkspaceID]);
                });
            }
            if (additionalWorkspaceData !== null) {
                startingData = immer.produce(additionalWorkspaceData, draftState => {
                    draftState.workspaces.workspaces[toWorkspaceID] = Object.assign(Object.assign({}, draftState.workspaces.workspaces[34]), { id: toWorkspaceID });
                    draftState.steps = Object.assign({}, startingData.steps);
                });
            }
            return modifyCb(firestore, orgRef, startingData, stepCountersToModify, columnCountersToModify);
        })
            .then((newDataResult) => {
            const [newData, stepCounters, columnCounters] = newDataResult;
            stepCountersToUse = stepCounters.length ? stepCounters : stepCountersToModify; //stepCountersToUse must have at least one step counter at this point in order to use a verify callback
            columnCountersToUse = columnCounters.length ? columnCounters : columnCountersToModify; //columnCountersToUse can still be empty if test doesn't involve changes to columns
            if (fromWorkspaceID !== toWorkspaceID) {
                startingData = immer.produce(startingData, draftState => {
                    draftState.workspaces.workspaces = {};
                    draftState.steps = {};
                });
            }
            const [edits,] = Workspaces.getWorkspaceEdits(newData, startingData, toWorkspaceID, Templates.PlatformType.snowflake);
            L.info("new edits", edits);
            const reqBody = {
                runDetails: {
                    deployCommit: "test-no-commit",
                    deployCommitMessage: "test-message",
                    fromWorkspaceData: newData,
                    toWorkspaceID: toWorkspaceID,
                    dividedStepDataWithWorkspaceEdits: edits,
                    stepsInRun: Object.keys(edits.addedTable).length +
                        Object.keys(edits.alteredTable).length +
                        Object.keys(edits.deletedTable).length
                },
                userCredentials: snowflakeUserCreds,
                runType: Runner.ERunType.deploy,
                userID: fbUserID,
                runStatus: Runner.ERunStatus.waitingToRun,
                runHistory: [],
            };
            return RunnerOperations.RunPost(`${Common.START_RUN_URL}/scheduler/startDeploy?token=${fbToken}`, reqBody);
        }).then((result) => {
            if (result.data.error) {
                L.error(`Error with RunPost during test deploy; Error:`, result.data.error);
                throw new Error(result.data.error);
            }
            else {
                return new Promise((resolve, reject) => {
                    //There seems to be a delay between the Axios response and Snowflake actually updating, this is a band-aid to get around that
                    setTimeout(() => {
                        return verifyCb(orgRef, toWorkspaceID, startingData, stepCountersToUse, columnCountersToUse).then(success => {
                            resolve(success);
                        });
                    }, 15000);
                });
            }
        }).then((success) => {
            resolveTest({ success, stepCounters: stepCountersToUse, columnCounters: columnCountersToUse });
        }).catch((err) => {
            L.error(`Error while attempting to deploy (test); Error:`, err);
            rejectTest(err);
        });
    });
};
exports.WaitUntilWorkspaceIsReadyAndNotFailed = (orgID, workspaceID) => {
    const firestore = admin.firestore();
    return new Promise((resolve, reject) => {
        const orgsRef = CommonOperations.getOrgsCollectionAdmin(firestore);
        const checkStatus = () => {
            orgsRef.doc(orgID).collection("workspaces").doc(workspaceID.toString()).get().then(workspace => {
                const status = workspace.data().status;
                if (status === Runner.EWorkspaceHealth.waiting) {
                    resolve();
                }
                else if (status === Runner.EWorkspaceHealth.failedDeploy || status === Runner.EWorkspaceHealth.failedRefresh) {
                    reject("Workspace in failed state");
                }
                else {
                    setTimeout(() => {
                        checkStatus();
                    }, 1000);
                }
            }).catch(err => {
                L.error("Encountered error while waiting for workspace to be ready:", err);
                reject(err);
            });
        };
        checkStatus();
    });
};
exports.GetRegistrationDataWithInvalidPassword = (invalidPassword) => {
    const dateString = Date.now();
    return {
        newOrg: {
            orgName: "testCompany"
        },
        newUser: {
            firstName: "testFirst",
            lastName: "testLast",
            role: "User",
            currentTeam: "NoTeamID",
            email: `testEmail${dateString}@notreal.com`,
            password: invalidPassword
        }
    };
};
exports.MakeRegistrationRequestWithInvalidPassword = (invalidPassword) => {
    //RunPost does not return the error data we actually need for testing
    return Axios.default.post(`${Common.START_RUN_URL}/scheduler/registerTrialOrg`, exports.GetRegistrationDataWithInvalidPassword(invalidPassword));
};
exports.useSimpleStateAccessor = () => {
    const state = react_redux_1.useSelector(state => (state));
    return state;
};
exports.GetAuthCode = (username, password, oauthClientID) => {
    const puppeteer = require("puppeteer");
    return new Promise((resolve, reject) => {
        let p = null;
        puppeteer.launch({ headless: true,
            args: ["--no-sandbox"]
        }).then((browser) => {
            return browser.newPage().then((page) => {
                // client ID needs to have its special characters encoded to be valid in the URL
                const encodedClientID = encodeURIComponent(oauthClientID);
                p = page;
                return page.goto(`https://${exports.CommonTestCredentials.snowflakeAccount}.snowflakecomputing.com/oauth/authorize?response_type=code&redirect_uri=http%3A%2F%2Flocalhost%3A3000%2Foauthredirect&client_id=${encodedClientID}`, { waitUntil: "networkidle2" })
                    .then((page) => {
                    return p.waitFor(2000);
                }).then(() => {
                    return p.type("[name=username]", `${username}`);
                }).then(() => {
                    return p.type("#password-id-inputEl", `${password}`);
                })
                    .then((result) => {
                    return p.setRequestInterception(true);
                }).then(() => {
                    p.on("request", request => {
                        /*
                         * Capture any request that is a navigation requests that attempts to load a new document
                         * This will capture HTTP Status 301, 302, 303, 307, 308, HTML, and Javascript redirects
                         */
                        if (request.isNavigationRequest() && request.resourceType() === "document") {
                            const redirect = request.url();
                            const values = qs.parse(redirect.split("?")[1]);
                            resolve(values.code);
                        }
                        request.continue();
                    });
                    /*
                     *p.on('response', response => {
                     *	const status = response.status()
                     *	console.log("got response", response)
                     *	if ((status >= 300) && (status <= 399)) {
                     *	  console.log('Redirect from', response.url(), 'to', response.headers()['location'])
                     *	}
                     *  })
                     */
                    return Promise.all([p.waitForNavigation(),
                        p.click("#base-button-1024-btnEl")]);
                }).then(() => {
                    return browser.close();
                })
                    .catch((err) => {
                    reject(err);
                });
            });
        });
    });
};
/**
 *
 * @returns a firebase refresh token to use in further requests
 */
exports.LogInAndAuthenticateWithOAuth = (
// credentials for logging into coalesce
appUsername, appPassword, 
// credentials for current snowflake account
snowflakeUsername, snowflakePassword, 
// urls, id and secret for current security configuration
oauthClientID, oauthClientSecret, authURL, tokenURL) => {
    let firebaseRefreshToken;
    return new Promise((resolve, reject) => {
        return exports.FirebaseLogin(appUsername, appPassword).then(refreshToken => {
            firebaseRefreshToken = refreshToken;
            return exports.GetAuthCode(snowflakeUsername, snowflakePassword, oauthClientID);
        }).then(authCode => {
            return ConnectionOperations.SendOAuthAuthenticationRequestToScheduler(authCode, 1, oauthClientID, oauthClientSecret, authURL, tokenURL);
        }).then(response => {
            resolve(firebaseRefreshToken);
            return firebaseRefreshToken;
        }).catch(error => {
            console.error("got authenticate oauth error", error);
            reject(error);
        });
    });
};
/**
 *
 * @param workspaceParams a dictionary of attributes to set on the targeted workspace
 */
exports.ConfigureWorkspaceWithParams = (teamID, workspaceID, workspaceParams) => {
    return Workspaces.getWorkspacesCollectionRef(teamID).doc(workspaceID).set(workspaceParams, { merge: true });
};
/**
 * helper that signs in with email and password and then resolves
 * with the logged in user's refresh token
 */
exports.FirebaseLogin = (email, password) => {
    return Firebase.getFirebaseAuth().signInWithEmailAndPassword(email, password).then(() => {
        var _a;
        return (_a = Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.refreshToken;
    });
};
exports.schedulerPost = (endpoint, body) => {
    return Runner.RunPost(endpoint, body);
};
exports.ChangeEnvironmentHealthStatus = (teamID, environmentID, status) => {
    const environmentRef = Workspaces.getWorkspacesCollectionRefAdmin(exports.adminFirebase.firestore(), teamID).doc(environmentID.toString());
    return environmentRef.set({
        status: status
    }, { merge: true });
};
exports.CheckForExpectedErrorCode = (errCode, desiredCode) => {
    if (errCode === desiredCode) {
        console.log("Recieved expected error code", errCode);
        expect(true).toBeTruthy();
    }
    else {
        console.log("ERROR: recieved unexpected error code!");
        console.table({
            expected: desiredCode,
            recieved: errCode
        });
        expect(true).toBeFalsy();
    }
};
exports.RejectTest = (rejectMsg) => {
    console.log("Test failed: ", rejectMsg);
    expect(true).toBeFalsy();
};
exports.ResolveTest = (resolveMsg) => {
    console.log("Test passed!", resolveMsg);
    expect(true).toBeTruthy();
};
//# sourceMappingURL=TestUtil.test.js.map